##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of Harvest Day: An Amstrad CPC Game 
##  Copyright (C) 2018 Álvaro Molina García / José Manuel Ladrón de Guevara García, Daniel Saura Martínez
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##-------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic compression utilities                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate the generation of          ##
## compressed files and their inclusion in users' projects.               ##
############################################################################

## COMPRESSION EXAMPLE (Uncomment lines to use)
##

## First 3 calls to ADD2PACK add enemy, hero and background
## graphics (previously converted to binary data) into the 
## compressed group 'mygraphics'. After that, call to PACKZX7B
## compresses all the data and generates an array with the result
## that is placed in src/mygraphics.c & src/mygraphics.h, ready
## to be included and used by other modules.
##
#$(eval $(call ADD2PACK,mygraphics,gfx/enemy.bin))
#$(eval $(call ADD2PACK,mygraphics,gfx/hero.bin))
#$(eval $(call ADD2PACK,mygraphics,gfx/background.bin))
#$(eval $(call PACKZX7B,mygraphics,src/))

$(eval $(call ADD2PACK,map_pack,src/mapsBin/map.bin))
$(eval $(call PACKZX7B,map_pack,src/mapsBin/))
$(eval $(call ADD2PACK,map2_pack,src/mapsBin/map2.bin))
$(eval $(call PACKZX7B,map2_pack,src/mapsBin/))
$(eval $(call ADD2PACK,map3_pack,src/mapsBin/map3.bin))
$(eval $(call PACKZX7B,map3_pack,src/mapsBin/))
$(eval $(call ADD2PACK,map4_pack,src/mapsBin/map4.bin))
$(eval $(call PACKZX7B,map4_pack,src/mapsBin/))
$(eval $(call ADD2PACK,map5_pack,src/mapsBin/map5.bin))
$(eval $(call PACKZX7B,map5_pack,src/mapsBin/))
$(eval $(call ADD2PACK,map6_pack,src/mapsBin/map6.bin))
$(eval $(call PACKZX7B,map6_pack,src/mapsBin/))

$(eval $(call ADD2PACK,tile_pack,src/tilesz.bin))
$(eval $(call PACKZX7B,tile_pack,src/))

$(eval $(call ADD2PACK,level0,levels/level_data/level0.bin))
$(eval $(call PACKZX7B,level0,src/levelBin/))
$(eval $(call ADD2PACK,level1,levels/level_data/level1.bin))
$(eval $(call PACKZX7B,level1,src/levelBin/))
$(eval $(call ADD2PACK,level2,levels/level_data/level2.bin))
$(eval $(call PACKZX7B,level2,src/levelBin/))
$(eval $(call ADD2PACK,level3,levels/level_data/level3.bin))
$(eval $(call PACKZX7B,level3,src/levelBin/))
$(eval $(call ADD2PACK,level4,levels/level_data/level4.bin))
$(eval $(call PACKZX7B,level4,src/levelBin/))
$(eval $(call ADD2PACK,level5,levels/level_data/level5.bin))
$(eval $(call PACKZX7B,level5,src/levelBin/))
$(eval $(call ADD2PACK,level6,levels/level_data/level6.bin))
$(eval $(call PACKZX7B,level6,src/levelBin/))
$(eval $(call ADD2PACK,level7,levels/level_data/level7.bin))
$(eval $(call PACKZX7B,level7,src/levelBin/))
$(eval $(call ADD2PACK,level8,levels/level_data/level8.bin))
$(eval $(call PACKZX7B,level8,src/levelBin/))
$(eval $(call ADD2PACK,level9,levels/level_data/level9.bin))
$(eval $(call PACKZX7B,level9,src/levelBin/))
$(eval $(call ADD2PACK,level10,levels/level_data/level10.bin))
$(eval $(call PACKZX7B,level10,src/levelBin/))
$(eval $(call ADD2PACK,level11,levels/level_data/level11.bin))
$(eval $(call PACKZX7B,level11,src/levelBin/))
$(eval $(call ADD2PACK,level12,levels/level_data/level12.bin))
$(eval $(call PACKZX7B,level12,src/levelBin/))
$(eval $(call ADD2PACK,level13,levels/level_data/level13.bin))
$(eval $(call PACKZX7B,level13,src/levelBin/))
$(eval $(call ADD2PACK,level14,levels/level_data/level14.bin))
$(eval $(call PACKZX7B,level14,src/levelBin/))
$(eval $(call ADD2PACK,level15,levels/level_data/level15.bin))
$(eval $(call PACKZX7B,level15,src/levelBin/))
$(eval $(call ADD2PACK,level16,levels/level_data/level16.bin))
$(eval $(call PACKZX7B,level16,src/levelBin/))





#MENU'S TIME
$(eval $(call ADD2PACK,menuiniciopack, src/imagesmenus/menuinicio.bin))
$(eval $(call PACKZX7B,menuiniciopack,src/imagesmenus))

$(eval $(call ADD2PACK,menuwinpack, src/imagesmenus/YouWinMenu.bin))
$(eval $(call PACKZX7B,menuwinpack, src/imagesmenus))

$(eval $(call ADD2PACK,menudeathpack, src/imagesmenus/DeathMenu.bin))
$(eval $(call PACKZX7B,menudeathpack, src/imagesmenus))

$(eval $(call ADD2PACK,menupausepack, src/imagesmenus/PauseMenu.bin))
$(eval $(call PACKZX7B,menupausepack, src/imagesmenus))

$(eval $(call ADD2PACK,menunextlevelpack, src/imagesmenus/NextLevelMenu.bin))
$(eval $(call PACKZX7B,menunextlevelpack, src/imagesmenus))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macros used for compression are ADD2PACK and PACKZX7B:                 ##
##                                                                        ##
##	ADD2PACK: Adds files to packed (compressed) groups. Each call to this ##
##  		  macro will add a file to a named compressed group.          ##
##  PACKZX7B: Compresses all files in a group into a single binary and    ##
##            generates a C-array and a header to comfortably use it from ##
##            inside your code.                                           ##
##                                                                        ##
##------------------------------------------------------------------------##
##                                                                        ##
##  $(eval $(call ADD2PACK,<packname>,<file>))                            ##
##                                                                        ##
##		Sequentially adds <file> to compressed group <packname>. Each     ##
## call to this macro adds a new <file> after the latest one added.       ##
## packname could be any valid C identifier.                              ##
##                                                                        ##
##  Parameters:                                                           ##
##  (packname): Name of the compressed group where the file will be added ##
##  (file)    : File to be added at the end of the compressed group       ##
##                                                                        ##
##------------------------------------------------------------------------##
##                                                                        ##
##  $(eval $(call PACKZX7B,<packname>,<dest_path>))                       ##
##                                                                        ##
##		Compresses all files in the <packname> group using ZX7B algorithm ##
## and generates 2 files: <packname>.c and <packname>.h that contain a    ##
## C-array with the compressed data and a header file for declarations.   ##
## Generated files are moved to the folder <dest_path>.                   ##
##                                                                        ##
##  Parameters:                                                           ##
##  (packname) : Name of the compressed group to use for packing          ##
##  (dest_path): Destination path for generated output files              ##
##                                                                        ##
############################################################################
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##  * You can omit parameters by leaving them empty.                      ##
##  * Parameters (4) and (5) are optional and generally not required.     ##
############################################################################
