;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Harvest Day: An Amstrad CPC Game 
;;  Copyright (C) 2018 Álvaro Molina García / José Manuel Ladrón de Guevara García, Daniel Saura Martínez
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
;; Include
.include "mapsBin/map.h.s"
.include "tile_pack.h.s"
.include "mapsBin/map_pack.h.s"
;; Macros

;; Constants
decompress_buffer 		= 0x105		;;where the music ends and the decompress buffer space starts
mapmaxsize 				= _map_pack_size
decompress_buffer_end 	= decompress_buffer + mapmaxsize - 1
decompress_buffer2 		= decompress_buffer_end + 1
tilesmaxsize 			= _tile_pack_size
decompress_buffer2_end 	= decompress_buffer2 + tilesmaxsize -1
ztileset_ptr 			= decompress_buffer2 + 0
tilemap_ptr 			= decompress_buffer + 0


music_bytes = 12
;; Globals

	.globl cpct_disableFirmware_asm
	.globl cpct_getScreenPtr_asm
	.globl cpct_drawSolidBox_asm
	.globl cpct_waitVSYNC_asm
	.globl cpct_setVideoMode_asm
	.globl cpct_scanKeyboard_asm
	.globl cpct_isKeyPressed_asm
	.globl cpct_memset_f64_asm
	.globl cpct_setVideoMemoryPage_asm
	.globl cpct_setPalette_asm
	.globl cpct_akp_musicInit_asm
	.globl cpct_setInterruptHandler_asm
	.globl cpct_zx7b_decrunch_s_asm
	.globl cpct_etm_setDrawTilemap4x8_ag_asm
	.globl cpct_etm_drawTilemap4x8_ag_asm
	.globl cpct_akp_musicPlay_asm 
	.globl cpct_akp_stop_asm
	.globl cpct_isAnyKeyPressed_asm 
	.globl cpct_scanKeyboard_if_asm 
	.globl cpct_drawSprite_asm
	.globl cpct_setPALColour_asm


	.globl _palette
	.globl tilemap_ptr 
	.globl ztileset_ptr
	.globl _song_ingame
	.globl drawMap
	.globl configure_map

	.globl inicio_juego
	.globl game_loop
	.globl game_start

	.globl check_mute_music