;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Harvest Day: An Amstrad CPC Game 
;;  Copyright (C) 2018 Álvaro Molina García / José Manuel Ladrón de Guevara García, Daniel Saura Martínez
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;; Macros

	.macro DefinePlayer _name, _x, _y, _w, _h, _col, _mx, _my, _dir, _upd, _vx, _vy, _mov, _del, _block, _op, _dist, _type, _died, _scoreU, _scoreD, _scoreC
	_name:
		DefineEntity _name'_e, _x, _y, _mx, _my, _w, _h, _col, _mx, _my, _dir, _upd, _vx, _vy, _mov, _del, _block, _op, _dist, _type
		.db _died 						;; Boolean that tells if its removed, or not... 0 -> Not removed, -1 -> Removed
		_name'_size = . - _name 		;; Saves the number of bytes that fills the Entity
	.endm


;; Macro positions
pl_e = 0
pl_e_size = 21

pl_died = 0 + pl_e_size

;; Constants

	;; Player constants

		;;PLAYER 1
			;; Screen initial positions of the player
			player1_initial_x = 40
			player1_initial_y = 160

			;; Size of the player
			player1_w = 0x04
			player1_h = 0x10

			;; Matrix initial positions of the player
			player1_initial_mx = 10
			player1_initial_my = 10

			;; Initial direction of the player
			player1_dir = 0 	;; Properties: 0 = Up, 1 = Right, 2 = Down, 3 = Left

			;; Initial velocity of the player
			player1_vx = 0
			player1_vy = 0

			;; Times it truly moves each time press a movable key
			player1_mov = 3

			;; Delay between each movement
			player1_del = 2

			;; Delay every time we create or destroy a single obstacle
			player1_block = 10

			;; Boolean that tells if a the player is destroying or creating
			player1_op = 0 	;; 0 -> It's not creating or destroying 	1 -> It's creating or destroying

			;; The number of obstacles that the player has already created without updating
			player1_dist = 0

			;; Delay to turn in a certain direction
			player1_dir_del = 2


;; Globals
	
	;; Global methods
	.globl pl_clear
	.globl pl_update
	.globl pl_draw
	.globl ent_createObstacle
	.globl pl_change_died

	;; Global pointers
	.globl player1_data