;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of Harvest Day: An Amstrad CPC Game 
;;  Copyright (C) 2018 Álvaro Molina García / José Manuel Ladrón de Guevara García, Daniel Saura Martínez
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

;; Macros
	
	;; Defines a unique section
	.macro DefineSection _name, _value
	_name:
		.db _value
	.endm


	;; Inits the default section 
	.macro DefineDefaultSection _name, _row, _col
		DefineSection _name'_row'_col, section_free
	.endm


	;; Creates a vector of "columns" sections
	.macro DefineColumnSections _name, _row, _col
		_c = 10
		.rept _col
			DefineDefaultSection _name, _row, \_c
			_c = _c + 1
		.endm
	.endm


	;; Creates a matrix of "rows" x "columns" sections
	.macro DefineMatrix _name, _row, _col
		_r = 10
		.rept _row
			DefineColumnSections _name, \_r, _col
			_r = _r + 1
		.endm
	.endm



;; Macro positions


;; Constants
	
	;; Matrix parameters
		rows = 12 			;; For future references -> Rows - 1 = Max Y on the matrix
		columns = 20 			;; For future references -> Columns - 1 = Max X on the matrix
		matrix_size = 240		;; Size in bytes of Matrix (rows * columns)

		section_w = 04 			;; Size X of each section
		section_h = 16 			;; Size Y of each section

		section_obstacleColor = 0x11 	;; Color of an obstacle

		section_free = 0 		;; To initialise all the sections of the matrix
	

;; Globals

	;; Global methods
		.globl sec_setValue
		.globl sec_retValue
		.globl sec_matrixToScreen

	;; Global pointers
		.globl matrix_data


	;; Global variables
		.globl matrix_size
		.globl rows
		.globl columns