// TILEMAPP, basic tilemap tool by CNGSOFT //
// since 20181013-1414 until 20181014-0055 //

#include <stdio.h>
#include <string.h>
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <wingdi.h>

unsigned char tilemap[1<<14],suptile[1<<12],clipbrd[1<<14];
int winlenx,winleny,winmulx,winmuly,winmulz,windivz;
int maplenx,mapleny,map_x_x,map_x_y,map_y_x,map_y_y;
int dibposx,dibposy,diblenx,dibleny;
int dib_x_x,dib_x_y,dib_y_x,dib_y_y;
int dibmaxx,dibmaxy;
int suplenx,supleny;
int sup_x_x,sup_x_y,sup_y_x,sup_y_y;
int suptiles=0,suptile0=0,clip_x=0,clip_y=0;
int winposx=0,winposy=0,mapposx=0,mapposy=0,selposx=0,selposy=0;
FILE *f; int scanfail=0;

int dirty=0;

int minimum(int x,int y) { return x<y?x:y; }
int maximum(int x,int y) { return x>y?x:y; }
int within(int x,int y,int z) { return x<=y&&y<=z; }

HBITMAP tilebm; HDC tiledc=0;
void wndproc_supertile(HDC hdc,int x,int y,int z,int a)
{
	z*=suplenx*supleny;
	int xx,yy,zz,lx=diblenx*winmulx*winmulz/windivz,ly=dibleny*winmuly*winmulz/windivz;
	for (yy=0;yy<supleny;++yy)
		for (xx=0;xx<suplenx;++xx)
		{
			zz=suptile[z++];
			BitBlt(hdc,
				(((x*suplenx+xx)*sup_x_x)+((y*supleny+yy)*sup_y_x))*lx,
				(((x*suplenx+xx)*sup_x_y)+((y*supleny+yy)*sup_y_y))*ly,
				lx,ly,tiledc,
				(dibposx+(zz%dibmaxx)*dib_x_x+(zz/dibmaxx)*dib_x_y)*winmulx*winmulz/windivz,
				(dibposy+(zz%dibmaxx)*dib_y_x+(zz/dibmaxx)*dib_y_y)*winmuly*winmulz/windivz,
				a);//,diblenx,dibleny
		}
}
void wndproc_cursor(HDC hdc,int x,int y,int z)
{
	int lx=diblenx*winmulx*(suplenx*sup_x_x+supleny*sup_y_x)*winmulz/windivz;
	int ly=dibleny*winmuly*(suplenx*sup_x_y+supleny*sup_y_y)*winmulz/windivz;
	int tx=(((x)*sup_x_x)+((y)*sup_y_x))*lx;
	int ty=(((x)*sup_x_y)+((y)*sup_y_y))*ly;
	int sx=tx+lx,sy=ty+ly,wx=lx/(z?4:1),wy=ly/(z?1:4);
	Rectangle(hdc,tx,ty,tx+wx,ty+wy);
	Rectangle(hdc,sx-wx,sy-wy,sx,sy);
}
LRESULT CALLBACK wndproc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
	int x,y,z;
	int minx=minimum(mapposx,selposx),miny=minimum(mapposy,selposy),maxx=maximum(mapposx,selposx),maxy=maximum(mapposy,selposy);
	switch(msg)
	{
		case WM_CLOSE:
			DestroyWindow(hwnd);
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		case WM_PAINT:
			{
				PAINTSTRUCT ps; RECT rt;
				HDC hdc=BeginPaint(hwnd,&ps);
				if (!tiledc)
					tiledc=CreateCompatibleDC(hdc),SelectObject(tiledc,tilebm);
				//HGDIOBJ context=SelectObject(tiledc,tilebm);
				for (y=0;y<winleny;++y)
					for (x=0;x<winlenx;++x)
						wndproc_supertile(hdc,2+x,y,tilemap[(y+winposy)*maplenx+x+winposx],(within(minx,x+winposx,maxx)&&within(miny,y+winposy,maxy))?NOTSRCCOPY:SRCCOPY);
				wndproc_cursor(hdc,2+mapposx-winposx,mapposy-winposy,0);
				for (y=0;y<winleny;++y)
					wndproc_supertile(hdc,1,y,0,SRCCOPY);
				z=suptile0-(winleny-1)/2;
				for (y=0;y<winleny;++y)
					wndproc_supertile(hdc,0,y,(z++)&suptiles,SRCCOPY);
				wndproc_cursor(hdc,0,(winleny-1)/2,1);
				//SelectObject(tiledc,context);
				//DeleteDC(tiledc);
				EndPaint(hwnd,&ps);
			}
			break;
		case WM_KEYDOWN:
			{
				int GUI_CONTROL=GetKeyState(VK_CONTROL)<0,GUI_SHIFT=GetKeyState(VK_SHIFT)<0,q=0;
				switch (wparam)
				{
					case VK_UP:
						if (GUI_CONTROL)
							--suptile0;
						else
							q=1,mapposx-=map_x_y,mapposy-=map_y_y;
						break;
					case VK_DOWN:
						if (GUI_CONTROL)
							++suptile0;
						else
							q=1,mapposx+=map_x_y,mapposy+=map_y_y;
						break;
					case VK_LEFT:
						if (GUI_CONTROL)
							--suptile0;
						else
							q=1,mapposx-=map_x_x,mapposy-=map_y_x;
						break;
					case VK_RIGHT:
						if (GUI_CONTROL)
							++suptile0;
						else
							q=1,mapposx+=map_x_x,mapposy+=map_y_x;
						break;
					case VK_PRIOR:
						if (GUI_CONTROL)
							suptile0-=16;
						else
							q=1,mapposx-=16*map_x_y,mapposy-=16*map_y_y;
						break;
					case VK_NEXT:
						if (GUI_CONTROL)
							suptile0+=16;
						else
							q=1,mapposx+=16*map_x_y,mapposy+=16*map_y_y;
						break;
					case VK_HOME:
						if (GUI_CONTROL)
							suptile0-=16;
						else
							q=1,mapposx-=16*map_x_x,mapposy-=16*map_y_x;
						break;
					case VK_END:
						if (GUI_CONTROL)
							suptile0+=16;
						else
							q=1,mapposx+=16*map_x_x,mapposy+=16*map_y_x;
						break;
					case VK_RETURN:
						suptile0=tilemap[mapposy*maplenx+mapposx];
						break;
					case VK_SPACE:
						for (y=minimum(mapposy,selposy);y<=maxy;++y)
							for (x=minimum(mapposx,selposx);x<=maxx;++x)
								tilemap[y*maplenx+x]=suptile0;
						q=dirty=1;
						break;
					case 'C':
					case 'X':
						if (GUI_CONTROL)
						{
							dirty=(wparam=='X');
							clip_y=maxy-miny+1;
							clip_x=maxx-minx+1;
							for (y=0;y<clip_y;++y)
								for (x=0;x<clip_x;++x)
								{
									clipbrd[y*clip_x+x]=tilemap[(miny+y)*maplenx+minx+x];
									if (dirty)
										tilemap[(miny+y)*maplenx+minx+x]=suptile0;
								}
						}
						break;
					case 'V':
						if (GUI_CONTROL)
						{
							dirty=(clip_y&&clip_x);
							for (y=0;y<clip_y;++y)
								for (x=0;x<clip_x;++x)
									tilemap[(miny+y)*maplenx+minx+x]=clipbrd[y*clip_x+x];
						}
						break;
					case 'H': q=1; // replace / swap
						if (GUI_CONTROL&&(suptile0!=(z=tilemap[mapposy*maplenx+mapposx])))
						{
							dirty=1;
							for (x=0;x<sizeof(tilemap);++x)
								if (tilemap[x]==z)
									tilemap[x]=suptile0;
								else if (GUI_SHIFT&&(tilemap[x]==suptile0))
									tilemap[x]=z;
							if (GUI_SHIFT)
								suptile0=z;
						}
						break;
					default:
						return DefWindowProc(hwnd,msg,wparam,lparam);
						break;
				}
				if (mapposx<0) mapposx=0;
				if (mapposx>=maplenx) mapposx=maplenx-1;
				if (mapposy<0) mapposy=0;
				if (mapposy>=mapleny) mapposy=mapleny-1;
				//mapposx=(mapposx+maplenx)%maplenx;
				//mapposy=(mapposy+mapleny)%mapleny;
				suptile0&=suptiles;
				if (mapposx<winposx) winposx=mapposx;
				if (mapposy<winposy) winposy=mapposy;
				if (mapposx>=winposx+winlenx) winposx=mapposx-winlenx+1;
				if (mapposy>=winposy+winleny) winposy=mapposy-winleny+1;
				if (q)
					if (!GUI_SHIFT)
						selposx=mapposx,selposy=mapposy;
				InvalidateRect(hwnd,0,0);//UpdateWindow(hwnd);
			}
			break;
		default:
			return DefWindowProc(hwnd,msg,wparam,lparam);
	}
	return 0;
}

int scanfile()
{
	int i=0,c;
	if (!scanfail&&(c=fgetc(f))!=EOF)
	{
		while (c>='0'&&c<='9')
		{
			i=i*10+(c-'0');
			c=fgetc(f);
		}
		if (c!=EOF&&c!=','&&c!=10)
			while ((c=fgetc(f))!=EOF&&c!=10)
				{}
	}
	else
		scanfail=1;
	return i;
}

char cannotopen[]="error: cannot open %s!\n",str1[256],str2[256];

int main(int argc,char *argv[])
{
	char *s;
	int x,y,z;
	if (argc!=4||!strchr(argv[2],'.'))
		return printf("usage: %s <tilemap.dib|-> tilemap.til <tilemap.map|->\n",argv[0]),1;
	if (!strcmp(argv[1],"-"))
		strcpy(str1,argv[2]),strcpy(strrchr(str1,'.'),".dib"),argv[1]=str1;
	if (!strcmp(argv[3],"-"))
		strcpy(str2,argv[2]),strcpy(strrchr(str2,'.'),".map"),argv[3]=str2;
	if (!(tilebm=LoadImage(NULL,s=argv[1],IMAGE_BITMAP,0,0,LR_LOADFROMFILE)))
		return printf(cannotopen,s),1;
	if (!(f=fopen(s=argv[2],"r")))
		return printf(cannotopen,s),1;
	winlenx=scanfile(); winleny=scanfile();
	winmulx=scanfile(); winmuly=scanfile(); winmulz=scanfile(); windivz=scanfile();
	maplenx=scanfile(); mapleny=scanfile();
	map_x_x=scanfile(); map_x_y=scanfile(); map_y_x=scanfile(); map_y_y=scanfile();
	dibposx=scanfile(); dibposy=scanfile(); diblenx=scanfile(); dibleny=scanfile();
	dib_x_x=scanfile(); dib_x_y=scanfile(); dib_y_x=scanfile(); dib_y_y=scanfile();
	dibmaxx=scanfile(); dibmaxy=scanfile();
	suplenx=scanfile(); supleny=scanfile();
	sup_x_x=scanfile(); sup_x_y=scanfile(); sup_y_x=scanfile(); sup_y_y=scanfile();
	z=y=x=0;
	while (!scanfail)
	{
		suptile[z++]=scanfile();
		if (++x>=suplenx)
		{
			x=0;
			if (++y>=supleny)
				y=0,++suptiles;
		}
	}
	z=1;
	while (z<suptiles)
		z<<=1;
	suptiles=z-1;
	fclose(f);
	if (!(f=fopen(s=argv[3],"rb")))
		return printf(cannotopen,s),1;
	fread(tilemap,1,maplenx*mapleny,f);
	fclose(f);

	BITMAP bm;
	GetObject(tilebm,sizeof(bm),&bm);
	x=bm.bmWidth*winmulx*winmulz/windivz; y=bm.bmHeight*winmuly*winmulz/windivz;
	tilebm=CopyImage(tilebm,IMAGE_BITMAP,x,y,LR_COPYDELETEORG);

	// create window
	WNDCLASSEX wc; HWND hwnd; MSG msg;
	wc.cbSize=sizeof(WNDCLASSEX);
	wc.style=0;
	wc.lpfnWndProc=wndproc;
	wc.cbClsExtra=wc.cbWndExtra=0;
	wc.hInstance=GetModuleHandle(0);
	wc.hIcon=wc.hIconSm=LoadIcon(NULL,IDI_APPLICATION);
	wc.hCursor=LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground=0;//(HBRUSH)(COLOR_WINDOW+0);
	wc.lpszMenuName=NULL;
	wc.lpszClassName=argv[0];
	RegisterClassEx(&wc);
	// handle window
	RECT desired; desired.left=desired.top=0;
	desired.right=((((2+winlenx)*suplenx)*sup_x_x)+((winleny*supleny)*sup_y_x))*diblenx*winmulx*winmulz/windivz;
	desired.bottom=((((2+winlenx)*suplenx)*sup_x_y)+((winleny*supleny)*sup_y_y))*dibleny*winmuly*winmulz/windivz;
	AdjustWindowRect(&desired,WS_OVERLAPPEDWINDOW,0);
	if (hwnd=CreateWindowEx(0,argv[0],argv[3],WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,x=desired.right-desired.left,y=desired.bottom-desired.top,NULL,NULL,wc.hInstance,NULL))
	{
		ShowWindow(hwnd,SW_SHOWDEFAULT),UpdateWindow(hwnd);
		while (GetMessage(&msg,NULL,0,0)>0)
			TranslateMessage(&msg),DispatchMessage(&msg);
		// end of window
	}

	if (dirty)
	{
		if (!(f=fopen(s=argv[3],"wb")))
			return printf(cannotopen,s),1;
		fwrite(tilemap,1,maplenx*mapleny,f);
		fclose(f);
	}
	return 0;
}
