//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Deeper Warrens
//  Copyright (C) 2018 Arnaud Bouche (@Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

typedef struct 
{
	u8 type;
	u8 value;
} SBonus;

enum
{
	PERM_PROTECTION 		= 0x01,
	PERM_RESURRECTION		= 0x02,
	PERM_SWORD_MASTER		= 0x04,
	PERM_THROW_MASTER		= 0x08,
	PERM_BONUS				= PERM_THROW_MASTER,
	
	BONUS_STRENGTH			= 0x10,
	BONUS_INVISIBILITY		= 0x20,
	
	MALUS_POISON			= 0x40,
};

#define BONUS_EXISTING		0
#define BONUS_REMOVE		1

#define BONUS_LIFE_POTION	300

void InitBonus();
void RemoveBonus(u8 type);
void AddBonus(u8 type);
void UpdateBonus();
void DrawBonus();

u8 GetBonusOfObject(u8 objectId);
