//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Deeper Warrens
//  Copyright (C) 2018 Arnaud Bouche (@Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

extern u8 gLevel[MAP_SIZE];
extern const u8 gLevelTileset[TILESET_SIZE];

typedef struct
{
	u8 level, genLevel;
	u8 tileset, palette;
	u8 startx, starty;
} SDungeon;

/** Level informations */
enum
{
	LEVEL_TILESET,
	LEVEL_PALETTE,
	LEVEL_BORDER,
	LEVEL_START_X,
	LEVEL_START_Y,
	LEVEL_POPULATED,
	LEVEL_INFO_END
};

/** Tilesets */
enum
{
	STONEWALL_TILESET,
	WILDERNESS_TILESET
};

void FillBorderLevel();
void StartGame();
void GameWin();
void GameOver();
void EnterLevel();
void OpenDoor(u8* door);
void ChangeLevel();
void SetLevelColor(BOOL enterLevel);
void OpenWalls();
void DestroyItem(u8* tileRock);
void SetExplosion(u8* tile);
BOOL Teleport(u8* srcTeleport);
u8 GetTileDamages(u8 tileId);

u8 GetImpactIndice(u8 status);
SCoord* FindViewElement(u8 dgnElement, u8* element);
u8* GetLevelPtr(u8 x, u8 y);

#define IsTilePath(tileId)			(tileId == DGN_FIRE_PATH || tileId == DGN_WATER_PATH || tileId == DGN_SPIKE_TRAP)
#define IsItemBreakable(tileId) 	(tileId == OBJ_ROCK || tileId == OBJ_ROCK_DAMAGED || tileId == OBJ_SKULL || tileId == OBJ_CRATE)
#define NB_PALETTES_WALLS			6