//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Deeper Warrens
//  Copyright (C) 2018 Arnaud Bouche (@Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#define NB_MOVE_DIR			2
#define SPEED_MOVE			2
#define SPEED_MOVE_SLOW		1
#define MONSTER_ACTIVE		10
#define ROUND_WAIT			2
#define FIREBALL_WAIT		6
#define ATTACK_LVL	 		10

enum
{
	MONST_MOVE_0,
	MONST_MOVE_1,
	MONST_DEAD_0,
	MONST_DEAD_1,
	MONST_DEAD_2,
	MONST_DELETE
};

typedef struct 
{	
	u8 id;
	u8 wait;
	u8 type;
	u8 life;
	u8 speed;
	u8 infos;
	u8 fightTempo;
	u8 impactHit;
	
	SScreen screen;
	SPos pos;
} SMonster;

void InitMonsters();
void StoreMonster(SMonster* monster);
void CreateMonster(u8* tile, u8 x, u8 y);
void DelMonster(SMonster* monsterToDel);
void UpdateMonsters();
void DrawMonsters();
void BurnMonsters();

void MonsterIsHit(SMonster* monster, u8 damage, BOOL isPlayerAttack);
BOOL IsActive(SMonster* monster);

u8* DeflateSpriteMonster(u8 type);
SMonster* GetCollidedMonster(u8 monsterId, u8 x, u8 y);
BOOL ConvertToScreenMonster(SMonster* monster);
u8 GetMonsterLevel(SMonster* monster);