//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Deeper Warrens
//  Copyright (C) 2018 Arnaud Bouche (@Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------------

#ifndef SOUND_FX_H
#define SOUND_FX_H

/*************** Arkos2 includes **************/
#include "arkosPlayer2.h"

#define FX_ADDRESS		0x40
#define FX_LENGTH		0xE7
#define MUSIC_ADDRESS	0x8000

enum
{
	CHANNEL_A,
	CHANNEL_B,
	CHANNEL_C
};

enum
{
	FX_IMPACT = 1,
	FX_EXPLOSION,
	FX_MAGIC,
	FX_ACTION,
	FX_MISSILE,
	FX_TREASURE
};

void PlaySound();

void SelectMusic(void* music);
void ActivateMusic();

void InitSFX();
void PlaySFX(u8 fx);
void ActivateSFX();

#endif