//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Deeper Warrens
//  Copyright (C) 2018 Arnaud Bouche (@Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

// Move definitions
enum
{
	NO_MOVE,
	TOP		= 0x01,
	DOWN 	= 0x02,
	LEFT	= 0x04,
	RIGHT 	= 0x08,
	SELECT	= 0x10,
	FIRE	= 0x20,
	SEL1	= 0x81,
	SEL2	= 0x82,
	SEL3	= 0x83,
	SEL4	= 0x84	
};

#define MOVE_FILTER	0x0F

// Level Tileset
enum
{
	TILESET_STONE,
	TILESET_FOREST
};

// Alternate Tile definitions
enum
{
	ALT_TELEPORTER,
	ALT_FIRE
};

// Tile definitions
enum
{
	DGN_GROUND		= 0,
	DGN_SOMETHING,
	WALLS_BEG		= DGN_SOMETHING,
	WALLS_END		= WALLS_BEG + 15,
	
	DGN_ITEMS,
	DGN_SHOP = DGN_ITEMS,
	DGN_EXIT,
	DGN_DOOR_V_RED,
	DGN_DOOR_H_RED,
	DGN_DOOR_V_BLUE,
	DGN_DOOR_H_BLUE,	
	
	DGN_OPEN_PRESSURE_PLATE,
	DGN_USED_PRESSURE_PLATE,
	DGN_TELEPORT_DOOR_LEFT,
	DGN_TELEPORT_DOOR_RIGHT,
	OBJECTS, // 32

	OBJ_FOOD_CORN = OBJECTS,
	OBJ_FOOD_CIDER,
	OBJ_FOOD_APPLE,
	OBJ_FOOD_STEAK,
	
	OBJ_CHEST_CLOSED,
	OBJ_TREASURE_GOLD,
	OBJ_TREASURE_GOLD_PILES,
	OBJ_TREASURE_GOLD_CUP,
	OBJ_TREASURE_CHEST,

	OBJ_TAKABLE,
	OBJ_KEY_GOLD = OBJ_TAKABLE,
	OBJ_KEY_SILVER,
	
	OBJ_POTION_BOMB,
	OBJ_POTION_INVISIBILITY,
	OBJ_POTION_LIFE,
	OBJ_POTION_STRENGTH,
	
	OBJ_WEAPON_DAGGER,
	OBJ_WEAPON_SHORT_SWORD,
	OBJ_WEAPON_SWORD,
	OBJ_WEAPON_SWORD_MAGIC_BLUE,
	OBJ_WEAPON_SWORD_MAGIC_RED,
	
	OBJ_ARMOR_TUNIC,
	OBJ_ARMOR_LEATHER,
	OBJ_ARMOR_LEATHER_STUDDED,
	OBJ_ARMOR_MAIL,
	OBJ_ARMOR_BRONZE,
	OBJ_ARMOR_PLATE,
	
	OBJ_MAGIC_PROTECTION,
	OBJ_MAGIC_RESURRECTION,
	OBJ_MAGIC_SWORD_MASTER,	
	OBJ_MAGIC_THROW_MASTER,
	
	OBJ_AMMO,
	
	END_OBJ_TAKABLE = OBJ_AMMO,
	OBJ_ROCK,
	OBJ_ROCK_DAMAGED,
	OBJ_BOMB,
	
	OBJ_HOLE_PATH,
	OBJ_SKULL,
	OBJ_CRATE,
	OBJ_INVISIBLE_WALL, // And End game hero
		
	DGN_ALTERN_SPRITE,
	DGN_FIRE_PATH = DGN_ALTERN_SPRITE,
	DGN_WATER_PATH,
	DGN_TELEPORTER,
	DGN_TORCH,
	DGN_SPIKE_TRAP,
	DGN_ALTERN_END = DGN_SPIKE_TRAP,

	// Not Displayed
	DGN_WALLS = DGN_ALTERN_END,
	DGN_ILLUSION_WALL_H,
	DGN_ILLUSION_WALL_V,
	DGN_TRIGGER_WALL_H,
	DGN_TRIGGER_WALL_V,
	
	MONSTERS,
	MONSTER_1		= MONSTERS,
	MONSTER_2,
	MONSTER_3,
	MONSTER_4,
	MONSTER_5,
	MONSTER_6,
	MONSTER_7,
	
	PLAYER	
};

// Boolean definition
#define BOOL		u8
#define TRUE		1
#define FALSE		0

// Screen size
#define SCREEN_CX	80
#define SCREEN_CY	200

typedef struct 
{
	u8 mapx, mapy;
	u8 x, y;
	u8 dir;
	u8 tileOn;
} SPos;

typedef struct
{
	u8 x, y;
	u8 cy;
} SScreen;

typedef struct 
{
	u8 xl, xr;
	u8 yt, yd;
} SRect;

typedef struct
{
	u8 x, y;
} SCoord;
