##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette
PALETTE=14 1 2 3 4 6 9 11 26 13 15 16 18 24 25 0

PALETTEMENU=0 1 2 3 4 6 9 11 26 13 15 16 12 24 25 0 

## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_FOLDER      , src/               ))
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }
#$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))
#$(eval $(call IMG2SP, CONVERT         , img.png , w, h, array, palette, tileset))

#
# MENU
#

$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))
$(eval $(call IMG2SP, SET_MODE        , 0                  ))


$(eval $(call IMG2SP, SET_FOLDER      , src             ))
$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTEMENU)          ))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTEMENU), g_paletteMenu ))

$(eval $(call IMG2SP, SET_FOLDER      , menu/assetsObj             ))
$(eval $(call IMG2SP, SET_OUTPUT      , bin ))

$(eval $(call IMG2SP, CONVERT         , assets/avatars.png,  26, 78, g_avatar,   , g_avatars))
$(eval $(call IMG2SP, CONVERT         , assets/menu-title.png,  56, 41, g_menutitle_0,   , g_menutitle))
$(eval $(call IMG2SP, CONVERT         , assets/todStudios.png,  26, 24, g_tod_0,   , g_tod))
$(eval $(call IMG2SP, CONVERT         , assets/cpctelera.png,  52, 28, g_cpct_0,   , g_cpct))
$(eval $(call IMG2SP, CONVERT         , assets/flame.png,  12, 29, g_flame,  , g_flame))

$(eval $(call IMG2SP, CONVERT         , assets/keySpace.png,  36, 13, g_keySp_0,   , g_keySp))
$(eval $(call IMG2SP, CONVERT         , assets/keyArrow.png,  10, 13, g_keyArr,   , g_keyArr))
$(eval $(call IMG2SP, CONVERT         , assets/arrowH.png,  4, 15, g_arrowH_0,   , g_arrowH))
$(eval $(call IMG2SP, CONVERT         , assets/arrowV.png,  10, 8, g_arrowV,   , g_arrowV))
$(eval $(call IMG2SP, CONVERT         , assets/joyButton.png,  12, 13, g_joyBut,   , g_joyBut))
$(eval $(call IMG2SP, CONVERT         , assets/joyBall.png,  12, 18, g_joyBall_0,   , g_joyBall))
$(eval $(call IMG2SP, CONVERT         , assets/joyStick.png,  8, 11, g_joyStick,   , g_joyStick))


$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)          ))
$(eval $(call IMG2SP, CONVERT         , assets/panel.png,  80, 24, g_panel,   , g_panel))


$(eval $(call IMG2SP, SET_OUTPUT      , c ))
$(eval $(call IMG2SP, SET_FOLDER      , src             ))
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))



#
# FONTS
#
$(eval $(call IMG2SP, SET_FOLDER      , src/fonts          ))
$(eval $(call IMG2SP, CONVERT         , assets/font.png,    4,  8, g_font, g_palette, g_font))

#
# SPRITES
#
$(eval $(call IMG2SP, SET_FOLDER      , src/characters     ))
$(eval $(call IMG2SP, CONVERT         , assets/warrior.png, 8, 16, g_warrior, , g_warrior))
$(eval $(call IMG2SP, CONVERT         , assets/warriorAttackH.png, 14, 16, g_warriorAttackH, , g_warriorAttakH))
$(eval $(call IMG2SP, CONVERT         , assets/warriorAttackV.png, 8, 26, g_warriorAttackV, , g_warriorAttakV))
$(eval $(call IMG2SP, CONVERT         , assets/orc.png,     8, 16, g_orc,     , g_orc))
$(eval $(call IMG2SP, CONVERT         , assets/skeleton.png,     8, 16, g_skeleton,     , g_skeleton))
$(eval $(call IMG2SP, CONVERT         , assets/knight.png,     8, 16, g_knight,     , g_knight))
$(eval $(call IMG2SP, CONVERT         , assets/wizard.png,     8, 16, g_wizard,     , g_wizard))
$(eval $(call IMG2SP, CONVERT         , assets/ball.png,     8, 8, g_ball,     , g_ball))
$(eval $(call IMG2SP, CONVERT         , assets/slimer.png,     8, 16, g_slimer,     , g_slimer))
$(eval $(call IMG2SP, CONVERT         , assets/babieSlimer.png, 6, 16, g_babiSlimer,     , g_babiSlimer))
$(eval $(call IMG2SP, CONVERT         , assets/doorV.png,  8, 24, g_doorV_0,   , g_doorV))
$(eval $(call IMG2SP, CONVERT         , assets/doorH.png,  16, 16, g_doorH_0,   , g_doorH))


#
# ITEMS
#
$(eval $(call IMG2SP, SET_FOLDER      , src/items          ))
$(eval $(call IMG2SP, CONVERT         , assets/heart.png,   6,  9, g_heart,     , g_heart))
$(eval $(call IMG2SP, CONVERT         , assets/key.png,     4, 12, g_key_0,     , g_key))
$(eval $(call IMG2SP, CONVERT         , assets/items.png,   8,  8, g_items,     , g_items))
#$(eval $(call IMG2SP, CONVERT         , assets/chest.png,   8,  8, g_chest_0,   , g_chest))
#$(eval $(call IMG2SP, CONVERT         , assets/chicken.png, 8,  6, g_chicken_0, , g_chicken))
#$(eval $(call IMG2SP, CONVERT         , assets/coins.png,   6,  6, g_coins_0,   , g_coins))
#$(eval $(call IMG2SP, CONVERT         , assets/potion.png,  6,  8, g_potion_0,  , g_potion))
#$(eval $(call IMG2SP, CONVERT         , assets/item_heart.png,  6, 8, g_item_heart_0,  , g_item_heart))
#$(eval $(call IMG2SP, CONVERT         , assets/item_key.png,    4, 8, g_item_key_0,  , g_item_key))

#
# TILESETS
#
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , zgtiles            ))
$(eval $(call IMG2SP, SET_FOLDER      , src/tiles          ))
$(eval $(call IMG2SP, CONVERT         , assets/tiles1.png,  8,  8, g_tiles1,  , g_tiles1))
$(eval $(call IMG2SP, CONVERT         , assets/tiles2.png,  8,  8, g_tiles2,  , g_tiles2))
$(eval $(call IMG2SP, CONVERT         , assets/tiles3.png,  8,  8, g_tiles3,  , g_tiles3))



##
## OLD MACROS (For compatibility)
##

## Example firmware palette definition as variable in cpct_img2tileset format

# PALETTE={0 1 3 4 7 9 10 12 13 16 19 20 21 24 25 26}

## AUTOMATED IMAGE CONVERSION EXAMPLE (Uncomment EVAL line to use)
##
##    This example would convert img/example.png into src/example.{c|h} files.
##    A C-array called pre_example[24*12*2] would be generated with the definition
##    of the image example.png in mode 0 screen pixel format, with interlaced mask.
##    The palette used for conversion is given through the PALETTE variable and
##    a pre_palette[16] array will be generated with the 16 palette colours as 
##	  hardware colour values.

#$(eval $(call IMG2SPRITES,img/example.png,0,pre,24,12,$(PALETTE),mask,src/,hwpalette))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macro used for conversion is IMG2SPRITES, which has up to 9 parameters:##
##  (1): Image file to be converted into C sprite (PNG, JPG, GIF, etc)    ##
##  (2): Graphics mode (0,1,2) for the generated C sprite                 ##
##  (3): Prefix to add to all C-identifiers generated                     ##
##  (4): Width in pixels of each sprite/tile/etc that will be generated   ##
##  (5): Height in pixels of each sprite/tile/etc that will be generated  ##
##  (6): Firmware palette used to convert the image file into C values    ##
##  (7): (mask / tileset / zgtiles)                                       ##
##     - "mask":    generate interlaced mask for all sprites converted    ##
##     - "tileset": generate a tileset array with pointers to all sprites ##
##     - "zgtiles": generate tiles/sprites in Zig-Zag pixel order and     ##
##                  Gray Code row order                                   ##
##  (8): Output subfolder for generated .C/.H files (in project folder)   ##
##  (9): (hwpalette)                                                      ##
##     - "hwpalette": output palette array with hardware colour values    ##
## (10): Aditional options (you can use this to pass aditional modifiers  ##
##       to cpct_img2tileset)                                             ##
##                                                                        ##
## Macro is used in this way (one line for each image to be converted):   ##
##  $(eval $(call IMG2SPRITES,(1),(2),(3),(4),(5),(6),(7),(8),(9), (10))) ##
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##                                                                        ##
##  * You can omit parameters but leaving them empty. Therefore, if you   ##
##  wanted to specify an output folder but do not want your sprites to    ##
##  have mask and/or tileset, you may omit parameter (7) leaving it empty ##
##     $(eval $(call IMG2SPRITES,imgs/1.png,0,g,4,8,$(PAL),,src/))        ##
############################################################################
