;***********************************************************************
;DEFINE
;***********************************************************************
;Version
LANG_ES EQU 0		;espaol 1 / ingles 0
ROM EQU 0		;version rom 1 / version normal 0
SHWOCREDITS EQU 1	;mostrar creditos
;-----------------------------------------------------------------------
;codigo en pruebas
M4_ENABLED EQU 1	;rutinas M4 board	OK
IA_LINE EQU 1		;obstculos IA		OK
REG EQU 1		;registrar datos	OK
FAKEBY EQU 1		;imprecisin		OK
;***********************************************************************
;Address
;***********************************************************************

STACK EQU #300		;pila

if ROM
	START_CODE equ #437f			;+total 3c80 = 7fff	3c80 max (Softbrenner ROM)
else
	START_CODE equ #4000			;+total 3fff = 7fff
endif

;sprite dumps & flips
BLKREVSPR_LOC EQU START_CODE-1298	;168 (7 blocks) +144 (4 equip) 
.blockR_spr EQU BLKREVSPR_LOC
.conrIR_spr EQU BLKREVSPR_LOC+24
.portR1_spr EQU BLKREVSPR_LOC+48
.portR3_spr EQU BLKREVSPR_LOC+72
.cornBR_spr EQU BLKREVSPR_LOC+96
.cornr3_spr EQU BLKREVSPR_LOC+120
.cornr3_sprB EQU BLKREVSPR_LOC+144
.equip1_sprAR EQU BLKREVSPR_LOC+168
.equip2_sprAR EQU BLKREVSPR_LOC+204
.equip1_sprBR EQU BLKREVSPR_LOC+240
.equip2_sprBR EQU BLKREVSPR_LOC+276

HAND1R_LOC EQU START_CODE-986		;160
.hand1RA_spr EQU HAND1R_LOC
.hand1RB_spr EQU HAND1R_LOC+80

HAND2L_LOC EQU START_CODE-826		;160
.hand2lB_spr EQU HAND2L_LOC
.hand2lA_spr EQU HAND2L_LOC+80

HAND2R_LOC EQU START_CODE-666		;240
.hand2RB_spr EQU HAND2R_LOC
.hand2RA_spr EQU HAND2R_LOC+80
.handle2_spr EQU HAND2R_LOC+160

;buffers, etc..
.time_stamp equ START_CODE-426		;defs 5+nop	;m4 board time string in ram
.tableC000 equ START_CODE-420		;defs 400	;screen table
.back_buffer equ START_CODE-20		;defs 10	;ball back buffer
.keyb_buffer equ START_CODE-10		;defs 10	;keyboard

;arkos player
ARKOS_PLAYER EQU #76F3 	;TOTAL 6CF
SONG1 EQU #7DC3		;TOTAL 18A	
SONG2 EQU #7F4D 	;TOTAL B2
;7ffe final		total 90B

;***********************************************************************
;BALL
;***********************************************************************
;LIMITES MESA
LIMIT_UP EQU #1E
LIMIT_DW EQU #A6
LIMIT_LF EQU #09
LIMIT_RG EQU #46
GOAL_UP EQU #52
GOAL_DW EQU #75
GOAL_LF EQU #07
GOAL_RG EQU #48

;RANGOS VELO
MIN_BXI EQU 160
MAX_BXI EQU 255
MIN_BYI EQU 5
MAX_BYI EQU 255
MAX_BXYI EQU #FFFF

;saque inicial
INI_POS EQU #271A
INI_DEV EQU #CBFF	;cb 200;MAX_BYI
INI_DIRY EQU 1

;sacar izq
RES1_POS EQU #0E98	;BX BY
RES1_DEV EQU #E6FF	;230;MAX_BYI

;sacar dcha
RES2_POS EQU #4028	;BX BY
RES2_DEV EQU #E6FF	;230;MAX_BYI

;direccion
DIR_LFUP EQU #FFFF
DIR_RGUP EQU #01FF
DIR_LFDW EQU #FF01
DIR_RGDW EQU #0101

;shot
SHOT_TIMEOUT EQU 10
SHOT1_DIRX EQU #01
SHOT2_DIRX EQU #FF
SHOT_DEVX EQU MAX_BXI
;SHOT_DEVY EQU MAX_BYI-1

;TOUCH COLORS
CLR_EDGE1_UP EQU #A4	
CLR_EDGE1_DW EQU #8C	
CLR_DRAG_LF EQU #18	
CLR_EDGE2_UP EQU #58	
CLR_EDGE2_DW EQU #4C	
CLR_DRAG_RG EQU #24	
CLR_COVER1_LF EQU #1C	
CLR_COVER1_RG EQU #2C	
CLR_COVER2_LF EQU #86	
CLR_COVER2_RG EQU #49	
;CLR_COVER3_LF EQU #5C		
;CLR_COVER3_RG EQU #AC	
;CLR_COVER4_LF EQU #0E	
;CLR_COVER4_RG EQU #0D	
CLR_SHOT1 EQU #F0	
CLR_SHOT2 EQU #30	
CLR_SHOT3 EQU #03	
CLR_SHOT4 EQU #CF	
;CLR_SHOT5 EQU #FC	
;CLR_SHOT6 EQU #0F	

;BACK COLORS 
BACKCOLOR1 EQU #33
BACKCOLOR2 EQU #F3
BACKCOLOR3 EQU #B7
BACKCOLOR4 EQU #7B
BACKCOLOR5 EQU #0C
BACKCOLOR6 EQU #00

;***********************************************************************
;FIGURAS
;***********************************************************************
;AREAS
AREA7 EQU #10
AREA6 EQU #18
AREA5 EQU #20
AREA4 EQU #28
AREA3 EQU #30
AREA2 EQU #38
AREA1 EQU #40
AREA0 EQU #48

;SHOW MOVE (draw)
BIT_PT1 EQU 7		
BIT_DF1 EQU 6
BIT_DL2 EQU 5
BIT_MD1 EQU 4
BIT_MD2 EQU 3
BIT_DL1 EQU 2
BIT_DF2 EQU 1
BIT_PT2 EQU 0

;BIT VALUE
TEAM1 EQU %11010100
TEAM2 EQU %00101011
PT1_BIT EQU 128	
DF1_BIT EQU 64
DL2_BIT EQU 32
MD1_BIT EQU 16
MD2_BIT EQU 8
DL1_BIT EQU 4
DF2_BIT EQU 2
PT2_BIT EQU 1
NO_SHOT EQU 0
HDLE_Z1_BIT EQU 128
HDLE_Z2_BIT EQU 64
HDLE_Z3_BIT EQU 32
HDLE_Z4_BIT EQU 16

;X
PT1_POSX EQU #09
DF1_POSX EQU #11
DL2_POSX EQU #19
MD1_POSX EQU #21
MD2_POSX EQU #29
DL1_POSX EQU #31
DF2_POSX EQU #39
PT2_POSX EQU #41
MOVE_BACK_LIMIT EQU 2
MOVE_FORW_LIMIT EQU 5

;Y
PT_NUM_FIG EQU 1
PT_LIMIT_UP EQU #54		
PT_POSY EQU #60			
PT_LIMIT_DW EQU #70		
PT_OFFSET_SCR EQU #0000

DF_NUM_FIG EQU 2
DF_LIMIT_UP EQU #24		
DF_POSY EQU #48			
DF_LIMIT_1 EQU #60		
DF_LIMIT_DW EQU #6C		
DF_OFFSET_POS EQU #30		
DF_OFFSET_SCR EQU #01E0		

MD_NUM_FIG EQU 5
MD_LIMIT_UP EQU #24
MD_POSY EQU #30
MD_LIMIT_DW EQU #3C
;MD_OFFSET_POS EQU #18 		
MD_LMT1_OFFSET EQU #3D18	
MD_OFFSET_SCR EQU #00F0

DL_NUM_FIG EQU 3
DL_LIMIT_UP EQU #24
DL_POSY EQU #38
DL_LIMIT_DW EQU #4C
;DL_OFFSET_POS EQU #28		
DL_LMT1_OFFSET EQU #4D28	
DL_OFFSET_SCR EQU #0190

ALL_LMTTOTAL_DW EQU #9C

;***********************************************************************
;IA
;***********************************************************************
;ia1-ia2 DL shot Y offset
IA_DLSHOT_UP EQU GOAL_UP-10
IA_DLSHOT_DW EQU GOAL_DW+8
;ia1 area offset
IA1_AREA EQU 14
IA1_AREA_RET EQU 16
IA1_AREA_END EQU 20

;ia2 area offset
IA2_FIXA EQU 5
IA2_AREA EQU IA2_FIXA-14
IA2_AREA_RET EQU IA2_FIXA-16
IA2_AREA_END EQU IA2_FIXA-20

;***********************************************************************
;COUNTERS
;***********************************************************************
;ia
IA_FAKE_CONT EQU 40
IA_REACTION_TIME EQU 20
IA_FAKE_VALUE EQU 16
;menu counter
DEMO_DELAY EQU 10
;match
COUNTDOWN_DELAY EQU 50
COUNTDOWN_TIME EQU 4
POSESSION_TIME EQU 15
;***********************************************************************
;CONTROL
;***********************************************************************
;query
BIT_PRESSED1 EQU 7
BIT_PRESSED2 EQU 0
BIT_ALTBAR EQU 6
BIT_J2 EQU 5
BIT_Z4 EQU 4	
BIT_Z3 EQU 3	
BIT_Z2 EQU 2	
BIT_Z1 EQU 1	
BIT_CTRL1 EQU 0	
BIT_CTRL2 EQU 5	
BIT_IA1 EQU 6	
BIT_IA2	EQU 7	
;sets-xors
PRESSED1 EQU %10000000
PRESSED2 EQU %00000001
RESPRESS EQU %01111110
PRESSALTBAR EQU %11000000
ALTBAR EQU %01000000
Z12 EQU %00000110
Z34 EQU %00011000
;menu control conf
;j1 vs ia
MODO1_C1 EQU %00000100
MODO1_C2 EQU 0
MODO1_IA EQU %10101000
;j1+j2 vs ia
MODO2_C1 EQU %00100010
MODO2_C2 EQU %00100100	
MODO2_IA EQU %10101000
;j1 vs j2
MODO3_C1 EQU %00000100	
MODO3_C2 EQU %00010000
MODO3_IA EQU 0
;j1+ia vs ia
MODO4_C1 EQU %00100100	
MODO4_C2 EQU 0
MODO4_IA EQU %11101010
;j1+ia vs ia+j2
MODO5_C1 EQU %00100010	
MODO5_C2 EQU %00101000	
MODO5_IA EQU %11010100
;IA vs IA (demo)
MODO6_C1 EQU 0		
MODO6_C2 EQU 0
MODO6_IA EQU %11101011

;menu options
BIT_AUTOBAR1 EQU 0
BIT_AUTOZONE1 EQU 1
BIT_AUTOBAR2 EQU 2
BIT_AUTOZONE2 EQU 3
BIT_MIDLINE EQU 4
BIT_POSESSION EQU 5
BIT_REGS EQU 6
BIT_SOUND EQU 7
;***********************************************************************
;KEYB
;***********************************************************************
TOTAL_KEYBCONFS EQU 5

;INSTRUCCION BIT
INS_BIT0 EQU #47
INS_BIT1 EQU #4F
INS_BIT2 EQU #57
INS_BIT3 EQU #5F
INS_BIT4 EQU #67
INS_BIT5 EQU #6F
INS_BIT6 EQU #77
INS_BIT7 EQU #7F

;MENU
LIN_KEY1 EQU 8	;TECLA 1
BIT_KEY1 EQU 0
LIN_KEY2 EQU 8	;TECLA 2
BIT_KEY2 EQU 1
LIN_KEY3 EQU 7	;TECLA 3
BIT_KEY3 EQU 1
LIN_KEY4 EQU 7	;TECLA 4
BIT_KEY4 EQU 0
LIN_KEY5 EQU 6	;TECLA 5
BIT_KEY5 EQU 1
LIN_KEY6 EQU 6	;TECLA 6
BIT_KEY6 EQU 0
LIN_KEY7 EQU 5	;TECLA 7
BIT_KEY7 EQU 1
LIN_KEY8 EQU 5	;TECLA 8
BIT_KEY8 EQU 0
LIN_KEY9 EQU 4	;TECLA 9
BIT_KEY9 EQU 1
LIN_KEY0 EQU 4	;TECLA 0
BIT_KEY0 EQU 0

LIN_KEYC EQU 7
LIN_KEYV EQU 6
LIN_KEYK EQU 4
LIN_KEYL EQU 4
LIN_KEYS EQU 7
LIN_KEYT EQU 6
LIN_KEYR EQU 6
LIN_KEYE EQU 7

;ESC S N
LIN_EXIT EQU 8	;ESC
BIT_EXIT EQU 2
if LANG_ES
LIN_YES EQU 7		;S
BIT_YES EQU 4
else
LIN_YES EQU 5		;Y
BIT_YES EQU 3
endif
LIN_NO EQU 5		;N
BIT_NO EQU 6
LIN_READY EQU 2	;enter
BIT_READY EQU 2

;SET1 OPQA	
LIN_SET1_UP EQU 8	;Q
BIT_SET1_UP EQU 3
LIN_SET1_DW EQU 8	;A
BIT_SET1_DW EQU 5
LIN_SET1_LF EQU 4	;O
BIT_SET1_LF EQU 2
LIN_SET1_RG EQU 3 	;P
BIT_SET1_RG EQU 3
LIN_SET1_F1 EQU 8	;TAB
BIT_SET1_F1 EQU 4
LIN_SET1_F2 EQU 5	;SPACE
BIT_SET1_F2 EQU 7

;SET2 KEYB NUM
LIN_SET2_UP EQU 2	;F4
BIT_SET2_UP EQU 4
LIN_SET2_DW EQU 1	;F1
BIT_SET2_DW EQU 5
LIN_SET2_LF EQU 1	;F2
BIT_SET2_LF EQU 6
LIN_SET2_RG EQU 0	;F3
BIT_SET2_RG EQU 5
LIN_SET2_F1 EQU 1	;F0
BIT_SET2_F1 EQU 7
LIN_SET2_F2 EQU 0	;F.
BIT_SET2_F2 EQU 7

;***********************************************************************
;ALT MOD INKS
;***********************************************************************
AND_C0 EQU #C0E6
AND_CC EQU #CCE6
XOR_33 EQU #33EE
XOR_C0 EQU #C0EE
XOR_0C EQU #0CEE
XOR_CC EQU #CCEE
XOR_FF EQU #FFEE

;***********************************************************************
;PUNTOS
;***********************************************************************
SHOT_VALUE3 EQU 25
SHOT_VALUE7 EQU 20
SHOT_VALUE9 EQU 15
SHOT_VALUE11 EQU 10
SHOT_VALUE15 EQU 5
MAXPOINTS_MARGIN EQU 5536
MINPOINTS_MARGIN EQU 5
BONUS_VALUE EQU 200
;***********************************************************************
;SCOREBOARD
;***********************************************************************
;index
SCB_INI_REC EQU 1
SCB_TOTAL_REC EQU 15					
;offsets
SCB_NAME_LENG EQU 7					
SCB_OFFSET_PT EQU SCB_NAME_LENG+4			
;chars limit
SCB_CHR_LIMIT_DW EQU 32					
SCB_CHR_LIMIT_UP EQU 97					
;Y
SCB_POSY EQU #38					
SCB_ROW EQU #8						
SCB_LAST_POSY EQU SCB_ROW*SCB_TOTAL_REC+SCB_POSY	
;X
SCB_ARROW_POS_OFFSET EQU 10				
SCB_POSX_RANK EQU #10					
SCB_POSX_NAME EQU #16
SCB_POSX_NAME_LIMIT EQU SCB_NAME_LENG*2+SCB_POSX_NAME
SCB_POSX_ICO EQU #29
SCB_POSX_BALLS EQU #2C
SCB_POSX_SCORE EQU #36

;***********************************************************************
;STRING POS
;***********************************************************************
;MENU SCREEN
;col1
MENU_STR0A_POS EQU #0088
MENU_STR1A_POS EQU #0090
MENU_STR2A_POS EQU #0098
MENU_STR3A_POS EQU #00A0
MENU_STR4A_POS EQU #00A8
MENU_STR5A_POS EQU #00B0
;col2
MENU_STR0B_POS EQU #1E88
MENU_STR1B_POS EQU #1E90
MENU_STR2B_POS EQU #1E98
MENU_STR3B_POS EQU #1EA0
MENU_STR4B_POS EQU #1EA8
MENU_STR5B_POS EQU #1EB0
;col3
MENU_STR0C_POS EQU #3888
MENU_STR1C_POS EQU #3890
MENU_STR2C_POS EQU #3898
MENU_STR3C_POS EQU #38A0
MENU_STR4C_POS EQU #38A8
MENU_STR5C_POS EQU #38B0

MENU_SCORE_VALUE1_STR_POS EQU #2318
MENU_SCORE_MINUS_STR_POS EQU #2718
MENU_SCORE_VALUE2_STR_POS EQU #2918
;MENU_VICT_STR_POS EQU #2070			;cambia con lenguaje ver abajo
MENU_MODO_STR1A_POS EQU #1A28
MENU_MODO_STR1B_POS EQU #1E28
MENU_MODOVS_STR_POS EQU #2628
MENU_MODO_STR2A_POS EQU #2C28
MENU_MODO_STR2B_POS EQU #2E28
MENU_BALLS_STR_POS EQU #2878
MENU_ICO_STR_POS EQU #2578

MENU_NREGS_STR_POS EQU #46A8

;CTRLJ1_TITLE_POS EQU #0218			;cambia con lenguaje ver abajo
CTRLJ1_INTER_POS EQU #0628
CTRLJ1_SET_POS EQU #0E28
CTRLJ1_DESC1_POS EQU #0238
CTRLJ1_DESC2_POS EQU #0240
CTRLJ1_DESC3_POS EQU #0248
CTRLJ1_DESC4_POS EQU #0250
CTRLJ1_DESC5_POS EQU #0258
CTRLJ1_DESC6_POS EQU #0060
CTRLJ1_VALUE1_POS EQU #0A38

;CTRLJ2_TITLE_POS EQU #3C18			;cambia con lenguaje ver abajo
CTRLJ2_INTER_POS EQU #4028
CTRLJ2_SET_POS EQU #4828
CTRLJ2_DESC1_POS EQU #3C38
CTRLJ2_DESC2_POS EQU #3C40
CTRLJ2_DESC3_POS EQU #3C48
CTRLJ2_DESC4_POS EQU #3C50
CTRLJ2_DESC5_POS EQU #3C58
CTRLJ2_DESC6_POS EQU #3A60
CTRLJ2_VALUE1_POS EQU #4438

ARROW1_POS EQU #0028	
ARROW2_POS EQU #1428	
ARROW3_POS EQU #3A28	
ARROW4_POS EQU #4E28	
ARROW5_POS EQU #1828	
ARROW6_POS EQU #3628	
ARROW7_POS EQU #1C70	
ARROW8_POS EQU #3270	
ARROW9_POS EQU #1C78	
ARROW10_POS EQU #3278	
ARROW11_POS EQU #1848	
ARROW12_POS EQU #3648	

TIMESTAMP_STR_POS EQU #23C0
BOARD_ICO_BALL_STR_POS EQU #4903

;WAITING SCREEN
ZONE1_STR_POS EQU #0C76
ZONE2_STR_POS EQU #2976
ZONE12_STR_POS EQU #2476
ZONE3_STR_POS EQU #3028
ZONE4_STR_POS EQU #2128
ZONE34_STR_POS EQU #2428
if ROM
PRESS_MSG_STR_POS EQU #1370
else
PRESS_MSG_STR_POS EQU #13A0
endif
ESC_MSG_STR_POS EQU #0003
HISCORE_STR_POS EQU #02C0
POINTS1_STR_POS EQU #44C0
;POINTS2_STR_POS EQU #44C0	;no usado

;GAME SCREEN
SCORE_DESC1_STR_POS EQU #0203
SCORE_VALUE1_STR_POS EQU #0803
SCORE_MINUS_STR_POS EQU #0C03
SCORE_VALUE2_STR_POS EQU #0E03
SCORE_DESC2_STR_POS EQU #1403
BOARD_BALLS_STR_POS EQU #4C03
MAIN_MSG_STR_POS EQU #38C0
COUNTDOWN_STR_POS EQU #4CC0
POSESSION_STR_POS EQU #03C0

;RECORDS SCREEN
SCOREBOARD_RANK_STR_POS EQU #0E28
SCOREBOARD_NAME_STR_POS EQU #1628
SCOREBOARD_USED_STR_POS EQU #2628
SCOREBOARD_SCORE_STR_POS EQU #3628

;credits
AUTHOR_STR_POS EQU #1B38
COPYRIGHT_STR_POS EQU #2048
MEMORY2_STR_POS EQU #1478
THANKS3_STR_POS EQU #17B8

;posiciones que cambian con el lenguaje
if LANG_ES
MENU_VICT_STR_POS EQU #2070
CTRLJ1_TITLE_POS EQU #0218
CTRLJ2_TITLE_POS EQU #3C18
SCOREBOARD_DESC1_STR_POS EQU #1AB4
SCOREBOARD_DESC2_STR_POS EQU #04C0
SCOREBOARD_DESC3_STR_POS EQU #13B4
SCOREBOARD_DESC4_STR_POS EQU #15C0
SCOREBOARD_DESC5_STR_POS EQU #0CC0
BY_STR_POS EQU #2528
MEMORY1_STR_POS EQU #1B68
THANKS1_STR_POS EQU #0498
THANKS2_STR_POS EQU #02A0
else
MENU_VICT_STR_POS EQU #2170
CTRLJ1_TITLE_POS EQU #0318
CTRLJ2_TITLE_POS EQU #3D18
SCOREBOARD_DESC1_STR_POS EQU #1CB4
SCOREBOARD_DESC2_STR_POS EQU #04C0
SCOREBOARD_DESC3_STR_POS EQU #13B4
SCOREBOARD_DESC4_STR_POS EQU #17C0
SCOREBOARD_DESC5_STR_POS EQU #0FC0
BY_STR_POS EQU #2628
MEMORY1_STR_POS EQU #1C68
THANKS1_STR_POS EQU #0498
THANKS2_STR_POS EQU #08A0
endif

;***********************************************************************
;SPRITE SCR ADDR
;***********************************************************************
HAND_PT1_SPR_SCRADDR EQU #C739
HAND_DF1_SPR_SCRADDR EQU #C741
HAND_MD1_SPR_SCRADDR EQU #C751
HAND_DL1_SPR_SCRADDR EQU #C761
HAND_PT2_SPR_SCRADDR EQU #C042
HAND_DF2_SPR_SCRADDR EQU #C03A
HAND_MD2_SPR_SCRADDR EQU #C02A
HAND_DL2_SPR_SCRADDR EQU #C01A

DICE_SPR_SCRADDR_H EQU #C0
DICE1_SPR_SCRADDR_L EQU #28
DICE2_SPR_SCRADDR_L EQU #40

EQUIP1_NECK_SPR_SCRADDR EQU #F24E
EQUIP2_NECK_SPR_SCRADDR EQU #F25C
EQUIP1_ARML_SPR_SCRADDR EQU #C29B
EQUIP1_ARMR_SPR_SCRADDR EQU #C2A4
EQUIP2_ARML_SPR_SCRADDR EQU #C2A9
EQUIP2_ARMR_SPR_SCRADDR EQU #C2B2
EQUIP1_LEGL_SPR_SCRADDR EQU #D33C
EQUIP1_LEGR_SPR_SCRADDR EQU #D343
EQUIP2_LEGL_SPR_SCRADDR EQU #D34A
EQUIP2_LEGR_SPR_SCRADDR EQU #D351	
EQUIP1_LEGC_SPR_SCRADDR EQU #D390
EQUIP2_LEGC_SPR_SCRADDR EQU #D39E

BOARD_BLKTOP_SPR_SCRADDR EQU #C0F6
BOARD_BLKBTM_SPR_SCRADDR EQU #C6E0
BOARD_BLKLFT_SPR_SCRADDR EQU #C146
BOARD_BLKRGT_SPR_SCRADDR EQU #C187
BOARD_LEG1_SPR_SCRADDR EQU #C733
BOARD_LEG2_SPR_SCRADDR EQU #C777
BOARD_LATA_SPR_SCRADDR EQU #C0F0