;***********************************************************************
;BALL INT
;***********************************************************************
.ball_init:
	ld a,%00001000			;bit ball area
	ld (ball_area),a		;set
	ld a,(bxd)			;dir x (ultimo valor conocido)
	ld d,a				;dir x 
	call drop3			;act.valores de inicio	(sacar de centro)
	jp back_buffer_addr		;modificar addr del buffer

;***********************************************************************
;MOVE
;***********************************************************************
.ball_count:
	ld a,(bxic+1):dec a:ld (bxic+1),a	;decrementa 1 por frame
	ld a,(byic+1):dec a:ld (byic+1),a	;decrementa 1 por frame
	ret
.bmovex:	;requiere H (bx)
	ld a,(bxi)			;a=velox
	.bxic:cp MAX_BXI		;comparar con contador (variable decrementndose)
	ret c				;si es menor, salir
	xor a				;reset contador (0)
	ld (bxic+1),a			;auto-modificar
	;ACTUALIZAR X
	ld a,(bxd)			;dir x
	add h				;bxd+bx
	ld (bx),a			;act.bx
	ret
.bmovey:	;requiere L (by)	;lo mismo que x
	ld a,(byi)
	.byic:cp MAX_BYI
	ret c
	xor a
	ld (byic+1),a	
	;ACTUALIZAR Y
	ld a,(byd)			;dir y
	add l				;byd+by
	ld (by),a			;act.by
	ret
;***********************************************************************
;CHECKS
;***********************************************************************
.goals:		;requiere H,L (bx,by)	;comprobar franjas x y
	ld a,h				;x
	cp LIMIT_LF-1:jr c,check1
	cp LIMIT_RG+1:jr nc,check2
	ld a,l				;y
	cp GOAL_UP+1:jr c,bposx
	cp GOAL_DW-1:jr nc,bposx
	ret
.check1:	;requiere A,L (bx,by)	;comprueba porteria izq
	cp GOAL_LF:jr c,box1		;x
 	ld a,l				;y
 	cp GOAL_UP:jr c,box1
 	cp GOAL_DW:jr nc,box1
 	ret
.check2:	;requiere A,L (bx,by)	;comprueba porteria dcha
	cp GOAL_RG:jr nc,box2		;x
  	ld a,l				;y
  	cp GOAL_UP:jr c,box2
  	cp GOAL_DW:jr nc,box2
 	ret
 	
.bposx:		;requiere H (bx)		;comprobar lmites pos x
 	ld a,h					;x
 	cp LIMIT_LF:jr c,brbx			;en limite izq?
 	cp LIMIT_RG:jr nc,blbx			;en limite dcho?
	ret
.brbx:ld a,(bxd):cp #01:ret z:jr wall_negx	;si dir dcha salir, sino choca
.blbx:ld a,(bxd):cp #FF:ret z:;jr wall_negx	;si dir izq salir, sino choca
.wall_negx:neg:ld (bxd),a:
	if REG
	call event_cancel
	endif
	jp snd_wall

.bposy:		;requiere L (by)		;comprobar limites pos y
	ld a,l					;y
	cp LIMIT_UP:jr c,bdby			;lo mismo que x
	cp LIMIT_DW:jr nc,buby
 	ret
.bdby:ld a,(byd):cp #01:ret z:jr wall_negy
.buby:ld a,(byd):cp #FF:ret z:;jr wall_negy
.wall_negy:neg:ld (byd),a:jp snd_wall

;***********************************************************************
;IN / DROP
;***********************************************************************
.box1:					;gol en porteria izq
	call snd_box			;sonido bola en porteria
	call posession_reset		;rset timepo de posesion
	ld a,(options)			;leer opciones menu
	bit BIT_MIDLINE,a:jr nz,goal1	;si no hay media ir a goal
	ld e,1				;porteria 1
	ld a,(last_touch)		;si ultimo toque
	bit BIT_MD2,a			;media del equipo 2
	jr nz,foul			;falta
					;si no, contina goal
.goal1:
	call inc_score2			;actualizar marcador
	call toma			;bocadillo IA izq
	call check_balls		;checkear bolas / fin partido
	call points_checkmax		;checkear maximos puntos
	if REG
	ld a,#ff			;registrar un gol en la tabla de datos IA
	call event_pass
	endif
					;continua drop
.drop1:					;resetear posicion de saque la bola
	ld hl,RES1_POS			;pos
	ld de,DIR_RGUP			;dir
	ld bc,RES1_DEV			;deviation (velo)
	jr ball_drop			;act. vars
;----------------------------------------------------------------------------	
.box2:					;gol en porteria dcha (lo mismo que izq)
	call snd_box
	call posession_reset
	ld a,(options)
	bit BIT_MIDLINE,a:jr nz,goal2
	ld e,2
	ld a,(last_touch)
	bit BIT_MD1,a
	jr nz,foul
.goal2:
	goal2_value:			;puntos (solo porteria dcha)
	ld de,0				;variable puntos
	call print_points1		;mostrar puntos
	call inc_score1
	call ouch			;bocadillo IA dcha
	call check_balls
	call points_checkmax
	if REG
	ld a,#ff
	call event_pass
	endif
.drop2:
	ld hl,RES2_POS
	ld de,DIR_LFDW
	ld bc,RES2_DEV
	jr ball_drop	;act. vars
;----------------------------------------------------------------------------	
.drop3: ;D (dir x)		;saque de centro
	ld hl,INI_POS			;pos xy de inicio de partido
	ld e,INI_DIRY			;dir y
	ld bc,INI_DEV			;velo xy
.ball_drop:				;nuevos valores 16bits
	ld (bxy),hl			;pos xy
	ld (bxyd),de			;dir xy
	ld (bxyi),bc			;velo xy
	ld a,1
	ld (allow+1),a			;permitir toques
	ret
;----------------------------------------------------------------------------	
.foul:	;D,E (dir x, drop)
	push de			;preservar saque E / dir D
	ld hl,str_foul		;string
	call print_msg		;mostrar falta
	call posession_reset
	pop de			;recuperar saque/dir
	ld a,e			;determinar donde saca
	cp 1:jr z,drop1
	cp 2:jr z,drop2
	cp 3:jr z,drop3
	ret
;***********************************************************************
; SHOW
;***********************************************************************
;routine based on techniques of Prodatron
;www.amstrad.es/forum/viewtopic.php?t=161&start=45
.show_ball:
	call find_ball			;convertir pos en addr
	push hl				;preservar scr addr
	;---------------------------------
	;scr>mem buffer
		ld a,5			;repetir bucle (altura)
		ld de,back_buffer	;apuntar a buffer
		.read_scr_lp:		;bucle
		ldi:ldi			;guardar buffer, pixel izq/dcho
		dec a			;decrementar alto
		jr z,end_read_scr	;si zero, terminar bucle
		ld bc,#7fe		;salto sig. linea
		add hl,bc		;aadir linea y comprobar acarreo
		jr nc,read_scr_lp	;si no hay carry, bucle
		ld bc,#c050		;salto sig. bloque de lineas
		add hl,bc		;aadir bloque
		jr read_scr_lp		;bucle
	;---------------------------------
	.end_read_scr:
	pop hl				;recuperar scr addr
	;---------------------------------
	;mem>scr
		ld a,5			;repetir bucle (altura)
		ld de,ball_spr		;apuntar a sprite
		.write_scr_lp:		;bucle
		ex de,hl		;intercambiar regs.
		ex af,af'		;preservar alto
		call draw_ball		;comprobar pixel izq
		call draw_ball		;comprobar pixel dch
		ex af,af'		;recuperar alto
		dec a			;decrementar alto
		ret z			;si zero, terminar bucle
		ld bc,#7fe		;salto sig. linea
		ex de,hl		;intercambiar regs.
		add hl,bc		;aadir linea y comprobar acarreo
		jr nc,write_scr_lp	;si no hay carry, bucle
		ld bc,#c050		;salto sig. bloque de lineas
		add hl,bc		;aadir bloque
		jr write_scr_lp		;bucle

;----------------------------------------------------------------------------------
.draw_ball:	;DE (scr addr)		;pintar pixel
	ld a,(de)			;scr pixel en A
	cp BACKCOLOR1:jr z,ball_scr	;si es el color de fondo deseado
	cp BACKCOLOR2:jr z,ball_scr
	cp BACKCOLOR3:jr z,ball_scr
	cp BACKCOLOR4:jr z,ball_scr
	cp BACKCOLOR5:jr z,ball_scr
	;cp BACKCOLOR6:;jr z,ball_scr
	inc hl				;si no, solo incrementa punteros
	inc de
	ret
.ball_scr:ldi:ret			;pinta e incrementa punteros

;***********************************************************************
;POSESSION - BALL AREA - TOUCH BALL - SHOT
;***********************************************************************
;convierte ball posx en bit area
.null_area:
	xor a
	ld (ball_area),a
	ret

.check_ball_area:
	ld b,1			;iniciar byte en 1 (bit 0)
	ld a,(bx)		;ballx
	cp LIMIT_LF:jr c,null_area	;si esta fuera de areas salir
	cp LIMIT_RG:jr nc,null_area
	ld c,a			;ballx a C
	ld a,#6			;iniciar areax	
	.next_area_lp
	cp #26:jr nz,no_inc_pix	
	inc a			;aadir un pixel al cambiar de campo para que sea simtrico
	.no_inc_pix:
	rrc b			;gira byte a la dcha (bit 7,6,5...)
	add #8			;offset siguiente area
	cp c			;si areax es menor que ballx
	jr c,next_area_lp	;entonces siguiente area
				;sino el bit area pasa a set_ball_area
.set_ball_area:	;B (bit value)
	ld a,(ball_area)
	cp b:ret z		;si ultimo y nuevo son iguales, salir
	ld c,a			;guardar ultimo
	ld a,b			;guardar nuevo
	ld (ball_area),a	
	;--posession--
	ld a,c			;cargar ultimo
	and %10000001		;alterar flag porteros
	ret nz			;si el ultimo son porteros, no resetear posesion
	ld a,b			;cargar nuevo
	and %01111110		;alterar flag del resto de figuras
	ret z			;si zero, no resetear posesion
	jp posession_reset	;resetear posesion
;----------------------------------------------------------------------------------
.touch_ball:
	ld a,(byd)	;determinar direccion vertical de la bola
	cp #ff
	jr z,touch_up
	jr nz,touch_dw
	
	.touch_up:		;si la bola va hacia arriba
	ld a,#13		;modificar lectura del buffer hacia abajo (inc de)
	ld de,back_buffer	;empezar por arriba
	jr touch

	.touch_dw:		;si la bola va hacia abajo
	ld a,#1B		;modificar lectura del buffer hacia arriba (dec de)
	ld de,back_buffer+8	;empezar por abajo
	jr touch		;no necesario pero vamos a dejarlo para que tarde lo mismo
	
.touch:	;A, DE (inc/dec, buffer) 
	ld (touch_dir),a				;modificar rutina (inc de/dec de)
	ld a,8						;repetir bucle (pixels)
	ld (pixel_count+1),a				;y resetear contador pixels (8)
 	.touch_ball_lp:
 	ex af,af'					;guardar contador bucle
 		.allow:					;permitir toques
 		ld c,1					;variable
 		bit 0,c:call z,allow_color		;comprobar permitir toques si C=0
		bit 0,c:call nz,touch_color		;detectar toques si C=1
		ld a,(de)				;pixel del buffer en A
		cp CLR_SHOT1:jr z,shot			;si detecta shot salir del bucle (jr)
		cp CLR_SHOT2:jr z,shot			;shot destruye A,BC,DE,HL
		cp CLR_SHOT3:jr z,shot
		cp CLR_SHOT4:jr z,shot
		;cp CLR_SHOT5:;jr z,shot
		;cp CLR_SHOT6:;jr z,shot
	.touch_dir:
	inc de						;siguiente pixel del buffer (inc o dec)
	ex af,af'					;recuperar contador bucle
	dec a						;decrementar contador bucle
	jr nz,touch_ball_lp				;bucle si nozero
	ret
;----------------------------------------------------------------------------------
.allow_color:	;DE (buffer)
	ld a,(de)			;pixel del buffer en A
	cp CLR_COVER1_LF:ret z		;si detecta color de toque fuera (no permitir mas toques)
	cp CLR_COVER1_RG:ret z
	cp CLR_COVER2_LF:ret z
	cp CLR_COVER2_RG:ret z
	cp CLR_EDGE1_UP:ret z
	cp CLR_EDGE1_DW:ret z
	cp CLR_EDGE2_UP:ret z
	cp CLR_EDGE2_DW:ret z
	.pixel_count:		;si no detecta ningun color comprobar cuantos pixels lleva y permitir toques
	ld a,8:dec a:ld (pixel_count+1),a	;decrementa variable contador pixels
	or a:ret nz				;si nozero fuera
	inc a:ld (allow+1),a			;si zero, permite toques	
	ld c,a					;(A=C=1)
	ret
;---------------------------------------------------------------------------------
;comprobar disparos
.shot:
	ld hl,(c_shot)				;shot team1/team2
	ld a,(ball_area)			;comparar con area
	cp h:jr z,shot1
	cp l:jr z,shot2
	ret
.shot2:
	ld a,SHOT2_DIRX				;dir
	jr set_shot
	
.shot1:
	ld de,SHOT_VALUE7			;puntos team1
	call print_points1			;sumar y mostrar
	ld a,SHOT1_DIRX				;dir
	;jr set_shot

.set_shot:	;A (dirx)
	ld (bxd),a				;cambiar dir
	ld a,SHOT_DEVX
	ld (bxi),a				;velo
	call dec_y_dev
	call allow0				;premitir toques,last_touch,regs
	if REG
	call regia_get
	endif
	call snd_shot			;DESTRUYE A,BC,HL,DE
	jr shot_reset

.shot_count:				;contador timeout
	ld a,0				;variable contador
	inc a
	ld (shot_count+1),a		;automodificar
	cp 1:ret z			;frame 1? salir
	cp SHOT_TIMEOUT:ret c		;si es menor salir
.shot_reset:				;resetear contador, ctrl shot
	xor a
	ld (shot_count+1),a
	ld (c1_shot),a
	ld (c2_shot),a
	ret
;----------------------------------------------------------------------------------	
;determinar tipo de toque segun color
.touch_color:	;DE (buffer)	;buscar color
	ld a,(de)
	cp CLR_COVER1_LF:jr z,cover	;J1 B
	cp CLR_COVER1_RG:jr z,cover	;J1 C
	cp CLR_COVER2_LF:jr z,cover	;J2 B
	cp CLR_COVER2_RG:jr z,cover	;J2 C
	cp CLR_DRAG_LF:jr z,drag_lf	;J1/J2
	cp CLR_DRAG_RG:jr z,drag_rg	;J1/J2
	cp CLR_EDGE1_UP:jr z,edge1_up	;J1 up
	cp CLR_EDGE1_DW:jr z,edge1_dw	;J1 dw
	cp CLR_EDGE2_UP:jr z,edge2_up	;J2 up
	cp CLR_EDGE2_DW:jr z,edge2_dw	;J2 dw	
	ret

;volores de direccin de la bola segn color
.edge1_up:ld hl,DIR_RGUP:jr set_dirXY
.edge1_dw:ld hl,DIR_RGDW:jr set_dirXY				
.drag_lf:ld a,1:jr set_dirX	
.edge2_up:ld hl,DIR_LFUP:jr set_dirXY				
.edge2_dw:ld hl,DIR_LFDW:jr set_dirXY
.drag_rg:ld a,-1:jr set_dirX	

;cambia de direccin y decrementa/incrementa velocidades
.cover:
	ld a,(bxd):neg:ld (bxd),a
	call dec_x_dev
	call inc_y_dev
	jr allow0

.set_dirX:	;A (dirx)
	ld (bxd),a
	call rnd_dec_x_dev
	jr inc_y_dev
	
.set_dirXY:	;HL (dirxy)
	ld (bxyd),hl					;grabar dir xy 16bits
	:ld a,(bxi):cp MAX_BXI:call z,inc_y_dev:	;comprobar max.velo e incrementar velo y
	call rnd_dec_x_dev 				;decrementar velo x con random
	;;;continua allow0
.allow0:
	xor a:ld (allow+1),a		;no permitir ms toques hasta que vuelva a detectar
	
	ld a,(ball_area)		;cargar area
	if REG
	;or a:;jr z,event_pass		;si el area es null grabar 0 en el evento
	or a:jr z,null_area_event	;si el area es null registrar evento como gol
	ld (last_touch),a		;sino, copiar area a ultimo toque
	jr event_pass			;y registrar evento
	
	.null_area_event:
	ld a,#ff			;anotar como gol, aunque puede que el portero lo pare
	jr event_pass			;registrar evento
	
	else				;si el codigo REGIA esta desactivado
	or a:ret z			;un null area no
	ld (last_touch),a		; grabar ltimo toque
	ret
	endif


.inc_x_dev:ld a,(bxi):cp MAX_BXI:ret nc:inc a:jr x_dev
.dec_x_dev:ld a,(bxi):dec a:cp MIN_BXI:ret c:;jr x_dev
.x_dev::ld (bxi),a:ret

.inc_y_dev:ld a,(byi):cp MAX_BYI:ret nc:inc a:jr y_dev
.dec_y_dev:ld a,(byi):dec a:cp MIN_BYI:ret c::;jr y_dev
.y_dev:ld (byi),a:ret


.rnd_dec_x_dev:
	call random
	and 3		;frenar bola random
	add 3		;aadir ms frenada

	ld b,a		;rnd num
	ld a,(bxi)	;velo
	sub b		;restar rnd a velo
	
	cp MIN_BXI:	;si resta
	jr nc,x_dev	;es mayor o igual que min velo, grabar velo
	ret

;----------------------------------------------------------------------------------
;num_aleat_z by Ral Simarro
;www.amstrad.es/forum/viewtopic.php?t=296
.random ;number	out B
	ld a,r
	or #81
	and #0F			;reducir el buclea la mitad 
	ld b,a
	ld a,r
	or #80
	random_lp
	adc a
	djnz random_lp
	ret
;***********************************************************************
;REG DATA
;***********************************************************************	
if REG
;guarda dato en el puntero de event
.event_pass:	;A (ball_area)
	ret			;nop/ret paso de rutina (modificacion)
	ld b,a			;area a grabar
	.event:
	ld hl,#3000		;variable (addr del valor a guardar)
	ld a,(hl):cp #ff	;si el contenido fue gol (#ff)
	jr z,event_cancel	;cancelar evento
	ld (hl),b		;si no, grabar el area
				;y continuar cancelando evento
.event_cancel:
	ld a,#c9		;ret
	ld (event_pass),a	;modificar rutina
	ret

;combina bally con la columna correspondiente al area
;y graba el puntero en una variable, es decir event=columnarea,bally
;ej. PT1 = #37,bally , DF1 = #36,bally ... PT2 = #30,bally
.regia_get:
	ld a,(by)		;bally (fila de datos)
	ld l,a
	ld h,#30		;empezar en #3000
	ld de,#100		;offset columna de datos
	ld a,(ball_area)
	regia_get_lp
	bit 0,a			;comprobar bit area
	jr nz,regia_set		;si nozero, ir grabar puntero evento
	add hl,de		;aadir offset siguiente columna
	rra			;girar bits sig.area
	or a			;comprobar 0
	jr nz,regia_get_lp	;bucle si nozero
	ret
	
.regia_set
	ld (event+1),hl		;registrar donde debe grabar el evento (puntero)
	xor a			;nop
	ld (event_pass),a	;modificar rutina con nop
	ret
	
;borra todos los eventos grabados
.regia_clear
	ld a,(modo)		;cargar modo de juego
	cp 6:ret z		;si es IA vs IA salir y no borra nada
	ld a,(options)		;cargar opciones de menu
	bit BIT_REGS,a:ret nz	;si la opcion REGS esta activada salir y no borra nada
	ld bc,#800		;bytes a borrar
	ld hl,#2FFF		;empieza en #2fff cuyo contenido es 0
	ld de,#3000		;y copia delante
	ldir			;borrar
	ret
endif