;***********************************************************************
;CONTROL J1
;***********************************************************************
.controlUD1:
	ld a,(c1_zone)				;cargar bits ctrl
	or a:ret z				;si zero salir
	ld d,a					;pasar ctrl a D
	ld a,(bx):ld e,a			;guardar bx en E
	call c1_autobar				;ir a autobar
	call c1_autozone
	ld a,(c1_zone)
	ld d,a					;pasar ctrl a D
	;check keyb buffer
	;-------------------
	call control1c
	.control1a:ld a,(keyb_buffer+LIN_SET1_LF):bit BIT_SET1_LF,a:jr z,c1_moveleft
	.control1b:ld a,(keyb_buffer+LIN_SET1_RG):bit BIT_SET1_RG,a:jr z,c1_moveright
	.control1e:ld a,(keyb_buffer+LIN_SET1_F1):bit BIT_SET1_F1,a:jp z,c1_alterbar
	.control1f:ld a,(keyb_buffer+LIN_SET1_F2):bit BIT_SET1_F2,a:jp z,c1_alterzone
	ld a,d::and RESPRESS:ld (c1_zone),a:ret	;res pressed
	.control1c:ld a,(keyb_buffer+LIN_SET1_UP):bit BIT_SET1_UP,a:jr z,c1_moveup
	.control1d:ld a,(keyb_buffer+LIN_SET1_DW):bit BIT_SET1_DW,a:jr z,c1_movedown	
	ret
.c1_moveup:	;D
	bit BIT_Z1,d:jp nz,moveupZone1
	bit BIT_Z2,d:jp nz,moveupZone2
	ret
.c1_movedown:	;D
	bit BIT_Z1,d:jp nz,movedownZone1
	bit BIT_Z2,d:jp nz,movedownZone2
	ret	
.c1_moveleft:	;D
	bit BIT_Z1,d:jp nz,moveleftZone1
	bit BIT_Z2,d:jp nz,moveleftZone2
	ret
.c1_moveright:	;D
	bit BIT_Z1,d:jp nz,moverightZone1
	bit BIT_Z2,d:jp nz,moverightZone2
	ret
;------------------------------------------------------------------------------
.c1_autoZone:	;D,E	(c1_zone, bx)
	nop
	bit BIT_J2,d:ret nz			;compaero?
	bit BIT_PRESSED2,d:ret nz		;pressed?
	ld a,e					;A=ballx
	cp AREA5-1:jr c,c1_z1
	cp AREA5-1:jr nc,c1_z2
	ret
	
.c1_autobar:	;D,E	(c1_zone, bx)
	nop					;nop/ret mod. hab./deshab. autobar
	bit BIT_PRESSED1,d:ret nz		;pressed?
	ld a,e					;A=ballx
	bit BIT_Z2,d:jr nz,c1_autoz2		;z2?
	.c1_autoz1:				;z1
	cp AREA7-1: jr c,c1_altbar0
	cp AREA0-2: jr c,c1_altbar1
	.c1_autoz2:				;z2
	cp AREA3-1: jr c,c1_altbar0		
	cp AREA0-2: jr c,c1_altbar1
	ret
	
	.c1_z1:bit BIT_Z1,d:ret nz:ld a,d:jr c1_xor_zone
	.c1_z2:bit BIT_Z2,d:ret nz:ld a,d::jr c1_xor_zone
	.c1_altbar0:bit BIT_ALTBAR,d:ret z:ld a,d:xor ALTBAR:jr c1_set_zone	;xor altbar
	.c1_altbar1:bit BIT_ALTBAR,d:ret nz:ld a,d:xor ALTBAR:;jr c1_set_zone	;xor altbar
	.c1_set_zone:ld (c1_zone),a:ret					;set c1
	
.c1_alterbar:	;D (c_zone)
	ld a,d
	bit BIT_PRESSED1,a:ret nz	;pressed?
	xor PRESSALTBAR
	jr c1_set_zone			;xor pressed+altbar

.c1_alterzone:	;D (c_zone)
	ld a,d
	bit BIT_PRESSED2,a:ret nz	;pressed?
	xor PRESSED2			;pressed
	call c1_set_zone		
	bit BIT_J2,a:ret nz		;compaero?
.c1_xor_zone:	;A (c_zone)
	xor Z12				;cambiar de zona
	;jr c1_hands_hdle
.c1_hands_hdle:	;A (c_zone)		;solo c1
	ld (c1_zone),a
	bit BIT_Z1,a:jr nz,hands_z1_hdle			;
	bit BIT_Z2,a:jr nz,hands_z2_hdle			;
	ret
.c1_hands:	;A (c_zone)		;hands en el inicio ia1/c1
	bit BIT_Z1,a:jr nz,hands_z1
	bit BIT_Z2,a:jr nz,hands_z2
	ret
;------------------------------------------------------------------------------
;manos y mangos (ia1, c1, c2)
;zona 1
.hands_z1_hdle:			;pintar mangos en z2
	ld b,HDLE_Z2_BIT	;md1/dl1
	call handle_tables	
.hands_z1:			;pintar manos en z1
	ld b,PT1_BIT		;pt1
	call autohand
	ld b,DF1_BIT		;df1
	jp autohand
;zona 2
.hands_z2_hdle:			
 	ld b,HDLE_Z1_BIT	;pintar mangos en z1
 	call handle_tables	;pt1/df1
.hands_z2:
	ld b,MD1_BIT		;pintar manos en z2
	call autohand		;md1
	ld b,DL1_BIT
	jp autohand		;dl1
;###################################################################
;###################################################################
;###################################################################
;---------------------------------PT1-------------------------------
.moveleft_pt1:
	ld a,(p1x1):cp MOVE_BACK_LIMIT:ret c		;comprobar anim figura
	dec a						;dec anim
	ld (p1x1),a					;guardar anim
	ld b,PT1_BIT					;bit shot/hand
	call choose1_spr				;requiere A,B (anim,bit value) -- out HL (sprite)
	ld (choose_pt1+1),hl				;mod. sprite addr
	call hand_back					;mover mano - requiere B (hand bit)
	jr show_pt1					;ir a guardar show move
.moveright_pt1:
	ld a,(p1x1):cp MOVE_FORW_LIMIT:ret nc		;comprobar anim figura
	inc a						;inc anim
	ld (p1x1),a
	ld b,PT1_BIT					
	call choose1_spr
	ld (choose_pt1+1),hl
	call hand_forw
	jr show_pt1
.moveup_pt1:
	ld a,PT_LIMIT_UP				;limit
	ld hl,(pt1_pos)					;pos
	cp l						;si limit es igual posy
	ret z						;salir
.doup_pt1:
	dec l						;dec posy
	ld (pt1_pos),hl					;guardar posy
	jr show_pt1					;ir a guardar show move
.movedown_pt1:
	ld a,PT_LIMIT_DW		
	ld hl,(pt1_pos)
	cp l
	ret z
.dodown_pt1:
	inc l						;inc posy
	ld (pt1_pos),hl
	;jr show_pt1
.show_pt1:ld a,(show_move):bit BIT_PT1,a:ret nz:set BIT_PT1,a:ld (show_move),a:xor a:ret 	;guardar si zero
;###################################################################
.moveleftZone1:bit BIT_ALTBAR,d:jr z,moveleft_pt1:jr nz,moveleft_df1
.moverightZone1:bit BIT_ALTBAR,d:jr z,moveright_pt1:jr nz,moveright_df1
.moveupZone1:bit BIT_ALTBAR,d:jr z,moveup_pt1:jr nz,moveup_df1
.movedownZone1:bit BIT_ALTBAR,d:jr z,movedown_pt1:jr nz,movedown_df1
;###################################################################
;---------------------------------DF1----------------------------------
.moveleft_df1:
	ld a,(p1x2):cp MOVE_BACK_LIMIT:ret c
	dec a
	ld (p1x2),a
	ld b,DF1_BIT
	call choose1_spr
	ld (choose_df1+1),hl
	call hand_back
	jr show_df1
.moveright_df1:
	ld a,(p1x2):cp MOVE_FORW_LIMIT:ret nc
	inc a
	ld (p1x2),a
	ld b,DF1_BIT
	call choose1_spr
	ld (choose_df1+1),hl
	call hand_forw
	jr show_df1
.moveup_df1:
	ld a,DF_LIMIT_UP
	ld hl,(df1_pos)
	cp l
	ret z
.doup_df1:
	dec l
	ld (df1_pos),hl
	jr show_df1
.movedown_df1:
	ld a,DF_LIMIT_DW		
	ld hl,(df1_pos)
	cp l
	ret z
.dodown_df1:
	inc l
	ld (df1_pos),hl
	;jr show_df1
.show_df1:ld a,(show_move):bit BIT_DF1,a:ret nz:set BIT_DF1,a:ld (show_move),a:xor a:ret

;---------------------------------MD1----------------------------------
.moveleft_md1:
	ld a,(p1x3):cp MOVE_BACK_LIMIT:ret c
	dec a
	ld (p1x3),a
	ld b,MD1_BIT
	call choose1_spr
	ld (choose_md1+1),hl
	call hand_back
	jr show_md1
.moveright_md1:
	ld a,(p1x3):cp MOVE_FORW_LIMIT:ret nc
	inc a
	ld (p1x3),a
	ld b,MD1_BIT
	call choose1_spr
	ld (choose_md1+1),hl
	call hand_forw
	jr show_md1
.moveup_md1:
	ld a,MD_LIMIT_UP
	ld hl,(md1_pos)
	cp l
	ret z
.doup_md1:
	dec l
	ld (md1_pos),hl
	jr show_md1
.movedown_md1:
	ld a,MD_LIMIT_DW		
	ld hl,(md1_pos)
	cp l
	ret z
.dodown_md1:
	inc l
	ld (md1_pos),hl
	;jr show_md1
.show_md1:ld a,(show_move):bit BIT_MD1,a:ret nz:set BIT_MD1,a:ld (show_move),a:xor a:ret

;###################################################################
.moveleftZone2:bit BIT_ALTBAR,d:jr z,moveleft_md1:jr nz,moveleft_dl1
.moverightZone2:bit BIT_ALTBAR,d:jr z,moveright_md1:jr nz,moveright_dl1
.moveupZone2:bit BIT_ALTBAR,d:jr z,moveup_md1:jr nz,moveup_dl1
.movedownZone2:bit BIT_ALTBAR,d:jr z,movedown_md1:jr nz,movedown_dl1
;###################################################################
;---------------------------------DL1----------------------------------
.moveleft_dl1:
	ld a,(p1x4):cp MOVE_BACK_LIMIT:ret c
	dec a
	ld (p1x4),a
	ld b,DL1_BIT
	call choose1_spr
	ld (choose_dl1+1),hl
	call hand_back
	jr show_dl1
.moveright_dl1:
	ld a,(p1x4):cp MOVE_FORW_LIMIT:ret nc
	inc a
	ld (p1x4),a
	ld b,DL1_BIT
	call choose1_spr
	ld (choose_dl1+1),hl
	call hand_forw
	jr show_dl1
.moveup_dl1:
	ld a,DL_LIMIT_UP
	ld hl,(dl1_pos)
	cp l
	ret z
.doup_dl1:
	dec l
	ld (dl1_pos),hl
	jr show_dl1
.movedown_dl1:
	ld a,DL_LIMIT_DW		
	ld hl,(dl1_pos)
	cp l
	ret z
.dodown_dl1:
	inc l
	ld (dl1_pos),hl
	;jr show_dl1
.show_dl1:ld a,(show_move):bit BIT_DL1,a:ret nz:set BIT_DL1,a:ld (show_move),a:xor a:ret
;-----------------------------------------
.choose1_spr: ;in A, B (sprite num, bit shot) - out HL (sprite addr)	
	cp 5:jr z,p1e
	ld hl,p1a_spr			;establecer puntero
	ld c,1				;indice de inicio
	ld de,48			;num bytes offset
.choose1_spr_lp:
	cp c				;comparar indice y opcion
	ret z				;retorna sprite (hl)
	add hl,de			;sino, incrementar offset puntero
	inc c				;e incrementar indice
	jr choose1_spr_lp		;bucle
	
.p1e:ld a,b:ld (c1_shot),a:ld hl,p1e_spr:ret	;alterar shot / ret sprite que dispara
