;***********************************************************************
;; DRAWS & FILLS
;***********************************************************************	
.toma:
	ld a,(ia_zone):bit 4,a:jp z,snd_sequence	;si no hay IA en z4, solo sonido
	ld hl,toma_b2p_table				;bit2pixel table
	ld de,delete_dice1_fill				;fill borrar bocadillo
	ld c,DICE1_SPR_SCRADDR_L:call dice		;func compartida, x de dice spr
	jp hands_z4					;pintar manoos
.ouch:
	ld a,(ia_zone):bit 3,a:jp z,snd_sequence
	ld hl,ouch_b2p_table
	ld de,delete_dice2_fill
	ld c,DICE2_SPR_SCRADDR_L:call dice		
	jp hands_z3					
.dice:
	push de						;preservar fill
	push bc						;preservar c (x dice)
	call table_b2p					;mostrar bocadillo hl
	pop bc						;recuperar c
	ld h,DICE_SPR_SCRADDR_H:ld l,c:ld de,dice_spr:ld a,4:call disspr2	;pintar dice spr (c->l)
	call snd_sequence				;sonido+pausa
	pop hl						;recuperar fill + cambio de reg
	jr table_fill					;;borrar bocadillos y volver
;***********************************************************************
.scr_fill:
	if ROM
	call nl_de2_scr_8000			;modificar rutina #8000
	call clear_scr8000			;borra #8000-#bfff
	call nl_de2_scr_C000			;modificar rutina #C000 (normal)
	jr clear_scr				;borra #C000-#ffff
	else
	ld hl,&c000				;copia la pantalla de carga a &8000
	ld de,&8000
	ld bc,&4000
	ldir
	call nl_de2_scr_8000			;modificar rutina #8000
	call clear_scr_titles			;borra parcialmente #8000
	jp nl_de2_scr_C000			;modificar rutina #C000 (normal)
	endif
	
ifnot ROM 
.copy_buffer:			;copiar buffer a C000
	ld hl,&8000
	ld de,&c000
	ld bc,&4000
	ldir
	jp disspr_text_mod2	;modifica rutina de texto
endif
.delete_main_msg:ld hl,delete_main_msg_fill:jr table_fill	;borra msg inferior con fillbox
if ROM
.clear_scr8000:ld hl,clear_scr8000_fill:jr table_fill		;borra scr8000
else
.clear_scr_titles:ld hl,clear_scr_titles_fills:jr table_fill	;borra titulo de la screen
endif
.clear_scr:ld hl,clear_scr_fill:;jr table_fill			;borra scrC000
;***********************************************************************
;FILL TABLES
;***********************************************************************
.table_fill: ;HL (tabla)
	ld a,(hl):inc hl     	;indices	
	table_fill_lp:
	ex af,af'		;preservar indice
	call tbl_incs		;asignar registros de la tabla
	push hl			;preserva puntero de la tabla
	call fill_box		;pintar relleno
	pop hl			;recuperar puntero de la tabla
	ex af,af'		;recuperar indice
	dec a			;decrementar indice y mod. flag zero
	jr nz,table_fill_lp 	;bucle si nozero
	ret
;***********************************************************************
;BIT2PIXEL TABLES
;***********************************************************************
.table_b2p:	;HL (tabla)
	ld c,(hl):inc hl      	;mod color 
	ld b,(hl):inc hl     	;mod color
	ld (b2p_clr),bc		;modifica rutina
	ld a,(hl):inc hl	;indices
	table_b2p_lp:
	push af
	call tbl_incs		;asignar registros de la tabla
	ld (bit2pixel_hl+1),bc	;modifica rutina  spr addr > mod hl
	ld b,(hl):inc hl	;heigth lines
	push hl
	call bit2pixel_hl	;pintar pixels
	pop hl
	pop af			
	dec a			
	jr nz,table_b2p_lp 	
	ret
;***********************************************************************
.tbl_incs:			;fillbox	;bit2pixel
	ld e,(hl):inc hl	;scr addr 	;scr addr 
	LD d,(hl):inc hl	;scr addr 	;scr addr 
	ld c,(hl):inc hl	;width		;sprite addr
	ld b,(hl):inc hl	;height		;sprite addr
	ld a,(hl):inc hl	;color		;width bytes
	ret
;***********************************************************************
;FILL_BOX - Lineas verticales o rellenos
;***********************************************************************
.fill_box: ;DE,B,C,A (addr,height,width,color)
	;setup
	ld hl,fill_box_lp	;apuntar a dir de salto
	ld (nl_de2_jp+1),hl	;modificar dir de salto en func scr_next_line_de
	ifnot ROM
	call fill_box_mod	;comprueba color y modifica rutina
	endif
	;---------------------------
	.fill_box_lp:
	push af			;preservar registros
	push bc
	push de
	.fill_box_call:
	call line_ldir		;pintar linea de color
	;call line_buffldir	;pintar linea con color del buffer scr 
	pop de			;recuperar registros
	pop bc
	jr scr_nl_de2		;calcula next line y vuelve a fill_box_lp (+pop af)
;---------------------------------------------------------------------------------------
;LINE_LDIR  Lineas horizontales o pixels
;---------------------------------------------------------------------------------------
.line_ldir: ;DE,C,A (scr addr,width,color)
	ld (de),a		;poner el primer pixel
	dec c			;decrementa width y altera flag zero 
	ret z			;si zero, salir (la linea era 1 pixel de ancho)
	ld h,d			;copia addr DE = HL 
	ld l,e
	inc de			;incrementar destino
	ld b,0			;resetea B
	ldir			;copia contenido de HL a DE hasta C = 0
	ret
;---------------------------------------------------------------------------------------
;modifica fillbox   line_ldir (normal) / line_buffldir (copia de 8000 a C000)
;---------------------------------------------------------------------------------------
ifnot ROM
.fill_box_mod:	;A (color)
	cp &ff						;si ff
	jr z,fill_box_mod2				;copia del buffer
	;jr nz,fill_box_mod1				;si no, pinta normal
	;continua
.fill_box_mod1:ld hl,line_ldir:jr fill_box_mod_set
.fill_box_mod2:ld hl,line_buffldir:;jr fill_box_mod_set
.fill_box_mod_set:ld (fill_box_call+1),hl:ret		;modifica rutina

.line_buffldir: ;DE,C (scr addr,width)
	ld a,d
	sub #40			;restar scr base
	ld h,a
	ld l,e
	ld b,0		
	ldir			;pintar linea
	ret
endif

;***********************************************************************
;BIT2PIXEL - Convierte bits de varios octetos de bytes en pixels
;***********************************************************************
.bit2pixel_hl:
	ld hl,#0000		;variable scr addr
.bit2pixel: ;DE,HL,B,A (scr addr, bits addr, height lines, width bytes)
	;setup
	push hl			;preservar bits addr
	ld hl,bit2pixel_lp	;apuntar a dir de salto
	ld (nl_de2_jp+1),hl	;modificar dir de salto en func scr_next_line_de
	pop hl			;recuperar bits addr
	;--------------------------------------------------------------------
	;bucle principal
	.bit2pixel_lp:
	push af				;preservar registros
	push bc
	push de
	;--------------------------------------------------------------------
		.next_byte_lp:
		ex af,af'		;preservar width (bytes)
		;------------------------------------------------------------
		;la rutina lee bits de 2 en 2 y pinta pixel en pantalla
		ld b,4			;num.repeticiones para el byte (x2 bit)
		ld c,(hl)		;cargar byte
		.depack_byte_lp:
		xor a			;resetear A
		bit 7,c:jr z,b2p_jp1	;si bit7 es zero saltar suma
		add %10001000		;sumar "#88" en A
		.b2p_jp1:
		bit 6,c:jr z,b2p_clr	;si bit6 es zero saltar suma
		add %01000100		;sumar "#44" en A
		.b2p_clr:		;linea modificable
		and %11000000		;pen1 sobre pen0 (blanco-fondo)
		.drawpx:
		ld (de),a		;pinta en pantalla color de A (2 pixels modo 0)
		inc de			;inc puntero de pantalla (2 pixels modo 0)
		rlc c			;gira el byte a la izq
		rlc c			;gira el byte a la izq
		djnz depack_byte_lp	;bucle hasta b=0
		;------------------------------------------------------------
		ex af,af'		;recuperar width (bytes)
		inc hl			;siguiente byte de la linea
		dec a			;dec width (bytes)
		jr nz,next_byte_lp	;termino con el width?
	;--------------------------------------------------------------------
	pop de				;recuperar puntero pantalla
	pop bc				;recuperar height
	;jr scr_nl_de2		;calcular next line / volver a bucle principal
	;continua
;***********************************************************************
;SCR_NEXT_LINE DE 2 - Calcula siguiente linea de pantalla con el regsitro DE
;***********************************************************************
;scr_next_line By Kevin Thacker
;www.cpctech.org.uk/source/cpl_spr.asm

.scr_nl_de2:	;DE, B (scr addr, height)
	ld a,d
	.nl_de2_line:		;modificar rutina, salta lineas
	add #08			;variable - add #08  normal
	ld d,a
	.nl_de2_scr:		;modificar rutina para checkear el carry con pantalla en 8000
	nop			;[nop] por defecto C000-ffff, [add] 8000-bfff
	nop			;[nop] por defecto C000-ffff, [#40] 8000-bfff
	jr nc,nl_de2_end	;si hay carry, end	
	ld a,e			;aadir siguiente linea a DE
	add #50			
	ld e,a
	ld a,d
	adc #C0
	ld d,a
.nl_de2_end:
	pop af			;recuperar registro de las tablas
	dec b			;modificar flag zero con el height
	.nl_de2_jp:		;llamada a mod. rutina (setup) 
	jp nz,fill_box_lp	;jp a fill_box_lp o bit2pixel_lp (fillbox por defecto)
	ret
	
;modifica rutina, saltar lineas
.nl_de2_line_normal:ld a,#08:jr nl_de2_line_set	;add #08  normal
.nl_de2_line_two:ld a,#10:jr nl_de2_line_set	;add #10  salta 2 lineas
.nl_de2_line_three:ld a,#18:;jr nl_de2_line_set	;add #18  salta 3 lineas
.nl_de2_line_set:ld (nl_de2_line+1),a:ret	;modificar rutina
;mmodifica rutina para scr 8000/C000
.nl_de2_scr_8000:ld hl,#40C6:jr nl_de2_scr_set	;instruccion add #40 
.nl_de2_scr_C000:ld hl,0:;jr nl_de2_scr_set	;instruccion nop nop
.nl_de2_scr_set:ld (nl_de2_scr),hl:ret		;modificar rutina
;------------------------------------------------------------------------

