;***********************************************************************
;IA1
;***********************************************************************
;colocar en cuenta-atrs
.controlIA1_prep:
	ld a,(ia_zone)		;ctrl ia
	bit BIT_IA1,a:ret z	;deshabilitado?	
	ld d,a			;D control bits IA
	ld a,(countdown_num+1)	;lee contador
	cp 4:ret nc		;4...nada
	cp 1:ret c
	cp 3:jr z,ia1_prep_z1	;3...z1
	jr ia1_prep_z2

.ia1_prep_z1:			;prepara zona 1
	bit BIT_Z1,d:ret z	;zona1?
	;---------------------------------------
	ld a,PT_POSY		;colocar portero
	ld hl,(pt1_pos)
	cp l:call nz,ia_pt1_updw
	;---------------------------------------
	push de			;preservar control bits
	call moveleft_pt1	;mover atras
	call moveleft_df1
	pop de	
	;---------------------------------------
	ld a,DF_POSY		;colocar defensa
	ld hl,(df1_pos)
	cp l:call nz,ia_df1_updw
	;---------------------------------------
	bit BIT_CTRL1,d:ret z	;autozona?
	cp l:call z,ia1_z2	;cambia a zona2 cuando termine con df (cp l=Z)
	;---------------------------------------
	ret
	
.ia1_prep_z2:			;prepara zona 2
	bit BIT_Z2,d:ret z		;zona2?
	;---------------------------------------
	ld a,MD_POSY		;colocar media
	ld hl,(md1_pos)
	cp l:call nz,ia_md1_updw
	;---------------------------------------
	ld a,DL_POSY		;colocar delantero
	ld hl,(dl1_pos)
	cp l:call nz,ia_dl1_updw
	;---------------------------------------
	call moveleft_md1	;mover atras 
	jp moveleft_dl1

;***********************************************************************
.ia1_autoZone:
	ld a,(ball_area)
	or a:ret z
	cp DL2_BIT: 
	jr c,ia1_z2	;sino, pasa a z1
	;cp DL2_BIT: 	;no hace falta
	;jr nc,ia1_z1	;
	;ret		;
.ia1_z1:bit BIT_Z1,d:ret nz:ld a,d:xor Z12:ld (ia_zone),a:jp hands_z1_hdle
.ia1_z2:bit BIT_Z2,d:ret nz:ld a,d:xor Z12:ld (ia_zone),a:jp hands_z2_hdle
;***********************************************************************
.controlIA1:
	ld a,(ia_zone)				;control IA
	bit BIT_IA1,a:ret z			;deshabilitado?
	ld d,a					;D control bits IA
	bit BIT_CTRL1,d:call nz,ia1_autoZone	;autozona?

	ld a,(by)
	sub 2
	ld c,a					;C=Y
	ld a,(bx)	
	ld b,a					;B=X

	;comprobar areas  -  A,BC,D (bx,bxy,iazone)
	bit BIT_Z1,d:jr z,ia1_zone2b			;si zona1 es 0 ir a zona2b
	.ia1_zone1:					;si x menor..
	cp DF1_POSX+IA1_AREA: 		jr c,ia_pt1df1	;port, defensa
	bit BIT_Z2,d:			ret z		;si zona2 es 0 cancelar
	.ia1_zone2:					;si x menor..
	cp MD1_POSX+IA1_AREA: 		jp c,ia_md1	;media
	cp DL1_POSX+IA1_AREA: 		jp c,ia_dl1	;delantero
	cp DL1_POSX+IA1_AREA_RET: 	ret c		;no mover
	cp DL1_POSX+IA1_AREA_END: 	jp c,ia_dl1	;delantero
	ret
	.ia1_zone2b:					;si x menor..
	cp DF1_POSX+IA1_AREA: 		ret c		;no mover
	jr ia1_zone2					;ir a zona2
	
;***********************************************************************
.ia_pt1:	;B,C	(bx,by)
	ld hl,(pt1_pos)			;pos portero
	if FAKEBY
	ld d,PT1_BIT			;bit para fakepos
	call ia1_fakey_pos
	endif
	ld a,c				;comprobar limites by
	cp PT_LIMIT_UP: ret c		
	cp PT_LIMIT_DW: ret nc
.ia_pt1_do:
	ld e,a				;preservar BY para despues
	cp l:jr z,ia_pt1_area		;si by es igual que portero y ir a mover x
.ia_pt1_updw:				;sino, mover y
	cp l:call c,doup_pt1		
	cp l:call nc,dodown_pt1
.ia_pt1_area:
	ld a,b				;comprobar bx
	cp PT1_POSX+1:jp c,moveleft_pt1		;0
	cp PT1_POSX+4:jr c,ia_pt1_do4		;3 2 1
	cp PT1_POSX+5:jr c,ia_pt1_do3		;4
	cp PT1_POSX+7:jp c,moveleft_pt1		;5
	ret
.ia_pt1_do3:	
	ld a,(p1x1):cp 4:ret nc		;comprobar sprite figura
	jp moveright_pt1		;mover x
.ia_pt1_do4:
	call chcki:ret z
	ld a,e				;cargar bx alternativo
	inc a				;checkear posiciones adyacentes
	cp l:jr z,ia_pt1_shot
	dec a
	cp l:jr z,ia_pt1_shot
	dec a
	cp l:jr z,ia_pt1_shot
	ret
.ia_pt1_shot:
	jp moveright_pt1
;***********************************************************************
.ia_pt1df1:
push bc			;preservar bxy
call ia_pt1		;llamar al portero
pop bc			;recuperar bxy y continuar con defensa

.ia_df1:	;B,C	(bx,by)
	ld hl,(df1_pos)
	if FAKEBY
	ld d,DF1_BIT
	call ia1_fakey_pos
	endif
	ld a,c
	cp DF_LIMIT_UP:ret c		;comprobar offset figura y restar BY 
.ia_df1_1:cp DF_LIMIT_1:jr nc,ia_df1_2:jr ia_df1_do
.ia_df1_2:cp DF_OFFSET_POS+DF_LIMIT_DW+1:ret nc:sub DF_OFFSET_POS
.ia_df1_do:
	ld e,a
	cp l:jr z,ia_df1_area

.ia_df1_updw:
	cp l:call c,doup_df1
	cp l:call nc,dodown_df1
.ia_df1_area:
	ld a,b
	cp DF1_POSX-1:ret c			;
	cp DF1_POSX+1:jp c,moveleft_df1		;0 -1
	cp DF1_POSX+4:jr c,ia_df1_do4		;3 2 1
	cp DF1_POSX+5:jr c,ia_df1_do3		;4
	cp DF1_POSX+7:jp c,moveleft_df1		;6 5
	ret
.ia_df1_do3:	
	ld a,(p1x2):cp 4:ret nc
	jp moveright_df1
.ia_df1_do4:
	call chcki:ret z
	ld a,e
	inc a
	cp l:jr z,ia_df1_shot
	dec a
	cp l:jr z,ia_df1_shot
	dec a
	cp l:jr z,ia_df1_shot
	ret
.ia_df1_shot:
	if IA_LINE
	call ia1_line:ret nz	;si hay obstculo salir
	endif
	;regia
	if REG			
	ld h,#36		;tabla de datos
	ld l,c			;tabla de datos	
	ld a,(hl)		;valor de la tabla de datos
	cp DL2_BIT:ret z	;si registr DL2 salir
	endif
	jp moveright_df1	;shot
;;***********************************************************************
.ia_md1:	;B,C	(bx,by)
	ld hl,(md1_pos)
if FAKEBY
	ld d,MD1_BIT
	call ia1_fakey_pos
endif
	ld a,c
	cp MD_LIMIT_UP:ret c
	cp ALL_LMTTOTAL_DW+1:ret nc
.ia_md1_posy:			;comprobar offset figuras y restar BY 
	ld de,MD_LMT1_OFFSET
	ia_md1_posy_lp
	cp d
	jr c,ia_md1_do
	sub e
	jr ia_md1_posy_lp
.ia_md1_do:
	ld e,a
	cp l:jr z,ia_md1_area
.ia_md1_updw:
	cp l:call c,doup_md1
	cp l:call nc,dodown_md1
.ia_md1_area:
	ld a,b
	cp MD1_POSX-1:ret c
	cp MD1_POSX+1:jp c,moveleft_md1
	cp MD1_POSX+4:jr c,ia_md1_do4
	cp MD1_POSX+5:jr c,ia_md1_do3
	cp MD1_POSX+7:jp c,moveleft_md1
	reT
.ia_md1_do3:
	ld a,(p1x3):cp 4:ret nc
	jp moveright_md1
.ia_md1_do4:	
	call chcki:ret z
	ld a,e
	inc a
	cp l:jr z,ia_md1_shot
	dec a
	cp l:jr z,ia_md1_shot
	dec a
	cp l:jr z,ia_md1_shot
	ret
.ia_md1_shot:
	if IA_LINE
	call ia1_line:ret nz
	endif
	;regia
	if REG
	ld h,#34	
	ld l,c
	ld a,(hl)
	cp MD2_BIT:ret z
	endif
	jp moveright_md1
;;***********************************************************************	
.ia_dl1:	;B,C	(bx,by)
	ld hl,(dl1_pos)
if FAKEBY
	ld d,DL1_BIT
	call ia1_fakey_pos
endif
	ld a,c
	cp DL_LIMIT_UP:ret c
	cp ALL_LMTTOTAL_DW+1:ret nc
.ia_dl1_posy:
	ld de,DL_LMT1_OFFSET
	ia_dl1_posy_lp
	cp d
	jr c,ia_dl1_do
	sub e
	jr ia_dl1_posy_lp
.ia_dl1_do:
	ld e,a
	cp l:jr z,ia_dl1_area
.ia_dl1_updw:
	cp l:call c,doup_dl1
	cp l:call nc,dodown_dl1
.ia_dl1_area:
	ld a,b
	cp DL1_POSX-1:ret c
	cp DL1_POSX+1:jp c,moveleft_dl1		;0 -1
	cp DL1_POSX+4:jr c,ia_dl1_do4		;3 2 1
	cp DL1_POSX+5:jr c,ia_dl1_do3		;4
	cp DL1_POSX+7:jp c,moveleft_dl1		;7 6 5
	ret
.ia_dl1_do3:
	ld a,(p1x4):cp 4:ret nc
	jp moveright_dl1
.ia_dl1_do4:
	call chcki:ret z
	ld a,c
	cp IA_DLSHOT_UP:jr c,ia_dl1_do3
	cp IA_DLSHOT_DW:jr nc,ia_dl1_do3
	ld a,e
	inc a
	cp l:jr z,ia_dl1_shot
	dec a
	cp l:jr z,ia_dl1_shot
	dec a
	cp l:jr z,ia_dl1_shot
	ret
.ia_dl1_shot:
	if IA_LINE
	call ia1_line:ret nz
	endif
	;regia
	if REG
	ld h,#32	
	ld l,c
	ld a,(hl)
	cp DF2_BIT:ret z
	endif
	jp moveright_dl1
	
;***********************************************************************
;general

if FAKEBY
;aadir imprecision
.ia1_fakey_pos:		;C,D (by,bit figura)
	ld a,(ball_area)	;si el bit area
	cp d:			;es igual que bit figura 
	ret z			;salir
	ld a,(ia_fakey+1)	;cargar value
	cp IA_REACTION_TIME:	;comprobar ocnstante
	ret nc			;si es mayor o igual salir
	ld a,c			;cargar by
	.ia1_fakey;
	add IA_FAKE_VALUE	;alterar precision (modificable sub/add/value)
	ld c,a			;retornar by
	ret
endif

if IA_LINE
;comprobar obstculo
.ia1_line:	;in HL (pos figura) - out AF (color/flag zero)
	ld a,h			;fig x
	add 10			;offset x (adelantar posicion)
	ld h,a			;fig x+10
	ld l,c			;ball y
	inc l			;ball y+1
	push bc			;guardar regs
	call find_addr		;buscar (combinacion de pos_figura y bally en HL)
	pop bc			;recuperar regs
	ld a,(hl)		;scr > A
	cp BACKCOLOR1		;comparar color area de juego
	ret			;ret flag zero
endif
;***********************************************************************
;IA1 /IA2 modificar rutinas fakepos
if FAKEBY
.ia_fakey:
	ld a,0			;variable contador
	inc a
	ld (ia_fakey+1),a	;automodificar contador
	cp IA_FAKE_CONT:ret nz	;salir si no 
.ia_fakey_change:
	xor a
	ld (ia_fakey+1),a	;resetear contador
	ld a,(byd)		;dir
	cp 1:jr z,ia_fakey_dw
	cp -1:jr z,ia_fakey_up
.ia_fakey_dw:	
	ld a,#C6	;add
	jr ia_fakey_set
.ia_fakey_up:	
	ld a,#D6	;sub
	;jr ia_fakey_dir
.ia_fakey_set:
	ld (ia1_fakey),a
	ld (ia2_fakey),a
	ret
endif	
	
.chcki:	;retornar flag zero
ld a,(bxi)
cp #ff:ret