;***********************************************************************
;IA2
;***********************************************************************
;colocar en cuenta-atrs
.controlIA2_prep:
	ld a,(ia_zone)		;ctrl ia
	bit BIT_IA2,a:ret z	;deshabilitado?	
	ld d,a			;D control bits IA
	ld a,(countdown_num+1)
	cp 4:ret nc
	cp 1:ret c
	cp 3:jr z,ia2_prep_z3
	jr ia2_prep_z4
	
.ia2_prep_z3:			;prepara zona 3	
	bit BIT_Z3,d:ret z	;zona3?
	;---------------------------------------
	ld a,PT_POSY		;colocar portero
	ld hl,(pt2_pos)
	cp l:call nz,ia_pt2_updw
	;---------------------------------------
	push de			;preservar control bits
	call moveright_pt2	;mover atras
	call moveright_df2
	pop de
	;---------------------------------------
	ld a,DF_POSY		;colocar defensa
	ld hl,(df2_pos)
	cp l:call nz,ia_df2_updw
	;---------------------------------------
	bit BIT_CTRL2,d:ret z	;autozona?
	cp l:call z,ia2_z4	;cambia a zona4 cuando termine con df (cp l=Z)
	;---------------------------------------
	ret
	
.ia2_prep_z4:			;prepara zona 4
	bit BIT_Z4,d:ret z	;zona4?
	;---------------------------------------
	ld a,MD_POSY		;colocar media
	ld hl,(md2_pos)
	cp l:call nz,ia_md2_updw
	;---------------------------------------
	ld a,DL_POSY		;colocar delantero
	ld hl,(dl2_pos)
	cp l:call nz,ia_dl2_updw
	;---------------------------------------
	call moveright_md2	;mover atras
	jp moveright_dl2

;***********************************************************************
.ia2_autoZone:
	ld a,(ball_area)
	or a:ret z
	cp MD2_BIT: 
	jr nc,ia2_z4	;sino, pasa a z3
	;cp MD2_BIT: 	;no hace falta
	;jr c,ia2_z3	;
	;ret		;
.ia2_z3:bit BIT_Z3,d:ret nz:ld a,d:xor Z34:ld (ia_zone),a:jp hands_z3_hdle
.ia2_z4:bit BIT_Z4,d:ret nz:ld a,d:xor Z34:ld (ia_zone),a:jp hands_z4_hdle
;***********************************************************************
.controlIA2:
	ld a,(ia_zone)		;Control IA
	bit BIT_IA2,a:ret z		;deshabilitado?
	ld d,a			;D control bits IA
	
	bit BIT_CTRL2,d:call nz,ia2_autoZone	;autozona?
	
	ld a,(by)
	sub 2
	ld c,a					;C=Y
	ld a,(bx)	
	ld b,a					;B=X

	;comprobar areas  -  A,BC,D (bx,bxy,ia,zone)
	bit BIT_Z3,d:jr z,ia2_zone4b			;si zona3 es 0, ir a zona4b
	.ia2_zone3:					;si x mayor..
	cp DF2_POSX+IA2_AREA: 		jr nc,ia_pt2df2	;port, defensa
	bit BIT_Z4,d:			ret z		;si zona4 es 0, cancelar
	.ia2_zone4:					;si x mayor..
	cp MD2_POSX+IA2_AREA: 		jp nc,ia_md2	;media
	cp DL2_POSX+IA2_AREA: 		jp nc,ia_dl2	;delantero
	cp DL2_POSX+IA2_AREA_RET: 	ret nc		;no mover
	cp DL2_POSX+IA2_AREA_END: 	jp nc,ia_dl2	;delantero	
	ret
	.ia2_zone4b:					;si x mayor..
	cp DF2_POSX+IA2_AREA: 		ret nc		;no mover
	jr ia2_zone4					;a zona3
	
;***********************************************************************
.ia_pt2:	;B,C	(bx,by)
	ld hl,(pt2_pos)
if FAKEBY
	ld d,PT2_BIT
	call ia2_fakey_pos
endif
	ld a,c
	cp PT_LIMIT_UP: ret c
	cp PT_LIMIT_DW: ret nc
.ia_pt2_do:
	ld e,a
	cp l:jr z,ia_pt2_area
.ia_pt2_updw:
	cp l:call c,doup_pt2
	cp l:call nc,dodown_pt2
.ia_pt2_area:
	ld a,b
	cp PT2_POSX-2:ret c
	cp PT2_POSX:jp c,moveright_pt2		;-1 -2
	cp PT2_POSX+1:jr c,ia_pt2_do3		;0 
	cp PT2_POSX+4:jr c,ia_pt2_do4		;3 2 1
	cp PT2_POSX+6:jp c,moveright_pt2	;5 4
	ret	
.ia_pt2_do3:	
	ld a,(p2x1):cp 4:ret nc
	jp moveleft_pt2
.ia_pt2_do4
	call chcki:ret z
	ld a,e
	inc a
	cp l:jr z,ia_pt2_shot
	dec a
	cp l:jr z,ia_pt2_shot
	dec a
	cp l:jr z,ia_pt2_shot
	ret
.ia_pt2_shot:
	jp moveleft_pt2
	
;***********************************************************************	
.ia_pt2df2:
push bc
call ia_pt2
pop bc
.ia_df2:	;B,C	(bx,by)
	ld hl,(df2_pos)
if FAKEBY
	ld d,DF2_BIT
	call ia2_fakey_pos
endif
	ld a,c
	cp DF_LIMIT_UP:ret c
.ia_df2_1:cp DF_LIMIT_1:jr nc,ia_df2_2:jr ia_df2_do
.ia_df2_2:cp DF_OFFSET_POS+DF_LIMIT_DW+1:ret nc:sub DF_OFFSET_POS
.ia_df2_do:
	ld e,a
	cp l:jr z,ia_df2_area
.ia_df2_updw:
	cp l:call c,doup_df2
	cp l:call nc,dodown_df2
.ia_df2_area:
	ld a,b
	cp DF2_POSX-2:ret c
	cp DF2_POSX:jp c,moveright_df2		;-1 -2
	cp DF2_POSX+1:jr c,ia_df2_do3		;0
	cp DF2_POSX+4:jr c,ia_df2_do4		;3 2 1
	cp DF2_POSX+6:jp c,moveright_df2	;5 4
	ret
.ia_df2_do3:
	ld a,(p2x2):cp 4:ret nc
	jp moveleft_df2
.ia_df2_do4:	
	call chcki:ret z
	ld a,e
	inc a
	cp l:jr z,ia_df2_shot
	dec a
	cp l:jr z,ia_df2_shot
	dec a
	cp l:jr z,ia_df2_shot
	ret
.ia_df2_shot:
	if IA_LINE
	call ia2_line:ret nz
	endif
	;regia
	if REG
	ld h,#31	
	ld l,c
	ld a,(hl)
	cp DL1_BIT:ret z
	endif
	jp moveleft_df2
;***********************************************************************
.ia_md2:	;B,C	(bx,by)
	ld hl,(md2_pos)
if FAKEBY
	ld d,MD2_BIT
	call ia2_fakey_pos
endif
	ld a,c
	cp MD_LIMIT_UP:ret c
	cp ALL_LMTTOTAL_DW+1:ret nc
.ia_md2_posy:
	ld de,MD_LMT1_OFFSET
	ia_md2_posy_lp
	cp d
	jr c,ia_md2_do
	sub e
	jr ia_md2_posy_lp
.ia_md2_do:
	ld e,a
	cp l:jr z,ia_md2_area
.ia_md2_updw:
	cp l:call c,doup_md2
	cp l:call nc,dodown_md2
.ia_md2_area:
	ld a,b
	cp MD2_POSX-2:ret c
	cp MD2_POSX:jp c,moveright_md2
	cp MD2_POSX+1:jr c,ia_md2_do3
	cp MD2_POSX+4:jr c,ia_md2_do4
	cp MD2_POSX+6:jp c,moveright_md2
	ret
.ia_md2_do3:
	ld a,(p2x3):cp 4:ret nc
	jp moveleft_md2
.ia_md2_do4:	
	call chcki:ret z
	ld a,e
	inc a
	cp l:jr z,ia_md2_shot
	dec a
	cp l:jr z,ia_md2_shot
	dec a
	cp l:jr z,ia_md2_shot
	ret
.ia_md2_shot:
	if IA_LINE
	call ia2_line:ret nz
	endif
	;regia
	if REG
	ld h,#33	
	ld l,c
	ld a,(hl)
	cp MD1_BIT:ret z
	endif
	jp moveleft_md2
;***********************************************************************	
.ia_dl2:	;B,C	(bx,by)
	ld hl,(dl2_pos)
if FAKEBY
	ld d,DL2_BIT
	call ia2_fakey_pos
endif
	ld a,c
	cp DL_LIMIT_UP:ret c
	cp ALL_LMTTOTAL_DW+1:ret nc
.ia_dl2_posy:
	ld de,DL_LMT1_OFFSET
	ia_dl2_posy_lp
	cp d
	jr c,ia_dl2_do
	sub e
	jr ia_dl2_posy_lp
.ia_dl2_do:
	ld e,a
	cp l:jr z,ia_dl2_area
.ia_dl2_updw:
	cp l:call c,doup_dl2
	cp l:call nc,dodown_dl2
.ia_dl2_area:
	ld a,b
	cp DL2_POSX-2:ret c
	cp DL2_POSX:jp c,moveright_dl2
	cp DL2_POSX+1:jr c,ia_dl2_do3
	cp DL2_POSX+4:jr c,ia_dl2_do4
	cp DL2_POSX+6:jp c,moveright_dl2
	ret
.ia_dl2_do3:
	ld a,(p2x4):cp 4:ret nc
	jp moveleft_dl2
.ia_dl2_do4:
	call chcki:ret z
	ld a,c
	cp IA_DLSHOT_UP:jr c,ia_dl2_do3
	cp IA_DLSHOT_DW:jr nc,ia_dl2_do3
	ld a,e
	inc a
	cp l:jr z,ia_dl2_shot
	dec a
	cp l:jr z,ia_dl2_shot
	dec a
	cp l:jr z,ia_dl2_shot
	ret
.ia_dl2_shot:
	if IA_LINE
	call ia2_line:ret nz
	endif
	;regia
	if REG
	ld h,#35	
	ld l,c
	ld a,(hl)
	cp DF1_BIT:ret z
	endif
	jp moveleft_dl2
	
;***********************************************************************
;general

if FAKEBY
;aadir imprecision
.ia2_fakey_pos:		;C,D (by,bit figura)
	ld a,(ball_area)	;si el bit area
	cp d:			;es igual que bit figura
	ret z			;salir
	ld a,(ia_fakey+1)	;cargar value
	cp IA_REACTION_TIME	;comprobar ocnstante
	ret nc			;si es mayor o igual salir
	ld a,c			;cargar by
	.ia2_fakey;
	add IA_FAKE_VALUE	;alterar precision (modificable sub/add/value)
	ld c,a			;retornar by
	ret
endif
if IA_LINE
;comprobar obstculo
ia2_line:	;in HL (pos figura) - out AF (color/flag zero)
	ld a,h			;fig x
	sub 5			;offset x (retrasar posicion)
	ld h,a			;fig x-5
	ld l,c			;ball y
	inc l			;ball y+1
	push bc			;guardar regs
	call find_addr		;buscar (combinacion de pos_figura y bally en HL)
	pop bc			;recuperar regs
	ld a,(hl)		;scr > A
	cp BACKCOLOR1		;comparar color area de juego
	ret			;ret flag zero
endif