;***********************************************************************
; M4 BOARD routines by Duke - mod. by Q.Miquel
; github.com/M4Duke/M4examples
;***********************************************************************
.rom_enable:
	di
	ld bc,#7F84		;enable upper rom, disable lower rom, mode 0
	out (c),c
	ret
	
.get_time: 			; no params
	ld a,(m4_rom_num)
	cp #FF:ret z
	call rom_enable

	ld bc,#DF00
	out (c),a
	ld a,2 			;out going size
	ld b,#FE		; data port (#FE00)
	ld de,#4324 		; C_TIME command
	out (c),a
	out (c),e
	out (c),d
	ld b,#FC		; ack port (#FC00)
	out (c),c

	ld hl,#FF02 		; get response buffer address
	ld e,(hl)
	inc hl
	ld d,(hl)
	ex de,hl
	ld bc,#3 		; skip check bytes
	add hl,bc
	ld de,time_stamp	;addr donde guardar
	ld bc,5			;5 (HH MM) of 19 chars (HH MM SS AAAA MM DD). Note; Duke put 22 (19+skip bytes?)
	ldir 			; copy time stamp to ram
	jr rom_disabled
	
.find_m4_rom:
	call rom_enable

	ld iy,m4_rom_name 	; rom identification line
	ld d,127 		; start looking for from (counting downwards)

	romloop: 
	push de
	ld bc,#DF00
	out (c),d 		; select rom
	ld a,(#C000)
	cp 1
	jr nz, not_this_rom

	; get rsxcommand_table
	ld hl,(#C004)		;(c004-c005)
	push iy
	pop de
	cmp_loop:
	ld a,(de)
	xor (hl) 		; hl points at rom name
	jr nz, not_this_rom
	ld a,(de)
	inc hl
	inc de
	and #80
	jr z,cmp_loop

	; rom found, store the rom number
	pop de 			; rom number
	ld a,d
	ld (m4_rom_num),a
	jr rom_disabled
	
.not_this_rom:
	pop de
	dec d
	jr nz,romloop		;nozero loop, zero rom_disabled

.rom_disabled:
	ld bc,#7F8C		;upper and lower rom disabled, mode 0
	out (c),c
	ld bc,#DF00		;expansion rom select port
	out (c),c
	ei
	ret

m4_rom_name: db "M4 BOAR",#C4
;time_stamp ds 5	;in define.asm
;db 0
m4_rom_num: db #FF