;***********************************************************************
;MENU
;***********************************************************************
.setup_menu:
	;opciones seleccionadas, puntos, etc
	ld hl,menu_static_str_table:call table_str		;strings menu
	call reg_count
	call points_check
	call print_last_points

	ld a,(control1_set):add 48:ld de,CTRLJ1_SET_POS:call show_char	
	ld a,(control2_set):add 48:ld de,CTRLJ2_SET_POS:call show_char
	ld b,#05:call arrows_option				;arrow al inicio
	ld a,(modo):call set_modo_option			;setup modo
	ld a,(equipacion):call set_equip_option			;setup paleta equipacion
	ld a,(victoria):call set_victoria_option		;setup c.victoria
	;ld a,(balls_option):;call set_balls_option		;setup balls EN RUTINA VICTORIA
	call set_options					;setup opciones
.draw_equip_title:
	;fills & sprites equipaciones
	ld hl,menu_fills:call table_fill				;lineas rellenos etc
	ld hl,equip_2x4_spr_table:call table_spr			;sprites
	ld hl,equip_3x12_spr_table:call table_spr			;sprites
	ld hl,equip_6x2_spr_table:call table_spr			;sprites
.draw_title:
	;titulo, marcador, resultados
	call nl_de2_line_three						;b2p mod salta linea
	ld hl,title1_b2p_table:call table_b2p				;titulo rayas negras
	ld hl,title2_b2p_table:call table_b2p				;titulo rayas blancas
	call nl_de2_line_normal
	ld hl,score_box2:call table_fill
	jp print_results

;***********************************************************************
;SCAN
;***********************************************************************
.menu_scan:
	call keyb_scan			;key
	ld hl,menu_keys			;tabla de teclas del menu
	ld b,16				;indices de la tabla
	.control_menu_lp:
	;----------------------
	ld e,(hl):inc hl		;jp addr byte1
	ld d,(hl):inc hl		;jp addr byte2
	ld (menu_ins_jp+1),de		;modificar la instruccion jp
	;----------------------
	ld a,(hl):inc hl		;instruccin bit
	ld (menu_ins_bit+1),a		;modificar la instruccion bit
	;--------------------
	ld a,(hl)			;offset del buffer (line)
	ld de,keyb_buffer
	add e				;aadir offset al buffer
	ld e,a				
	ld a,(de)			;contenido del buffer (line)
	;----------------------
	.menu_ins_bit:
	bit 0,a				;comprobar el bit
	.menu_ins_jp:
	jp z,menu_control1		;salto a rutina deseada si zero
	inc hl				;siguiente menu
	djnz control_menu_lp		;bucle
	xor a:ld (key_pressed+1),a	;liberar pressed
	ret

;***********************************************************************
;COMMON
;***********************************************************************
.arrows:	;B (arrow num)		;funcion comun del menu
	call set_pressed		;opcin pulsada
.arrows_option:	;B (arrow num)			
	ld c,b				;B flecha 1
	inc c				;C flecha 2
	;-------------------------
	;pintar/borrar arrows
	ld hl,arrows_pos_table		;tabla de posiciones			
	ld a,12				;total indices
	.table_arrow_lp:		;loop
	push af				;preservar indice
	ld e,(hl):inc hl        	;pos byte 1
	ld d,(hl):inc hl       		;pos byte 2
	push hl				;preservar puntero
	ld hl,str_sp			;cargar espacio por defecto para borrar
	cp b:jr nz,jump_arrow1		
	ld hl,str_arrow1		;cargar flecha1 si se cumple A=B
	.jump_arrow1:
	cp c:jr nz,jump_arrow2	
	ld hl,str_arrow2		;cargar flecha2 si se cumple A=C
	.jump_arrow2:
	push bc				;preservar parejas de flechas
	call text_spr			;pintar flechas
	pop bc				;recuperar parejas
	pop hl				;recuperar puntero
	pop af				;recuperar indice
	dec a				;decrem indice
	jr nz,table_arrow_lp    	;loop
	;continua
	;-------------------------
.option_count_reset:
	call menu_count_reset		;resetear contador menu
	jp snd_menu			;sonido menu

.set_pressed:
	ld a,1
	ld (key_pressed+1),a
	ret
.key_pressed:	;out F (flag zero)
	ld a,0			;variable
	or a			;alterar flag
	ret			;retornar flag

;***********************************************************************
;CONTROLS
;***********************************************************************
.menu_control1:				;setup por menu
	call key_pressed:ret nz
	ld b,#01			;arrows 1 y 2 (2 se suma en la subrutina)
	call arrows			;funciones comunes, requiere BC (arrows)
	ld hl,delete_set_p1_fill:call table_fill	;;borrar strings del set  
	ld hl,menu_ctrls1_str_table:call table_str
	ld e,1				;sel. player
	ld hl,(control_sets)		;opcion menu control1 (H) y control2 (L) 16bits
	dec l
	ld a,h
	cp l:jr nz,menu_controls
	jr inc_set
.menu_control2:				;lo mismo que menu_control1
	call key_pressed:ret nz
	ld b,#03			;arrows 3 y 4
	call arrows
	ld hl,delete_set_p2_fill:call table_fill
	ld hl,menu_ctrls2_str_table:call table_str
	ld e,2
	ld hl,(control_sets)
	dec h
	ld a,l
	cp h:jr nz,menu_controls				
	;jr inc_set
.inc_set:
	inc a				;aade la sig.opcin
.menu_controls:	;A (option)
	inc a
	cp TOTAL_KEYBCONFS+1:jr c,set_control_option	;si es menor a max-1
	ld a,l				;si no, mirar set contrario
	or a:jr z,set_control_option2	;si es 0 poner 2
	ld a,h
	or a:jr z,set_control_option2
	ld a,1				;si nada se cumple poner la 1
	jr set_control_option
.set_control_option2:
	ld a,2
.set_control_option: ;A	(opcion)
	ld hl,keyb_conf1		;establecer puntero a conf
	ld bc,7				;num bytes offset de conf
	ld d,1				;indice de inicio
.set_control_option_lp:
	cp d				;comparar indice y opcion
	jr z,control_do			;si es igual ir a subrutina 
	add hl,bc			;sino, incrementar offset puntero
	inc d				;e incrementar indice
	jr set_control_option_lp	;bucle	

.control_do:	;HL,E	(conf, ctrl1/ctrl2)		;sel. player control
	ld a,e
	;cp 1:;jr z,control1_do		;no hace falta
	cp 2:jr z,control2_do		;si es 2 salta a ctrl2, sino continua

.control1_do:	;HL	(conf)
	ld a,(hl):inc hl	;carga opcion (primer byte de la conf.)
	ld (control1_set),a	;guarda el ctrl_set (opcion del menu) esta vez 8bit

	add 48			;pasa el num set a ascii
	ld de,CTRLJ1_SET_POS
	call show_char		;pinta num set - A,DE (char, pos)
	ld de,CTRLJ1_VALUE1_POS
	call show_keyb_conf	;pinta set ctrls - HL,DE (keyb_conf, pos)
	ld de,ctrl1_mod_table
	call ctrl_table_mod	;modifica controles HL,DE (keyb_conf,table addrs)
	;-------------------------------------------------
	;copiar teclas del ctrl1 a la rutina de scoreboard	(26B)
	ld hl,ctrl1_mod_table	;tabla de controles
	ld de,score_control1a	;puntero de la rutina a modificar
	ld a,4			;repite 4 (controles)
	.copy_ctrl_lp:
	ld c,(hl):inc hl	;tabla byte1
	push hl			;preservar tabla
	ld h,(hl)		;tabla byte2
	ld l,c			;tabla byte1
	ld bc,5			;5 bytes para ldir
	ldir			;HL->DE & BC-- mientras BC!=0. 
	pop hl			;recuperar tabla
	inc hl			;inc tabla
	inc de			;DE no se preserva, dejar que se incremente (+ 5 bytes de ldir)
	inc de			;+2 incrementos necesarios
	dec a			;decrementar bucle
	jr nz,copy_ctrl_lp	;bucle mientras nozero
	ret
	
.control2_do:			;lo mismo que control1_do pero sin copiar controles en scoreboard
	ld a,(hl):inc hl
	ld (control2_set),a	
	add 48			
	ld de,CTRLJ2_SET_POS
	call show_char
	ld de,CTRLJ2_VALUE1_POS
	call show_keyb_conf
	ld de,ctrl2_mod_table			
	;jr ctrl_table_mod			;continua
	
.ctrl_table_mod:	;HL, DE (keyb_conf, control mod table)		
	;recorre las tablas donde estan las direcciones de los controles a modficar 
	;y se asigna los bytes correspondientes
	ld a,6			;num ctrls
	.ctrl_table_lp		;bucle
	push af			;preservar registros
	push hl
	push de
	ld a,(hl)		;keyb_conf[keycode] -> A
	ex de,hl		;intercambiar regs
	ld e,(hl)		;control mod addr byte 1
	inc hl			;inc puntero
	ld d,(hl)		;control mod addr byte 2
	ex de,hl		;intercambiar regs - ctrl mod addr > HL
	ld e,a			;keycode -> E
	call kbline		;subrutina de linea a modificar, requiere E, HL (keycode, mod addr)
	pop de			;recuperar regstros
	pop hl
	pop af
	inc hl			;incrementar puntero key_conf (1B)
	inc de			;incrementar addr (2B)
	inc de
	dec a			;dec contador
	jr nz,ctrl_table_lp	;bucle mientras nozero
	ret	

.kbline:	;in E,HL (keybconf code, mod addr) - out B,C,HL (ins_bit, buffer_line,  mod addr)
	;recorre 79-0   keybcodes y envia C (LINEA) y B (instruccion bit) a la subrutina
	;bit 0,a = 47; 	1,a = 4f; ... 7,a = 7f;
	ld d,79				;max keybcodes
	ld c,9				;max lines
	.kbline_lp:
		ld a,INS_BIT7		;instruccin bit 7,?
		.kbbit_lp:
		ld b,a			;instruccin en B
		ld a,e			;si e=d
		cp d:jr z,kbline_mod	;code encontrado, salir
		dec d			;decrem. contador codes
		ld a,b
		sub 8			;restar 8 a la instruccin bit
		cp INS_BIT0-8
		jr nz,kbbit_lp		;bucle hasta instruccion bit 0,? (#47)
	dec c				;decrem, lineas
	jr kbline_lp		;bucle

.kbline_mod:	;B, C, HL	(ins_bit, line, mod addr)
	;modifica las rutinas de controles asignando una instruccion "bit (B),?" y
	;la direccion del buffer de teclado
	inc hl				;inc puntero mod addr
	push hl				;preservar mod addr 
	inc hl
	inc hl
	inc hl
	ld (hl),b			;modificar instruccion (BIT b,?)
	pop de				;recuperar mod addr + cambio de reg
	ld hl,keyb_buffer		;buffer addr
	ld b,0				;resetear b (ya usado)
	add hl,bc			;sumar offset C (LINEA) al buffer
	ex de,hl			;intercambiar regs
	ld (hl),e			;modificar LINEA que apunta al buffer
	inc hl
	ld (hl),d	
	ret

.show_keyb_conf:	;HL,DE  (keyb_conf, pos)	;muestra conf de los controles
	push hl				;preservar conf
	ld b,6				;num ctrls de conf
	.kb_conf_lp:
	ld c,(hl):inc hl		;C key_code a mostrar
	push de				;preservar regs
	push bc
	push hl				;preservar conf con incremento
	call show_key			;mostrar keyb_code
	pop hl				;recuperar conf con incremento
	pop bc				;recuperar regs		
	pop de
	ld a,e				;incrementar posy
	add 8
	ld e,a
	djnz kb_conf_lp			;bucle hasta b=0
	pop hl				;recuperar conf
	ret

.show_key: ;C, DE (keyb_code offset, pos)	;determina si un keybcode es tipo char o string (bit7)
	ld b,0				;resetear b
	ld hl,keyb_codes		;apuntar a keyb codes
	add hl,bc			;aadir num keyb_code (offset)
	ld a,(hl)			;cargar contenido (offset str / num char)
	bit 7,a				;bit 7 del contenido (no usar bit 7,(hl) porque se debe restar el acumulador)
	jr z,show_char			;si no hay bit7 ir a char
	;jr nz,show_key_str		;si hay bit7 ir a string
	
.show_key_str: ;A,DE (str offset, pos)	;mostrar key tipo string
	sub 128				;restar el bit7
	ld c,a				;offset de strings
	ld hl,keyb_str			;apuntar a strings
	add hl,bc			;aadir offset
	jp text_spr			;funcion de texto
	
.show_char: ;A,DE (num char, pos)	;mostrar char
	push hl				;preservar
	ld hl,char			;apuntar a char_str
	ld (hl),a			;grabar el num char
	call text_spr			;funcion de texto
	pop hl				;recuperar
	ret

;***********************************************************************
;MODO
;***********************************************************************
.menu_modo:
	call key_pressed:ret nz
	ld b,#05
	call arrows
	ld hl,delete_modo_fill:call table_fill			;borrar set strings 
	ld hl,modo_vs_str_table:ld a,1:call table_str_lp	;string
	ld a,(modo)
	inc a				;incrementar opcin
	cp 7:jr c,set_modo_option	;si es menor a max options+1 buscar ndice
	ld a,1				;si es mayor o igual poner la 1
.set_modo_option: ;A	(opcion) 
	ld hl,modo1_conf		;establecer puntero a conf
	ld bc,5				;num bytes offset de conf
	ld d,1				;ndice de inicio
.set_modo_option_lp:
	cp d				;comparar ndice y opcin
	jr z,modo_do			;si es igual ir a subrutina 
	add hl,bc			;sino, incrementar offset del puntero
	inc d				;e incrementar ndice
	jr set_modo_option_lp		;bucle
.modo_do:			;leer la tabla, copiar setup y mostrar strings
	ld (modo),a		;set menu option
	ld b,(hl):inc hl 
	ld c,(hl):inc hl 
	ld (c_zone),bc		;set zona c1 y c2 
	ld a,(hl):inc hl     	
	ld (ia_zone),a		;set zona ia
	ld e,(hl):inc hl	;string table
	ld d,(hl) 		;string table
	ex de,hl
	jp table_str		;fnc tablas de textos

;***********************************************************************
;VICTORIA
;***********************************************************************	
.menu_victoria:
	call key_pressed:ret nz
	ld b,#07
	call arrows
	ld a,(victoria)
	inc a
.set_victoria_option:
	;cp 1:;jr z,victoria1
	cp 2:jr z,victoria2		
	ld a,1				;si es distinto de 2 cargar victoria1
.victoria1:
	ld hl,menu_victoria1_str_table
	jr victoria_do
.victoria2:
	ld hl,menu_victoria2_str_table
	;jr victoria_do
.victoria_do:
	ld (victoria),a					;menu opt
	call table_str					;strings
	ld a,(balls_option):jr set_balls_option		;modifica balls

;***********************************************************************
;BALLS
;***********************************************************************
.menu_balls:
	call key_pressed:ret nz
	ld b,#09
	call arrows
	ld a,(balls_option)
	inc a				;incrementar opcion
	cp 6:jr c,set_balls_option	;si es menor a max.options+1 buscar indice
	ld a,1				;si es mayor o igual poner la 1
.set_balls_option: ;A	(opcion)
	ld hl,balls_conf		;establecer puntero a conf
	ld d,1				;indice de inicio
.set_balls_option_lp:
	cp d				;comparar indice y opcion
	jr z,points_values		;si es igual ir a subrutina 			
	inc hl				;sino, incrementar puntero
	inc hl
	inc d				;e incrementar indice
	jr set_balls_option_lp		;bucle	
.points_values:
	ld (balls_option),a		;guardar opcion menu
	ld a,(hl) 			;num bolas (primer byte tabla)
	ld (menu_num_balls),a		;guardar

	push hl
	ld de,MENU_BALLS_STR_POS:call print_num8_offset	;mostrar numero
	pop hl
	inc hl				;incrementa tabla
	ld a,(hl)			;puntos shot (segundo byte)
	ld (shot1+1),a			;guardar modificando otra rutina
	ld h,0
	ld l,a
	add hl,hl			;multiplicar
	add hl,hl
	add hl,hl
	ld (goal2_value+1),hl		;puntos de gol, modificando otra rutina
	ret

;***********************************************************************
;EQUIP
;***********************************************************************
.menu_equip:
	call key_pressed:ret nz		;comprobar pressed
	ld b,#0B			;arrows 11 y 12
	call arrows			;requiere bc (arrows)
	ld a,(equipacion)		;opcion menu
	inc a				;incrementar opcin
.set_equip_random:		
	cp 8:jr c,set_equip_option	;si es menor a max.equips+1 buscar ndice
	ld a,1				;si es mayor o igual poner la 1
.set_equip_option: ;A	(opcion)
	ld hl,equipacion1		;establecer puntero a paletas
	ld bc,9				;num bytes offset entre paletas
	ld d,1				;indice de inicio
.set_equip_option_lp:
	cp d				;comparar ndice y opcin
	jr z,equip_do			;si es igual ir a subrutina 
	add hl,bc			;sino, incrementar offset puntero
	inc d				;e incrementar ndice
	jr set_equip_option_lp		;bucle
.equip_do:
	ld (equipacion),a		;guardar menu opt
	ld a,6				;ini pen
	ld d,15				;end pen +1
.setcolors:	;HL,A,D	(pal addr, ini pen, end pen)
	.color_lp:
	ld b,#7f			;gate array
	out (c),a  			;set pen
    	outi				;"ld c,(hl)" + out (c),c + inc hl + dec b ;set/sig. color 
	inc a				;sig. pen
	cp d				;fin?
	jr c,color_lp			;bucle mientras sea menor
	ret

;***********************************************************************
;OPTIONS
;***********************************************************************	
;lectura de opciones al iniciar el men
.set_options:
	ld hl,options_tbl		;apuntar a tabla de datos
	ld b,8				;num. ndices
	.set_options_lp:		;ini bucle
	ld e,(hl):inc hl		;pos
	ld d,(hl):inc hl		;pos
	ld a,(hl):inc hl		;ins bit
	ld (set_options_ins_bit+1),a	;modificar instruccin bit
	ld a,(options)			;cargar bits de opciones
	.set_options_ins_bit:
	bit 0,a				;comparar y modificar flag zero
		push bc			;preservar regs
		push hl
		ld hl,str_mark		;char
		call nz,text_spr	;si bit nozero pintar char
		pop hl
		pop bc
	inc hl				;inc ltimo byte de la tabla no usado en esta rutina
	djnz set_options_lp		;dec b y bucle mientras nozero
	ret

;llamadas desde la rutina de control del men
.menu_autobar1:ld hl,option1_tbl:jr menu_option
.menu_autozone1:ld hl,option2_tbl:jr menu_option
.menu_autobar2:ld hl,option3_tbl:jr menu_option
.menu_autozone2:ld hl,option4_tbl:jr menu_option
.menu_foul:ld hl,option5_tbl:jr menu_option
.menu_possession:ld hl,option6_tbl:jr menu_option
.menu_regs:ld hl,option7_tbl:jr menu_option
.menu_sound:ld hl,option8_tbl:;jr menu_option

.menu_option:	;HL (tabla)
	call key_pressed:ret nz		;comprobar pressed
	call set_pressed

	ld e,(hl):inc hl		;leer la tabla
	ld d,(hl):inc hl
	ld a,(hl):inc hl
	ld (options_ins_bit+1),a	;modificar ins_bit
	ld a,(options)			
	xor (hl)			;alternar opcin
	ld (options),a
	.options_ins_bit:
	bit 0,a				;comprobar flag
	jr z,menu_option_no		;si zero opcin desmarcada
					;si nozero opcin marcada
.menu_option_yes:
	ld hl,str_mark
	jr menu_opt_print
.menu_option_no:
	ld hl,str_sp
	;jr menu_opt_print
.menu_opt_print
	call text_spr 			;pintar char
	jp option_count_reset		;resetear contador men

;***********************************************************************
;REGS
;***********************************************************************
;contar total de registros distintos a 0 en 8 tablas de datos.
.reg_count:
	xor a			;rst. acumulador 0
	ld h,#30		;iniciar puntero cols (30-37)
	ld b,8			;num. de columnas a checkear
	ld de,0			;rst. contador de registros  distintos a 0
	.rc_cols_lp:
		ld l,#20	;iniciar puntero filas (20-A8)
		ld c,#88	;num. de filas a checkear (136)
		.rc_rows_lp
		cpi		;inc L (puntero), dec C (filas), y si A = (HL)
		jr z,rc_noinc	;saltar si zero
		inc de		;inc. contador de registros distintos a 0
		.rc_noinc:
		cp c		;fin de filas?
		jr nz,rc_rows_lp;si nozero, bucle
	inc h			;incrementar sig. columna del puntero
	djnz rc_cols_lp		;dec B, bucle mientras nozero
	ex de,hl		;inter. contador a HL (string)
	ld c,3			;long. string (chars)
	ld de,MENU_NREGS_STR_POS;scrpos
	jp print_num16		;print

;***********************************************************************
;COUNTER
;***********************************************************************
.menu_counter:
	ld hl,0				;variable 2B
	inc hl				;incrementar
	ld (menu_counter+1),hl		;automodificar
	ld a,h
	cp 1:call z,delete_ctrls	;si 1, borrar listas de ctrls
	cp DEMO_DELAY:jr z,demo		;si constante ir a modo demo
	ret
.menu_count_reset:
	ld hl,0				;resetear
	ld (menu_counter+1),hl		;contador
	ret
.demo:
	call random			;num
	and %00000111			;de 0 a 7
	inc a				;nunca 0, sino error grave
	call set_equip_random		;mostrar
	ld a,1
	call set_balls_option		;camabiar bolas
	ld a,6
	call set_modo_option		;cambiar modo
	jp prep_start			;comenzar ia vs ia 
	
.delete_ctrls:
	ld hl,delete_set_p1_fill:call table_fill	;;borrar strings del set  
	ld hl,delete_set_p2_fill:jp table_fill		;;borrar strings del set  
