;***********************************************************************
;SCOREBOARD
;***********************************************************************
.records:
	ld sp,STACK					;resetear pila
	call crt8000					;pantalla en 8000

	if ROM
	call clear_scr					;limpiar pantalla
	else
	;call copy_buffer
	call disspr_text_mod1				;texto normal
	call clear_scr					;limpiar pantalla
	endif

	call draw_title					;ttulo
	ld hl,scoreboard_str_table:call table_str	;strings
	ld hl,scoreboard_fills:call table_fill		;rellenos
	call check_scoreboard				;comprobar score
	call show_scoreboard				;pintar scoreboard
	call points_check				;comprobar puntos
	
	ld a,(new_record_check)
	or a:						;si no hay score nuevo
	call z,print_last_points			;poner ltimo

	ld de,SONG2					;arkos music
	call PLY_Init					;arkos player init
	call crtC000					;pantalla C000

.records_loop:	
	call wait_vsync							;esperar
	ld a,(options):bit BIT_SOUND,a:call nz,PLY_Play			;si hay sonido, poner msica
	call keyb_scan							;buscar tecla
	ld a,(keyb_buffer+LIN_EXIT):bit BIT_EXIT,a:jp z,menu		;ESC, volver a men
	ld a,(keyb_buffer+LIN_KEY0):bit BIT_KEY0,a:jp z,prep_start	;0, comenzar partido
	call name_scoreboard				;rutina de nuevo record
	jr records_loop					;bucle
;-------------------------------------------------------------------------------------------
.check_scoreboard:
	ld hl,scoreboard		;puntero de la tabla de records
	ld a,SCB_INI_REC		;ndice de inicio	1
	.check_scoreboard_lp:		;bucle
	push hl				;preservar puntero
    	ld c,(hl)			;valores de la tabla
     	inc hl
     	ld h,(hl)
     	ld l,c				;HL puntos a comparar
	inc hl				;sumar un punto para empates 
					;(el acarreo sbc pone el record como superior)
	ld bc,(new_record)		;cargar nuevo record (si lo hay)
	sbc hl,bc			;comparar y alterar acarreo
	pop hl				;recuperar puntero
	ld bc,SCB_OFFSET_PT		;offset	puntero 10
	jr c,order_scoreboard		;si hay acarreo hay nuevo record
	add hl,bc			;aadir offset al puntero para los sig. puntos 
	inc a				;incrementar indice
	cp SCB_TOTAL_REC+1		;fin?	16
	jr c,check_scoreboard_lp	;bucle mientras sea menor
	xor a
	ld (new_record_check),a		;no hay nuevo record, poner check a 0
	ret

.order_scoreboard:	;A,HL,BC (ndice, puntero newrecord, offset)	
	push hl				;preservar puntero new record	
	ld d,a				;ndice final
	xor a				;resetear acarreo (check lo deja alterado)
	ld e,SCB_LAST_POSY		;pos Y ultima fiLa (+#8) #B0
	ld a,SCB_TOTAL_REC		;ndice de inicio	15
	ld hl,record15c			;ltimo puntero de la tabla(primero a modificar)
	.order_scoreboard_lp: 		;bucle (de fin a inicio)
	push af				;preservar ndice
	push de				;preservar fin / fila
	;---------------
	ld d,h				;HL->DE (puntero de record a manipular)
	ld e,l	
	sbc hl,bc			;restar offset a HL (record superior)
	push bc				;preservar offset
	ldir				;HL->DE hasta BC=0 (copia de datos del superior)
	pop bc				;recuperar offset
	sbc hl,bc			;restart offset a HL (ldir lo modifica)
	;---------------
	pop de				;recuperar fin (D) / fila (E)
	ld a,e				;usar A para 
	sub SCB_ROW			;restar filas	#8
	ld e,a				;y usar mas tarde
	pop af				;recuperar indice
	dec a				;decrementar indice
	cp d				;fin?
	jr nc,order_scoreboard_lp	;bucle
	
	ld h,SCB_POSX_NAME		;resetear pos x (pos nombre) #16
	ld l,e				;fila pos y (fila de record)
	ld (new_record_pos),hl		;guardar pos
	
	pop hl				;recuperar puntero new record 
.add_new_record: ;HL,BC	(puntero,offset)
	ld a,65				;char A
	ld (char),a			;rst char temporal
	ld a,1			 
	ld (new_record_check),a		;1 debe escribir nombre mas tarde
	ld de,new_record		;puntero variables temporales newrecord
	ex de,hl			;intercambiar regs
	ldir				;HL>DE hasta BC=0 (copia datos temporales en scoreboard)
	ex de,hl			;intercambiar regs
	ld bc,SCB_NAME_LENG		;offset para nombre 6
	sbc hl,bc			;restar el offset al puntero en donde acabo ldir
	ld (new_record_name_addr),hl 	;guardar addr para escribir nombre mas tarde
	;---------------------------	;Detalles
	
	call check_maxpoints_table	;selecciona tabla de descripcion
	;ld hl,newrecord_str_table	;cargar textos descripcion normal
	call table_str			;tablas de texto
	;---------------------------
	ld hl,str_arrow1		;string flecha
	ld de,(new_record_pos)		;pos para flecha indicadora
	ld a,d			
	sub SCB_ARROW_POS_OFFSET	;desplazar x -10
	ld d,a
	jp text_spr

.check_maxpoints_table:			;comprobar maxima puntuacion
	ld hl,(points1)		
	ld de,MAXPOINTS_MARGIN
	add hl,de			;comprobar mayor de 60000
	jr nc,check_usedballs_table	;si no hay acarreo, comprobar siguiente
	ld hl,newrecord_str_table3	;sino, cargar tabla maxima puntuacion
	ret
.check_usedballs_table:			;comprobar bolas usadas
	ld a,(used_balls):cp 255	;comprobar 255 bolas
	jr nz,ld_newrecord_table	;si no hay flag zero cargar tabla normal
	ld hl,newrecord_str_table2	;sino, cargar tabla maximas bolas
	ret
.ld_newrecord_table:
	ld hl,newrecord_str_table	;tabla normal new record
	ret

;***********************************************************************
.show_scoreboard:
	ld hl,scoreboard		;puntero de la tabla
	ld a,1				;primer ndice
	ld e,SCB_POSY			;pos Y pantalla (DE)	#38
	.draw_scoreboard_lp:
	push af				;preservar indices

	;pintar rango	A,E
	push hl
	ld d,SCB_POSX_RANK:call print_num8_offset		;#10
	pop hl
	
	;pintar puntos	HL,E
	ld c,(hl)
	inc hl
	push hl
	ld h,(hl)
	ld l,c
	ld d,SCB_POSX_SCORE:call print_num16_len5		;#36
	pop hl		
	inc hl	;inc puntero
	
	;pintar num bolas	HL,E
	push hl
	ld d,SCB_POSX_BALLS:ld a,(hl):call print_num8_offset	;#2c
	pop hl
	inc hl	;inc puntero
	
	;pintar char bola	E
	push hl
	ld d,SCB_POSX_ICO:call ico_ball
	pop hl
	
	;pintar nombre	HL,E
	push hl
	ld d,SCB_POSX_NAME:call text_spr			;#16
	pop hl
	ld bc,SCB_NAME_LENG+1	;inc puntero 7
	add hl,bc

	;incrementar fila pantalla	E
	ld a,e
	add SCB_ROW
	ld e,a
	
	pop af				;recuperar ndice
	inc a				;incrementar ndice
	cp SCB_TOTAL_REC+1		;fin?	16
	jr c,draw_scoreboard_lp		;bucle
	ret

;***********************************************************************

.name_scoreboard:
	ld a,(new_record_check)		;mirar si hay nuevo record
	or a:ret z			;sino, fuera
	score_control1a:ld a,(keyb_buffer+LIN_SET1_LF):bit BIT_SET1_LF,a:jr z,ascii_del
	score_control1b:ld a,(keyb_buffer+LIN_SET1_RG):bit BIT_SET1_RG,a:jr z,ascii_ins
	score_control1c:ld a,(keyb_buffer+LIN_SET1_UP):bit BIT_SET1_UP,a:jr z,ascii_up	
	score_control1d:ld a,(keyb_buffer+LIN_SET1_DW):bit BIT_SET1_DW,a:jr z,ascii_down
	xor a:ld (key_pressed+1),a	;liberar tecla
	ret
.ascii_ins:
	call key_pressed:ret nz	;si hay tecla pulsada salir
	ld a,(new_record_posx)		;cargar posx
	add 2				;inc pos pantalla
	cp SCB_POSX_NAME_LIMIT:ret nc	;comprobar limite posx
	ld hl,(new_record_name_addr)	;cargar puntero
	inc hl				;incrementar puntero
	jr set_name_addr		;ir a grabar puntero
.ascii_del:				;lo mismo que ins
	call key_pressed:ret nz	
	ld a,(new_record_posx)
	sub 2
	cp SCB_POSX_NAME:ret c			
	ld hl,(new_record_name_addr)
	dec hl
	;jr set_name_addr
.set_name_addr:		;A, HL
	ld (new_record_posx),a		;grabar posx
	ld (new_record_name_addr),hl	;grabar puntero para caracter
	call set_pressed		;tecla pulsada
	ret
.ascii_down:				;cambiar de caracter abajo
	call key_pressed:ret nz	;si hay tecla pulsada salir
	ld a,(char)
	dec a				
	cp SCB_CHR_LIMIT_DW:ret c	;limite	32
	jr set_char			;grabar en scoreboard y mostrar en pantalla
.ascii_up:				;lo mismo
	call key_pressed:ret nz	
	ld a,(char)
	inc a
	cp SCB_CHR_LIMIT_UP:ret nc		;97	
	;jr set_char			
.set_char:	;A (char)
	ld (char),a			;grabar char temporal
	ld c,a
	call set_pressed		;tecla pulsada
	ld hl,(new_record_name_addr)	;cargar dir. puntero
	ld (hl),c			;grabar char en scoreboard
	ld de,(new_record_pos)		;cargar pos
	ld hl,char			;cargar string char
	jp text_spr