;***********************************************************************
;SOUND FX
;***********************************************************************
.sustain:
	halt			;espera
	djnz sustain		;loop
	ret
.snd_whistle:
	ld hl,sound_whistle	;tabla
	call patt_toneb
	ld b,70		
	call sustain
	ld d,13				;shape reg psg
	ld e,1				;shape val psg
	call psg_reg
	ld b,120
	jr sustain
.snd_wall:
	push hl
	ld hl,sound_wall
	call patt_tonenoiseb
	pop hl
	ret
.snd_box:
	ld hl,sound_box		;tabla
	call patt_noiseb
	ld b,104		;100
	call sustain
	ld hl,sound_box_end	;tabla
	jr patt_noiseb

.snd_bonus:ld hl,sound_bonus:jr patt_toneb
.snd_shot:ld hl,sound_shot:jr patt_noiseb
.snd_menu:ld hl,sound_menu:;jr patt_toneb

;***********************************************************************
;PATTERNS
;***********************************************************************
.patt_toneb:ld de,regs_toneb:jr table_sndpatt
.patt_tonenoiseb:ld de,regs_tonenoiseb:jr table_sndpatt
.patt_noiseb:ld de,regs_noiseb:;jr table_sndpatt

.table_sndpatt: ;requiere HL, DE (tabla valores, tabla registros)
	ld a,(options):bit BIT_SOUND,a:ret z	;desactiva sonido con la option del menu
	ld a,(de):inc de	;value mixer del patron
	push de
	ld d,7			;reg mixer del patron
	ld e,a			
	call psg_reg		;set mixer
	pop de
	ld a,(de):inc de	;num indices
	.table_sndpatt_lp:
	push de			;preservar patron (registros)
	push hl			;preservar sonidos (valores)
	ex de,hl		;inter.regs
	ld d,(hl)		;registro psg del patron
	pop hl			;recupera tabla sonidos
	ld e,(hl)		;valor psg de la tabla de sonidos
	call psg_reg		;set psg
	pop de			;recuperar patron de registros
	inc de			;inc tabla de patrones (registros)
	inc hl			;inc tabla de sonidos (valores)
	dec a			;dec indice
	jr nz,table_sndpatt_lp	;bucle mientras nozero
	ret

;***********************************************************************
;PSG
;***********************************************************************
.seq_start:ld hl,sound_amp1:jr table_snd
.seq_end:ld hl,sound_amp2:;jr table_snd

.table_snd: ;HL (tabla reg/valor)
	ld a,(options):bit BIT_SOUND,a:ret z	;desactiva sonido con la option del menu
	ld a,(hl):inc hl	;indices
	.table_snd_lp:
	ld d,(hl):inc hl	;registro
	ld e,(hl):inc hl	;valor
	call psg_reg		;set
	dec a			;dec indice
	jr nz,table_snd_lp	;bucle mientras nz
	ret

.psg_reg:	;D, E  (reg, valor)
	;di
	ld bc,#F400
	out(c),D	;registro
	ld bc,#F6C0
	out(c),c	;set
	defb #ed,#71	;out(c),0 ;inactivo
	ld b,#F4
	out(c),E 	;valor
	ld bc,#F680
	out(c),c	;set
	defb #ed,#71	;out(c),0 ;inactivo
	;ei
	ret

;***********************************************************************
;SEQUENCE
;***********************************************************************
.snd_sequence:
	call seq_start
	.sndseq_alt:
	ld a,-1:neg:ld (sndseq_alt+1),a
	cp 1:call z,snd_sequence2
	cp -1:call z,snd_sequence1
	jr seq_end

.snd_sequence2:call seq2:;jr seq1
.seq1:
	ld a,100
	seq1_lp
	call seq
	dec a
	cp 10
	jr nc,seq1_lp
	ret
	
.snd_sequence1:call seq1:;jr seq2
.seq2:
	ld a,20
	seq2_lp
	call seq
	inc a
	cp 50
	jr c,seq2_lp	
	ret
	
.seq:
	ld d,2
	ld e,a
	call psg_reg
	halt
	halt	
	ret