;***********************************************************************
; CHECKS - SCORE
;***********************************************************************	
.clear_results:
	ld hl,0						;reset resultados score
.set_results:
	ld (results),hl					;set resultados
	ret

.setup_balls:
	ld de,BOARD_ICO_BALL_STR_POS			;pos ico
	ld a,(victoria)					;cargar opcion
	cp 1:call z,ico_ball				;mostrar icono
	cp 2:call z,ico_flag
	;jr print_balls
.print_balls:
	ld de,BOARD_BALLS_STR_POS			;pos valor bolas
	ld a,(balls)					;catgar bolas
	jp print_num8_offset				;mostrar

.dec_balls:ld a,b:or a:ret z:dec a:ld (balls),a:ret	;set bolas con decremento
.check_balls:						;al meter gol
	ld a,(used_balls)
	inc a						;incrementar
	jr z,end_match2					;si llega a 0 finaliza el partido
	ld (used_balls),a				;bolas usadas
.check_balls2:						;sacar en el start
	ld hl,(score)					;marcador 1 y 2 (score 16bits)
	call set_results				;copia el marcador a resultados
	ld a,(balls)					;bolas que quedan
	ld b,a
	ld a,(victoria)					;condicion de victoria
	;cp 1:;jr z,best_of				;condicion de victoria "mejor de"
	cp 2:jr z,win_to				;condicion de victoria "golear"
	;ret

.best_of:						;"mejor de"
	ld a,b:add l:cp h:jr c,end_match1		;si bolas+marc2 < marc1, victoria jg1
	ld a,b:add h:cp l:jr c,end_match2		;lo mismo, victoria jg2
	call dec_balls					;sino, decrementar bola
	jr print_balls					;y mostrar

.win_to:						;"golear"
	ld a,h:cp b:call nc,check_p1			;si marc1 >= bolas, check1
	ld a,l:cp b:call nc,check_p2			;si marc2 >= bolas, check2
	ld a,h:cp b:ret c:cp l:call z,print_deuce	;si marc1 < bolas salir y si marc1=marc2 empate
	ret
	
.check_p1:ld a,h:sub 2:cp l:jr nc,end_match1:ret	;si marc1 -2 >= marc2, victoria jg1
.check_p2:ld a,l:sub 2:cp h:jr nc,end_match2:ret	;si marc2 -2 >= marc1, victoria jg2


.end_match1:
	ld a,(modo):cp 3:jp c,prep_start_wresults	;jugador 1 gana, continua sig.partido
.end_match2:						;jugador 2 gana o modo >=3
	ld a,(modo):cp 3:jp nc,menu			;si el modo >= 3 ir a menu
	jp records					;si no ir a records

;***********************************************************************
;TEXT
;***********************************************************************
.points_check:
	xor a						;resetear acarreo
	ld hl,(points1)					;cargar puntos
	ld de,MINPOINTS_MARGIN				;valor de comprobacion
	sbc hl,de					;restar + acarreo
	jr c,points_reset				;si hay acarreo saltar guardar puntos
	add hl,de					;aadir comprobacion
	ld (last_points),hl				;guardar puntos en nueva var
.points_reset:	
	ld hl,0						;resetear HL
	ld (points1),hl					;guardar puntos reseteados
	xor a						;resetear A
	ld (used_balls),a				;guardar bolas usadas
	ret

.points_checkmax:
	ld hl,(points1)					;cargar puntos
	ld de,MAXPOINTS_MARGIN				;maximos puntos
	add hl,de					;si es mayor de 60000
	jr c,end_match2					;finalizar partido
	ret

.points_bonus:
	ld a,(modo):cp 3:ret nc				;modo >=3 salir
	call snd_bonus					;sonido bonus
	xor a						;resetea acumulador
	ld hl,(points1)					;cargar puntos
	ld de,MINPOINTS_MARGIN				;minimos puntos/incremento puntos
	sbc hl,de					;restar minimos puntos a puntos
	ret c						;si hay acarreo salir
	
	ld hl,BONUS_VALUE				;valor bonus	
	.bonus_lp:
	call wait_vsync2				;esperar
	push de						;preservar incremento de puntos
	push hl						;preservar bonus
	call print_points1				;aade inc. puntos y muestra string
	pop hl						;recuperar regs
	pop de
	sbc hl,de					;restar inc.puntos a bonus y alterar acarreo
	jr nz,bonus_lp					;si nozero repetir
	call snd_sequence1				;secuencia de sonido al finalizar
	jp seq_end					;fin de scuencia al psg
;-------------------------------------------------------------------------------
.posession:
	nop						;nop/ret options setup
	ld de,POSESSION_STR_POS				;string pos
	call countdown_dly				;rutina contador (ret flag zero)
	ret nz						;salir si no zero
.posession_foul:
	ld a,(ball_area)				;si el area es 0 la bola esta entre las porterias
	or a:call z,ld_last_touch			;cargar last touch
	ld b,a						;preservar ball_area
	ld de,#FF03					;sacar de centro + dir saque
	and TEAM2					;alterar flag
	jp nz,foul					;si nozero, falta team2
	ld d,1						;dir saque
	ld a,b						;recuperar ball_area
	and TEAM1					;alterar flag
	jp nz,foul					;si nozero, falta team1
	ret
.posession_reset:
	nop						;nop/ret options setup
	ld a,(countdown_num+1)
	cp POSESSION_TIME-1:ret nc			;si es mayor que el max. salir
	ld a,POSESSION_TIME				;time reset
	ld (countdown_num+1),a				;time reset
	ld a,10						;string reset
	ld de,POSESSION_STR_POS 			;string reset
	jp print_num8_len2				;string reset
.ld_last_touch:
	ld a,(last_touch)
	ret
;-------------------------------------------------------------------------------

.countdown:	;in DE (str pos) - out flag zero (zero = countdown end)
	halt
	;----------------------------
	.countdown_dly:					
	ld a,COUNTDOWN_DELAY				;variable contador
	dec a						
	ld (countdown_dly+1),a				;mod, variable cont.
	ret nz						;salir si nozero, ret flag zero
	;----------------------------
	ld a,COUNTDOWN_DELAY
	ld (countdown_dly+1),a				;resetea variable cont.
	;----------------------------
	.countdown_num:
	ld a,COUNTDOWN_TIME				;variable countdown num str
	dec a
	ld (countdown_num+1),a				;mod. var countdown num str
	;----------------------------
	push af						;preservar num str
	cp 11:call c,print_num8_offset			;si es menor de 11 mostrar
	pop af						;recueprar num str
	push af						;preservar num str
	cp 6:call c,snd_menu				;si es menor de 6 snoido
	pop af						;recueprar num str
	;----------------------------
	ret						;ret flag zero

;-------------------------------------------------------------------------------
if SHWOCREDITS
.credits_pause
	ld hl,5000					;tiempo de pausa
	.credits_lp:
	call wait_vsync					;esperar
	dec hl						;dec pausa
	ld a,h
	or l						;alterar flag
	jr nz,credits_lp				;bucle si nz
	ret
.credits:
	call draw_title					;mostrar titulo
	ld hl,credits_str_table:jr table_str		;strings creditos
endif
;-------------------------------------------------------------------------------
.setup_players:
	if ROM
	ld hl,modo_vs_str_table:ld a,3:call table_str_lp	;cuidado con el orden, sin medidas
	call draw_equip_title
	else
	ld hl,waiting_str_table:ld a,2:call table_str_lp	;cuidado con el orden, sin medidas
	call draw_title
	endif
	ld a,(modo):cp 3:jr nc,no_print_points		;>3 no mostrar puntos
	call print_hiscore
	call print_points
	no_print_points
	ld a,(modo)
	if ROM
	ld hl,modo1_str_table		;apuntar a la primera tabla y calcular offset despues
	else
	ld hl,set_player_m1_str_table	;apuntar a la primera tabla y calcular offset despues
	endif
	jr set_option_str		;rutina de offset
;-------------------------------------------------------------------------------
.setup_score:
	xor a:call set_score1						;reinicia/print score
	xor a:call set_score2						;reinicia/print score
	ld de,SCORE_MINUS_STR_POS:ld hl,str_minus:call text_spr		;print score
	ld a,(modo)
	ld hl,set_score_m1_str_table	;apuntar a la primera tabla y calcular offset despues
	;jr set_option_str
	;continua
;-------------------------------------------------------------------------------
.set_option_str: ;A,HL	(modo,tabla)
	ld b,0				;resetear B
	ld d,1				;indice de inicio
.set_option_str_lp:
	cp d				;comparar indice y opcion
	jr z,table_str			;si es igual ir a subrutina 
	;Calcular offset con el primer byte de la tabla
	ld c,(hl)			;primer byte de la tabla
	sla c				;multiplicar x2 el primer byte
	add hl,bc			;aadir offset
	inc c				;sla c+1 (primer byte que indica el tamao)
	add hl,bc			;aadir offset
	inc d				;e incrementar indice
	jr set_option_str_lp		;bucle
;-------------------------------------------------------------------------------
.print_deuce:
	ld hl,str_deuce			;string
.print_msg:
	push hl
	call delete_main_msg		;borrar msg principal
	pop hl
	ld de,MAIN_MSG_STR_POS		;pos
	call text_spr			;mostrar deuce
	call snd_whistle		;sonido
.points_restore:			;2 llamadas desde main
	call delete_main_msg		;borrar msg principal
	jp print_points			;mostrar puntos
;-------------------------------------------------------------------------------
.msg_exit:							;mostrar string salir
	call snd_menu
	ld de,MAIN_MSG_STR_POS:ld hl,str_exit:jr text_spr
.msg_start:							;mostrar msg lanzar
	ld de,MAIN_MSG_STR_POS:ld hl,str_start:jr text_spr
	
.ico_ball:ld hl,str_ball:jr text_spr				;mostrar bola
.ico_flag:ld hl,str_flag:jr text_spr				;mostrar flag

;***********************************************************************
;; STRING TABLE
;***********************************************************************
.table_str:	;HL (tabla)
	ld a,(hl):inc hl	;num ndices
	.table_str_lp:
	ex af,af'		;preservar indices
	ld e,(hl):inc hl       	;pos
	ld d,(hl):inc hl       	;pos
	ld c,(hl):inc hl      	;string addr
	push hl			
	ld h,(hl)		;string addr
	ld l,c			
	call text_spr		;mostrar string
	pop hl			
	inc hl			;inc tabla
	ex af,af'		;rec. indice
	dec a			;dec. indice
	jr nz,table_str_lp	;bucle si nozero    
	ret
	
;***********************************************************************
;; TEXT 2 SPRITE
;***********************************************************************
.text_spr:   ;requiere DE, HL (pos xy, string addr)
	ld a,(hl)		;A es el ascii
	or a			;si el string acaba en 0
	ret z			;terminar
	sub 32			;restar 32 para calcular la letra (En ASCII space=32)
	ld bc,ascii_spr   	;apunto a la primera letra de la tabla de chars
	push hl			;preservar puntero string
	push de			;preservar posicion

	ld l,a			;prepara offset en la tabla de chars con otro hl
	ld h,0			
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc		;HL char(sprite) a pintar, tabla de char+offset
	ex de,hl		;intercambiar pos/spritechar
	call find_addr		;calcula posicion real de pantalla
	ld a,8
	.text_spr_call:
	call disspr2	;funcion de sprites, pintar char
	;call disspr_trnsp
	pop de			;recuperar pos
	
	inc d			;incrementar pos x 2 octetos
	inc d			;para el siguiente char
	
	pop hl			;recuperar puntero string
	inc hl			;inc puntero string (siguiente char)
	jr text_spr		;loop

;-------------------------------------------------------------------------------
;funciones con numeros
.inc_score1:ld a,(score1):cp 99:ret z:inc a
.set_score1:ld (score1),a:ld de,SCORE_VALUE1_STR_POS:jr print_num8_len2
.inc_score2:ld a,(score2):cp 99:ret z:inc a
.set_score2:ld (score2),a:ld de,SCORE_VALUE2_STR_POS:jr print_num8_len2

.print_results:
ld de,MENU_SCORE_MINUS_STR_POS:ld hl,str_minus:call text_spr
ld a,(result1):ld de,MENU_SCORE_VALUE1_STR_POS:call print_num8_len2
ld a,(result2):ld de,MENU_SCORE_VALUE2_STR_POS:jr print_num8_len2

.print_points:
ld de,0
.print_points1:	;DE	(add points)
ld a,(modo):cp 3:ret nc
ld hl,(points1):add hl,de:ld de,POINTS1_STR_POS:ld (points1),hl:jr print_num16_len5

.print_last_points:
ld de,POINTS1_STR_POS:ld hl,(last_points):call print_num16_len5	;continua prnt_hiscore
.print_hiscore:
ld de,HISCORE_STR_POS:ld hl,(record1c):jr print_num16_len5

;***********************************************************************
;; NUMBERS
;***********************************************************************
.print_num16_len5:ld c,5:jr print_num16

.print_num8_offset:		;A,DE (num8bits, pos)
	push de			;preservar pos
	push af			;preservar num
	
	ld hl,str_sp2		;borrar lo que haya en pos con espacios en blanco,
	call text_spr		; la posicion (DE) es la misma
	
	pop af			;recuperar num
	pop de			
	cp 100:jr nc,print_num8_len3
	cp 10:jr nc,print_num8_len2	;si es >=10 usar un offset de 2
	ld c,1			;offset para 1 digito por defecto
	jr print_num8		

.print_num8_len3:		;A,DE (num8bits, pos)
	ld c,3
	jr print_num8
	
.print_num8_len2:		;A,DE (num8bits 0-99, pos)
	ld c,2			;offset para 2 digitos
	
.print_num8:			;A,DE,C (num8bits 0-255, pos, length-offset)
	ld h,0			;
	ld l,a			;convertir numero a 16bits
	
.print_num16:			;HL,DE,C (num16bits, pos, length-offset)
	ld b,0			;resetear b para aadir offset al puntero mas tarde
	push de			;guardar posicion
	push bc			;guardar offset
	call number16		;convertir digitos
	pop bc			;recuperar offset
	ex de,hl		;pasar la string a HL
  	sbc hl,bc		;restar a la string el length-offset (el puntero esta al final)
	pop de			;recuperar posicion
	jp text_spr		;funcion de texto con sprites

;-------------------------------------------------------------------
;preparavalor/gdigito By Ral Simarro
;www.amstrad.es/forum/viewtopic.php?t=245&start=30

.number16: ;in HL (hex num 16bits) - out DE (string end-pointer)
	ld de,number_str	;apuntar a string temporal
	ld bc,10000	
	call digit
	ld bc,1000		
	call digit
	ld bc,100		
	call digit
	ld bc,10		
	call digit
	ld bc,1
.digit:
	xor a			;resetear digito
.digit_lp:   
	sbc hl,bc		;resta DE para comprobar carry
	jr c,digit_end		;carry? encontro digito
	inc a			;si no, incrementar digito
	jr digit_lp		;bucle
.digit_end:
	add hl,bc		;suma ultima resta
	add 48			;aadir offset ascii al digito
	ld (de),a		;guarda digito en la string
	inc de			;incrementa puntero de la string
	ret
;---------------------------------------------------------------------------------------------
ifnot ROM
;modificar rutina de texto
.disspr_text_mod1:ld hl,disspr2:jr disspr_text_mod_set
.disspr_text_mod2:ld hl,disspr_text:;jr disspr_text_mod_set
.disspr_text_mod_set:ld (text_spr_call+1),hl:ret

;routine based on techniques of Prodatron
;www.amstrad.es/forum/viewtopic.php?t=161&start=45

.disspr_text:	;A, HL, DE (height, scr addr, sprite addr)
	ex de,hl			;inter.regs
	push af				;preservar alto
	call transp_back_px		;comprobar pixels
	call transp_back_px
	pop af				;recuperar alto
	dec a				;dec alto
	ret z				;fin si zero	
	ld bc,#7fe			;sig. linea
	ex de,hl			;inter. regs
	add hl,bc			;aadir sig.linea a scr addr
	jr nc,disspr_text		;bucle si no hay acarreo
	ld bc,#c050			;sig bloque
	add hl,bc			;aadir bloque a scr addr
	jr disspr_text			;bucle

.transp_back_px:	;HL, DE (spr addr, scr addr)
	ld a,d
	sub #40				;restar pos.base de pantalla
	ld b,a				;BC posicion del buffer en #8000
	ld c,e
	ld a,(hl)			;contenido del sprite ascii
	or a:jr z,a0			;ink0
	cp #04:jr z,a1			;ink0/ink2
	cp #08:jr z,a2			;ink2/ink0
	cp #40:jr z,a1			;ink0/ink1
	cp #80:jr z,a2			;ink1/ink0
	ldi				;si nada se cumple pinta pixel del ascii normal
	ret

a1:	;HL,BC,DE (spr, scr80, scrC0)	;pixeles derechos
	ld a,(bc)			;cargar pixels del buffer
	and #aa				;anular pixels izquierdos (si los hay)
	or (hl)				;combinar pixeles del ascii
	jr a_end
	
a2:	;HL,BC,DE (spr, scr80, scrC0)	;pixeles izquierdos
	ld a,(bc)			;lo mismo
	and #55				;anular pixeles derechos (si los hay)
	or (hl)
	jr a_end

a0:	;HL,BC,DE (spr, scr80, scrC0)	;los pixels del ascii son de fondo
	ld a,(bc)			;cargar pixels del buffer
.a_end: ;HL,BC,DE (spr, scr80, scrC0)
	ld (de),a			;pintar resultado en pantalla
	inc hl				;e incrementar punteros
	inc de
	ret	
	
endif