;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################

;.area _CODE

;; ========================================================
;; ========================================================
;; INCLUDED GLOBAL SYMBOLS
;; ========================================================
;; ========================================================



;.globl _g_menutitle_0
;.globl _g_tod_0
.globl _g_aniWarStatSide
.globl _g_warrior
.globl _g_warrior_00
.globl _g_orc
.globl _g_orc_00
.globl _g_aniMenuFlame
;.globl _g_flame
;.globl _g_flame_0


;; ========================================================
;; ========================================================
;; PRIVATE DATA
;; ========================================================
;; ========================================================
;; Constants

.equ titleSize, #0x291C
.equ todSize, #0x180D
.equ warriorSize, #0x1004
.equ orcSize, #0x1004


.equ titlePos, #80*3+26
.equ flame0Pos, #80*2+20
.equ flame1Pos, #80*2+53

;.equ warriorPos, #80*15+11
;.equ orcPos, #80*15+63

.equ text1Pos, #80*12+21
.equ text2Pos, #80*14+21
.equ text3Pos, #80*16+21

.equ text4Pos, #80*23+1
.equ text5Pos, #80*24
.equ todPos, #80*22+67

text1a: .asciz "[SPACE BAR] to play"
text1b: .asciz "   [FIRE] to play  "
text2a: .asciz "[S] select joystick"
text2b: .asciz "[S] select keyboard"
text3: .asciz  "    [C] credits"
text4: .asciz  "CPC RETRODEV"
text5: .asciz  "2018 edition"

kbTwo: .db 0x00


;; ========================================================
;; Initializes empty logic, declarates entities for use
;; the entity animation techniques. This logic does nothing.
;;
;; ========================================================
;empty_logic:
;ret
entity_define flame0, 20, 16, 6, 29, _g_aniMenuFlame, 0, _g_flame, _g_flame_0, empty_logic, entity_tAnimation
entity_define flame1, 53, 16, 6, 29, _g_aniMenuFlame, 2, _g_flame, _g_flame_0, empty_logic, entity_tAnimation
entity_define warSide, 11, 120, 4, 16, _g_aniWarStatSide, 0, _g_warrior, _g_warrior_00, empty_logic, entity_tAnimation
entity_define orcLeft, 63, 120, 4, 16, _g_aniWarStatSide, 0, _g_orc, _g_orc_00, empty_logic, entity_tAnimation


;; ========================================================
;; Initializes music
;;
;; ========================================================
menu_musicInit:
    ld de, #_intro_song
    call cpct_akp1_musicInit_asm     ; Init the load of the song
    ld de, #_intro_song
    call cpct_akp1_SFXInit_asm       ; Init the load of the instruments

    ld hl, #cpct_akp1_musicPlay_asm  ; Prepares the ISR4 to call the musicPlay 
    call interrupt_setISR4          ; function everytime it wakes up
    ret

;; ========================================================
;; Initializes title, TOD logo, text and calls wait function. 
;; ========================================================
menu_start::
    call menu_musicInit
    call menu_drawTitle

    ld hl, #videoStart
    ld bc, #todPos
    add hl, bc
    ld de, #_g_tod_0
    ex de, hl
    ld bc, #todSize
    call cpct_drawSprite_asm

    call menu_drawText
    call menu_wait
    ret

;; ========================================================
;; Draws title. 
;; ========================================================
menu_drawTitle:
    ld hl, #videoStart
    ld bc, #titlePos
    add hl, bc
    ld de, #_g_menutitle_0
    ex de, hl
    ld bc, #titleSize
    call cpct_drawSprite_asm
    ret

;; ========================================================
;; Refreshes motions, wait for keys to be pressed and 
;; performs the selected action 
;; ========================================================
menu_wait:
    loop:
        call menu_motionRefresh             ;; Refreshes motions
        call cpct_scanKeyboard_asm          ;; Update keyboard state table
        ld    hl, #Key_Space                ;; hl = key code to check
        call  cpct_isKeyPressed_asm         ;; l = a = key state
        cp    #0                            ;; | 
        jr    z, one_not_pressed            ;; if (a!=0) {
            ld a, (game_keybSelected)       ;; Checks if kb is selected
            cp #1                           ;; | 
            jp z, keyb                      ;; | 
                jp one_not_pressed          ;; If 1 is pressed but joystick selected skip it
            keyb:                           ;; If keybSelected go to the game
                call menu_initTutoGame      ;; | 
                ret                         ;; | 
        one_not_pressed:                    ;; }
        ld    hl, #Key_S                    ;; hl = key code to check   
        call  cpct_isKeyPressed_asm         ;; l = a = key state
        cp    #0                            ;; |       
        jr    z, two_not_pressed            ;; if (a!=0) { 
        ld a, (kbTwo)                       ;; Checks the flag pressed for
        ld b, a                             ;; prevent key bounding
        ld a, #1                            ;; |  
        ld (kbTwo), a                       ;; |  
        ld a, b                             ;; |  
        cp #0                               ;; |  
        call z, menu_changeKeybJoys         ;; Changes between keyboard and joystick
        jr two_next                         ;; Jump to check the next key
        two_not_pressed:                    ;; If key is not pressed disables the flag
            ld a, #0x00                     ;; | 
            ld (kbTwo), a                   ;; | 
        two_next:                           ;; }
        ld    hl, #Key_C                    ;; hl = key code to check
        call  cpct_isKeyPressed_asm         ;; l = a = key state
        cp    #0                            ;; | 
        jr    z, three_not_pressed          ;; if (a!=0) {
            call credits_start              ;; Shows credits screen
            call menu_drawTitle             ;; Draws title and text when credits are finished
            call menu_drawText              ;; |
        three_not_pressed:                  ;; }
        ld    hl, #Joy0_Fire1               ;; hl = key code to check
        call  cpct_isKeyPressed_asm         ;; l = a = key state
        cp    #0                            ;; | 
        jr    z, fire_not_pressed            ;; if (a!=0) {
            ld a, (game_keybSelected)       ;; Checks if joy is selected
            cp #1                           ;; | 
            jp z, fire_not_pressed          ;; | If fire is pressed but keyb is selected skip it, else:
                call menu_initTutoGame      ;; | Go to the game
                ret                         ;; | 
        fire_not_pressed:                   ;; }
        jp loop

;; ========================================================
;; Inits the tutorial and prepares the init of the game.
;; ========================================================
menu_initTutoGame:
    call credits_eraseCenter        ;; Erases the center of the screen
    call tutorial_start             ;; Initializes tutorial
    ld hl, #interrupt_defaultISR    ;; Disables the assignation of the music-
    call interrupt_setISR4          ;; to iterruption 4
    call cpct_akp1_stop_asm          ;; Stops the player
    ret                             ;; Return to game initialization

;; ========================================================
;; Changes between keyboard and joystick mode and refreshes the screen
;; ========================================================
menu_changeKeybJoys:
    ld a, (game_keybSelected)
    cp #1
    jp z, isKeyb                
        ld a, #1
        ld (game_keybSelected),a    ;; If keybSelected == 0 changes it to 1
        jp endKeyb
    isKeyb:                         ;; If keybSelected == 1 changes it to 0
        ld a, #0
        ld (game_keybSelected),a
    endKeyb:                        ;; Then re-draws the strings
    call menu_drawVariableStrings
    ret

;; ========================================================
;; Draws menu text strings 
;; ========================================================
menu_drawText:
    call menu_drawVariableStrings

    ld hl, #text3Pos
    ld bc, #text3
    call credits_drawString

    ld hl, #text4Pos
    ld bc, #text4
    call credits_drawString

    ld hl, #text5Pos
    ld bc, #text5
    call credits_drawString
    ret

;; ========================================================
;; Checks what mode is selected to draw the string on first
;; and second position 
;; ========================================================
menu_drawVariableStrings:
    ld a, (game_keybSelected)
    cp #1
    jp z, isKeybF               ;; If keybSelected != 1    
        ld bc, #text1b          ;; Draws A option texts
        ld hl, #text1Pos        ;; | 
        call credits_drawString ;; | 
        ld bc, #text2b          ;; | 
        ld hl, #text2Pos        ;; | 
        jp endKeybF             ;; | 
    isKeybF:                    ;; else, if keybSelected == 1 
        ld bc, #text1a          ;; Draws A option texts
        ld hl, #text1Pos        ;; |
        call credits_drawString ;; |
        ld bc, #text2a          ;; |
        ld hl, #text2Pos        ;; |
    endKeybF:                   ;; |
        call credits_drawString ;; Draws the last text of both options
    ret

;; ========================================================
;; Refreshes the motion of the entities on the screen. 
;; ========================================================
menu_motionRefresh:

    call cpct_waitVSYNC_asm
    ld ix, #flame0                  ;; Draws left flame
    call entity_eraseBlackFront     
    call entity_update
    call entity_drawFront
    ;ld c, entity_width(ix)
    ;ld b, entity_height(ix)
    ;ld de, #videoStart + flame0Pos
    ;ld h, entity_sprite + 1(ix)
    ;ld l, entity_sprite (ix)
    ;call cpct_drawSprite_asm

    ld ix, #flame1                  ;; Draws right flame
    call entity_eraseBlackFront     
    call entity_update
    call entity_drawFront
    ;ld c, entity_width(ix)
    ;ld b, entity_height(ix)
    ;ld de, #videoStart + flame1Pos
    ;ld h, entity_sprite + 1(ix)
    ;ld l, entity_sprite (ix)
    ;call cpct_drawSprite_asm

    ld ix, #warSide                  ;; Draws warrior
    call entity_eraseBlackFront     
    call entity_update
    call entity_drawFront

    ld ix, #orcLeft                  ;; Draws orc
    call entity_eraseBlackFront
    call entity_update
    call entity_drawFront
    ret
