;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################

 ;.area _CODE

;.include "cpctSymbols.h.s"
;.include "gameState.h.s"
;.include "credits.h.s"
;.include "entity.h.s"
;.include "characters/frames.h.s"
;.include "dbuffer.h.s";

;.include "menuSymbols.h.s"

;.globl _g_keySp_0
;.globl _g_keyArr_0
;.globl _g_keyArr_1
;.globl _g_keyArr_2
;.globl _g_keyArr_3
;.globl _g_arrowH_0
;.globl _g_arrowV_0
;.globl _g_arrowV_1
;.globl _g_joyBut_0
;.globl _g_joyBut_1
;.globl _g_joyBall_0
;.globl _g_joyStick_0
;.globl _g_joyStick_1

.globl _g_aniWarStatSide
.globl _g_warrior
.globl _g_warrior_00
.globl _g_warriorAttakH
.globl _g_warriorAttackH_0

;; ========================================================
;; ========================================================
;; PRIVATE DATA
;; ========================================================
;; ========================================================
;; Constants
;.equ videoStart, highBuffer

.equ keySpSize, #0x0D12
.equ keyArrSize, #0x0D05
.equ arrowHSize, #0x0E02
.equ arrowVSize, #0x0805

.equ joyButSize, #0x0D06
.equ joyBallSize, #0x1206
.equ joyStickSize, #0x0B04

.equ warriorSize, #0x1004


.equ keyArr0Pos, #80*9+13 ;Q
.equ keyArr2Pos, #80*11+15 ;A
.equ keyArr1Pos, #80*9+33 ;O
.equ keyArr3Pos, #80*9+39 ;P
.equ keySpPos, #80*14+19 ;Space

.equ arrowHPos, #80*12+20
.equ joyButPos, #80*14+31
.equ joyStickPos, #80*14+20

.equ warriorPos, #80*11+57

.equ titlePos, #80*2+28
titleText: .asciz "HOW TO PLAY"

.equ actionTextPos, #80*8+50
walkLeftText: .asciz  "walk left"
walkRightText: .asciz "walk right"
walkUpText: .asciz    " walk up"
walkDownText: .asciz  "walk down"
attackText: .asciz    "  attack"
emptyText: .asciz     "          "

.equ tutorial_endPos, #80*20+11
tutorial_endText: .asciz "press SPACE to skip and play"

waitTimeValue: .dw #100

;; ========================================================
;; Initializes empty logic, declarates entities for use
;; the entity animation techniques. This logic does nothing.
;; ========================================================


entity_define warTutStat, 57, 88, 4, 16, _g_aniStand, 0, _g_warrior, _g_warrior_00, empty_logic, entity_tAnimation
entity_define warTutSide, 57, 88, 4, 16, _g_aniWarStatSide, 0, _g_warrior, _g_warrior_00, empty_logic, entity_tAnimation
entity_define warTutUp, 57, 88, 4, 16, _g_aniWalkUp, 0, _g_warrior, _g_warrior_00, empty_logic, entity_tAnimation
entity_define warTutDown, 57, 88, 4, 16, _g_aniWalkDown, 0, _g_warrior, _g_warrior_00, empty_logic, entity_tAnimation
entity_define warTutAttack, 57, 88, 4, 16, _g_aniAttackH, 0, _g_warriorAttakH, _g_warriorAttackH_0, empty_logic, entity_tAnimation

;; ========================================================
;; Show the credits on the screen. 
;; ========================================================
tutorial_start::
    ld hl, #titlePos                ;; Draws the title
    ld bc, #titleText
    call credits_drawString
    ld hl, #tutorial_endPos                  ;; Draws bottom text for skip
    ld bc, #tutorial_endText
    call credits_drawString

    ld a, (game_keybSelected)       ;; Checks if kb is selected
            cp #1                           ;; | 
            jp z, tutStart_keyb                      ;; | 
                call tutorial_joy           ;; If joySelected show joy tutorial
                jp endTutorial              ;; |
            tutStart_keyb:                           ;; If keybSelected show keyb tutorial
                call tutorial_keyb          ;; |
    endTutorial:          ;; Cames here when SPACE is pressed
    ret

;; ========================================================
;; Shows joy tutorial.
;; ========================================================
tutorial_joy:
    call tutorial_drawIdleJoy       ;; Draws idle joy
    ld ix, #warTutStat              ;; Loads static animation
    call tutorial_waitTime          ;; Waits
                  
    call tutorial_drawLeftJoy       ;; Draws walk left sample
    ld hl, #actionTextPos           ;; |
    ld bc, #walkLeftText            ;; |
    call credits_drawString         ;; |

    ld ix, #warTutSide              ;; Loads walk left animation
    call entity_lookLeft            ;; |
    call tutorial_waitTime          ;; Waits

    call tutorial_drawIdleJoy       ;; Draws idle joy
    ld ix, #warTutStat              ;; Loads static animation
    call tutorial_waitTime          ;; Waits

    call tutorial_drawRightJoy      ;; Draws walk right sample
    ld hl, #actionTextPos           ;; |
    ld bc, #walkRightText           ;; |
    call credits_drawString         ;; |

    ld ix, #warTutSide              ;; Loads walk right animation
    call entity_lookRight           ;; |
    call tutorial_waitTime          ;; Waits
    call tutorial_drawIdleJoy       ;; Draws idle joy
    ld ix, #warTutStat              ;; Loads static animation
    call tutorial_waitTime          ;; Waits

    call tutorial_drawUpJoy         ;; Draws up example
    ld hl, #actionTextPos           ;; |
    ld bc, #walkUpText              ;; |
    call credits_drawString         ;; |

    ld ix, #warTutUp                ;; Loads walk up animation
    call tutorial_waitTime          ;; Waits
    call tutorial_drawIdleJoy       ;; Draws idle joy
    ld ix, #warTutStat              ;; Loads static animation
    call tutorial_waitTime          ;; Waits

    call tutorial_drawDownJoy       ;; Draws walk down sample
    ld hl, #actionTextPos           ;; |
    ld bc, #walkDownText            ;; |
    call credits_drawString         ;; |

    ld ix, #warTutDown              ;; Loads walk down animation
    call tutorial_waitTime          ;; Waits
    call tutorial_erasePrev         ;; Erases keyboard
    call tutorial_drawIdleJoy       ;; Draws idle joy
    ld ix, #warTutStat              ;; Loads static animation
    call tutorial_waitTime          ;; Waits
    call tutorial_erasePrev         ;; Erases keyboard

    call tutorial_drawActiveButton  ;; Draws attack sample
    ld hl, #actionTextPos           ;; |
    ld bc, #attackText              ;; |
    call credits_drawString         ;; |

    ld ix, #warTutAttack            ;; Loads attack animation
    ld bc, #0x1007                  ;; Changes the tileset of the warrior
    ld hl, #_g_warriorAttakH        ;; |
    call entity_setTileset          ;; |

    call tutorial_waitTime          ;; Waits
    call tutorial_erasePrev         ;; Erases keyboard
    call tutorial_drawIdleJoy       ;; Draws idle Joy
    ld ix, #warTutStat              ;; Loads static animation
    call tutorial_waitTime          ;; Waits
    ret
;; ========================================================
;; Shows keyboard tutorial.
;; ========================================================
tutorial_keyb:
    call tutorial_drawIdleKeyb      ;; Draws idle keyboard

    ld ix, #warTutStat              ;; Loads static animation
    call tutorial_waitTime          ;; Waits

    ld de,#80                       ;; Draws walk left sample
    call tutorial_DrawAKey          ;; |
    ld bc, #keyArr1Pos              ;; |
    call tutorial_DrawDownArrow     ;; |
    ld hl, #actionTextPos           ;; |
    ld bc, #walkLeftText            ;; |
    call credits_drawString         ;; |

    ld ix, #warTutSide              ;; Loads walk left animation
    call entity_lookLeft            ;; |
    call tutorial_waitTime          ;; Waits
    call tutorial_erasePrev         ;; Erases keyboard
    call tutorial_drawIdleKeyb      ;; Draws idle keyboard
    ld ix, #warTutStat              ;; Loads static animation
    call tutorial_waitTime          ;; Waits

    ld de,#80                       ;; Draws walk right sample
    call tutorial_DrawDKey          ;; |
    ld bc, #keyArr3Pos              ;; |
    call tutorial_DrawDownArrow     ;; |
    ld hl, #actionTextPos           ;; |
    ld bc, #walkRightText           ;; |
    call credits_drawString         ;; |

    ld ix, #warTutSide              ;; Loads walk right animation
    call entity_lookRight           ;; |
    call tutorial_waitTime          ;; Waits
    call tutorial_erasePrev         ;; Erases keyboard
    call tutorial_drawIdleKeyb      ;; Draws idle keyboard
    ld ix, #warTutStat              ;; Loads static animation
    call tutorial_waitTime          ;; Waits

    ld de,#80                       ;; Draws walk up sample
    call tutorial_DrawWKey          ;; |
    ld de,#0                        ;; |
    call tutorial_DrawAKey          ;; |
    ld de,#0                        ;; |
    call tutorial_DrawSKey          ;; |
    ld bc, #keyArr0Pos              ;; |
    call tutorial_DrawDownArrow     ;; |
    ld hl, #actionTextPos           ;; |
    ld bc, #walkUpText              ;; |
    call credits_drawString         ;; |

    ld ix, #warTutUp                ;; Loads walk up animation
    call tutorial_waitTime          ;; Waits
    call tutorial_erasePrev         ;; Erases keyboard
    call tutorial_drawIdleKeyb      ;; Draws idle keyboard
    ld ix, #warTutStat              ;; Loads static animation
    call tutorial_waitTime          ;; Waits

    ld de,#80                       ;; Draws walk down sample
    call tutorial_DrawSKey          ;; |
    ld bc, #keyArr2Pos              ;; |
    call tutorial_DrawDownArrow     ;; |
    ld hl, #actionTextPos           ;; |
    ld bc, #walkDownText            ;; |
    call credits_drawString         ;; |

    ld ix, #warTutDown              ;; Loads walk down animation
    call tutorial_waitTime          ;; Waits
    call tutorial_erasePrev         ;; Erases keyboard
    call tutorial_drawIdleKeyb      ;; Draws idle keyboard
    ld ix, #warTutStat              ;; Loads static animation
    call tutorial_waitTime          ;; Waits
    call tutorial_erasePrev         ;; Erases keyboard

    ld de,#0                        ;; Draws attack sample
    call tutorial_DrawWKey          ;; |
    ld de,#0                        ;; |
    call tutorial_DrawAKey          ;; |
    ld de,#0                        ;; |
    call tutorial_DrawSKey          ;; |
    ld de,#0                        ;; |
    call tutorial_DrawDKey          ;; |
    ld de,#80                       ;; |
    call tutorial_DrawSpKey         ;; |
    ld bc, #keySpPos                ;; |
    inc bc                          ;; |
    inc bc                          ;; |
    inc bc                          ;; |
    inc bc                          ;; |
    inc bc                          ;; |
    inc bc                          ;; |
    call tutorial_DrawDownArrow     ;; |
    ld hl, #actionTextPos           ;; |
    ld bc, #attackText              ;; |
    call credits_drawString         ;; |

    ld ix, #warTutAttack            ;; Loads attack animation
    ld bc, #0x1007                  ;; Changes the tileset of the warrior
    ld hl, #_g_warriorAttakH        ;; |
    call entity_setTileset          ;; |

    call tutorial_waitTime          ;; Waits
    call tutorial_erasePrev         ;; Erases keyboard
    call tutorial_drawIdleKeyb      ;; Draws idle keyboard
    ld ix, #warTutStat              ;; Loads static animation
    call tutorial_waitTime          ;; Waits
    ret

;; ========================================================
;; Draws idle keyboard.
;; ========================================================
tutorial_drawIdleKeyb:
    ld de,#0
    call tutorial_DrawWKey
    ld de,#0
    call tutorial_DrawAKey
    ld de,#0
    call tutorial_DrawSKey
    ld de,#0
    call tutorial_DrawDKey
    ld de,#0
    call tutorial_DrawSpKey
    ret

;; ========================================================
;; Erases previous example.
;; ========================================================
tutorial_erasePrev:
    ;call cpct_waitVSYNC_asm         ;; Waits VSYNC to init sample
    ld bc,#80*7+12              
    ld hl, #videoStart
    add hl, bc
    ex de, hl
    ld a, #0xFF ;color
    ld b, #0x50 ;alto
    ld c, #0x20 ;ancho max 39
    call cpct_drawSolidBox_asm
    ld hl, #actionTextPos
    ld bc, #emptyText   
    call credits_drawString
    ret

;;===========================================
;; Draws down arrow
;;
;; Input:
;; BC = position: Position to draw the arrow
;;===========================================
tutorial_DrawDownArrow:
    ld hl, #videoStart
    add hl, bc
    ld de, #_g_arrowV_0
    ex de, hl
    ld bc, #arrowVSize
    call cpct_drawSprite_asm
    ret

;;===========================================
;; Draws W key
;;
;; Input:
;; DE = key status: DE = 0 Draws idle key
;;                  DE = 80 Draws pressed key
;;===========================================
tutorial_DrawWKey:
    ld hl, #videoStart
    add hl, de
    ld bc, #keyArr0Pos
    add hl, bc
    ld de, #_g_keyArr_0
    ex de, hl
    ld bc, #keyArrSize
    call cpct_drawSprite_asm
    ret

;;===========================================
;; Draws A key
;;
;; Input:
;; DE = key status: DE = 0 Draws idle key
;;                  DE = 80 Draws pressed key
;;===========================================
tutorial_DrawAKey:
    ld hl, #videoStart
    add hl, de
    ld bc, #keyArr1Pos
    add hl, bc
    ld de, #_g_keyArr_1
    ex de, hl
    ld bc, #keyArrSize
    call cpct_drawSprite_asm
    ret

;;===========================================
;; Draws S key
;;
;; Input:
;; DE = key status: DE = 0 Draws idle key
;;                  DE = 80 Draws pressed key
;;===========================================
tutorial_DrawSKey:
    ld hl, #videoStart
    add hl, de
    ld bc, #keyArr2Pos
    add hl, bc
    ld de, #_g_keyArr_2
    ex de, hl
    ld bc, #keyArrSize
    call cpct_drawSprite_asm
    ret

;;===========================================
;; Draws D key
;;
;; Input:
;; DE = key status: DE = 0 Draws idle key
;;                  DE = 80 Draws pressed key
;;===========================================
tutorial_DrawDKey:
    ld hl, #videoStart
    add hl, de
    ld bc, #keyArr3Pos
    add hl, bc
    ld de, #_g_keyArr_3
    ex de, hl
    ld bc, #keyArrSize
    call cpct_drawSprite_asm
    ret

;;===========================================
;; Draws Space key
;;
;; Input:
;; DE = key status: DE = 0 Draws idle key
;;                  DE = 80 Draws pressed key
;;===========================================
tutorial_DrawSpKey:
    ld hl, #videoStart
    add hl, de
    ld bc, #keySpPos
    add hl, bc
    ld de, #_g_keySp_0
    ex de, hl
    ld bc, #keySpSize
    call cpct_drawSprite_asm
    ret 

;; ========================================================
;; Waits waitTime.
;; ========================================================
tutorial_waitTime:
    ld de, #-1
    ld hl, (waitTimeValue)
    tut_waitTime_loop:
        push hl
        push de
        call tutorial_motionRefresh         ;; Refreshes the animation
        call cpct_scanKeyboard_asm          ;; Update keyboard state table
        ld    hl, #Key_Space                ;; hl = key code to check
        call  cpct_isKeyPressed_asm         ;; l = a = key state
        cp    #0                            ;; | 
        jr    z, tut_space_not_pressed          ;; if (a!=0) {
            pop de                          ;; Pops loop data
            pop hl                          ;; | 
            pop hl                          ;; Pops the PC of the call
            jp endTutorial                  ;; Exits the tutorial
        tut_space_not_pressed:                  ;; Else continues with the time countdown
        pop de
        pop hl
        add hl, de
        jr c, tut_waitTime_loop
    ret

;; ========================================================
;; Refreshes the motion of the entity on the screen.
;; Input:
;; IX = entity
;; ========================================================
tutorial_motionRefresh:

    call cpct_waitVSYNC_asm
    call entity_eraseBlackFront
    call entity_update
    call entity_drawFront
    ret

;;===========================================
;; Draws idle stick
;;===========================================
tutorial_drawIdleStick:
    ld hl, #videoStart          ;; Draws the stick
    ld bc, #joyStickPos         ;; | 
    add hl, bc                  ;; | 
    ld de, #_g_joyStick_0       ;; | 
    ex de, hl                   ;; | 
    ld bc, #joyStickSize        ;; | 
    call cpct_drawSprite_asm    ;; | 
    ret

;;===========================================
;; Draws idle joy
;;===========================================
tutorial_drawIdleJoy:
    call tutorial_erasePrev
    call tutorial_drawIdleStick ;; Draws the stick
    ld de, #videoStart          ;; Draws the ball
    ld c, #99 ;H                ;; |
    ld b, #89 ;V                ;; |
    call cpct_getScreenPtr_asm  ;; | 
    ld de, #_g_joyBall_0        ;; | 
    ex de, hl                   ;; | 
    ld bc, #joyBallSize         ;; | 
    call cpct_drawSprite_asm    ;; |
 
    call tutorial_drawIdleButton;; Draws the button
    ret 

;;===========================================
;; Draws left joy
;;===========================================
tutorial_drawLeftJoy:
    call tutorial_erasePrev
    ld hl, #videoStart          ;; Draws the stick
    ld bc, #joyStickPos         ;; | 
    add hl, bc                  ;; | 
    ld de, #_g_joyStick_1       ;; | 
    ex de, hl                   ;; | 
    ld bc, #joyStickSize        ;; | 
    call cpct_drawSprite_asm    ;; | 

    ld de, #videoStart          ;; Draws the ball
    ld c, #97 ;H                ;; |
    ld b, #89 ;V                ;; |
    call cpct_getScreenPtr_asm  ;; |  
    ld de, #_g_joyBall_0        ;; | 
    ex de, hl                   ;; | 
    ld bc, #joyBallSize         ;; | 
    call cpct_drawSprite_asm    ;; |

    ld hl, #videoStart          ;; Draws the arrow
    ld bc, #arrowHPos-7         ;; | 
    add hl, bc                  ;; | 
    ld de, #_g_arrowH_0         ;; | 
    ex de, hl                   ;; | 
    ld bc, #arrowHSize          ;; | 
    call cpct_drawSprite_asm    ;; |

    call tutorial_drawIdleButton;; Draws the button
    ret

;;===========================================
;; Draws right joy
;;===========================================
tutorial_drawRightJoy:
    call tutorial_erasePrev
    ld hl, #_g_joyStick_1       ;; Flips the stick sprite
    ld c, #0x04                 ;; |
    ld b, #0x0B                 ;; |
    call cpct_hflipSpriteM0_asm ;; |

    ld hl, #videoStart          ;; Draws the stick
    ld bc, #joyStickPos         ;; | 
    add hl, bc                  ;; | 
    ld de, #_g_joyStick_1       ;; | 
    ex de, hl                   ;; | 
    ld bc, #joyStickSize        ;; | 
    call cpct_drawSprite_asm    ;; | 

    ld de, #videoStart          ;; Draws the ball
    ld c, #101 ;H               ;; |
    ld b, #89 ;V                ;; |
    call cpct_getScreenPtr_asm  ;; | 
    ld de, #_g_joyBall_0        ;; | 
    ex de, hl                   ;; | 
    ld bc, #joyBallSize         ;; | 
    call cpct_drawSprite_asm    ;; |

    ld hl, #_g_arrowH_0         ;; Flips the arrow sprite
    ld c, #0x02                 ;; |
    ld b, #0x0E                 ;; |
    call cpct_hflipSpriteM0_asm ;; |

    ld hl, #videoStart          ;; Draws the arrow
    ld bc, #arrowHPos+9         ;; | 
    add hl, bc                  ;; | 
    ld de, #_g_arrowH_0         ;; | 
    ex de, hl                   ;; | 
    ld bc, #arrowHSize          ;; | 
    call cpct_drawSprite_asm    ;; |

    call tutorial_drawIdleButton;; Draws the button
    ret

;;===========================================
;; Draws up joy
;;===========================================
tutorial_drawUpJoy:
    call tutorial_erasePrev
    call tutorial_drawIdleStick ;; Draws the stick

    ld de, #videoStart          ;; |
    ld c, #99 ;Horiz            ;; |
    ld b, #86 ;Vertic           ;; |
    call cpct_getScreenPtr_asm  ;; |
    ld de, #_g_joyBall_0        ;; | 
    ex de, hl                   ;; | 
    ld bc, #joyBallSize         ;; | 
    call cpct_drawSprite_asm    ;; |

    ld hl, #videoStart          ;; Draws the arrow
    ld bc, #arrowHPos-161       ;; | 
    add hl, bc                  ;; | 
    ld de, #_g_arrowV_1         ;; | 
    ex de, hl                   ;; | 
    ld bc, #arrowVSize          ;; | 
    call cpct_drawSprite_asm    ;; |

    call tutorial_drawIdleButton;; Draws the button
    ret

;;===========================================
;; Draws down joy
;;===========================================
tutorial_drawDownJoy:
    call tutorial_erasePrev
    call tutorial_drawIdleStick ;; Draws the stick

    ld de, #videoStart          ;; |
    ld c, #99 ;Horiz            ;; |
    ld b, #94 ;Vertic           ;; |
    call cpct_getScreenPtr_asm  ;; |
    ld de, #_g_joyBall_0        ;; | 
    ex de, hl                   ;; | 
    ld bc, #joyBallSize         ;; | 
    call cpct_drawSprite_asm    ;; |

    ld hl, #videoStart          ;; Draws the arrow
    ld bc, #arrowHPos+319       ;; | 
    add hl, bc                  ;; | 
    ld de, #_g_arrowV_0         ;; | 
    ex de, hl                   ;; | 
    ld bc, #arrowVSize          ;; | 
    call cpct_drawSprite_asm    ;; |

    call tutorial_drawIdleButton;; Draws the button
    ret

;;===========================================
;; Draws idle button
;;===========================================
tutorial_drawIdleButton:
    ld hl, #videoStart          ;; Draws the button
    ld bc, #joyButPos           ;; | 
    add hl, bc                  ;; | 
    ld de, #_g_joyBut_1         ;; | 
    ex de, hl                   ;; | 
    ld bc, #joyButSize          ;; | 
    call cpct_drawSprite_asm    ;; | 
    ret 

;;===========================================
;; Draws active button
;;===========================================
tutorial_drawActiveButton:
    call tutorial_drawIdleJoy   ;; Draws the idle joy
    ld hl, #videoStart          ;; Draws the button
    ld bc, #joyButPos           ;; | 
    add hl, bc                  ;; | 
    ld de, #_g_joyBut_0         ;; | 
    ex de, hl                   ;; | 
    ld bc, #joyButSize          ;; | 
    call cpct_drawSprite_asm    ;; | 

    ld hl, #videoStart          ;; Draws the arrow
    ld bc, ##joyButPos-160      ;; | 
    add hl, bc                  ;; | 
    ld de, #_g_arrowV_0         ;; | 
    ex de, hl                   ;; | 
    ld bc, #arrowVSize          ;; | 
    call cpct_drawSprite_asm    ;; |
    ret 