;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################


.area _CODE


;; ========================================================
;; ========================================================
;; SÍMBOLOS GLOBALES INCLUIDOS
;; ========================================================
;; ========================================================

.include "cpctSymbols.h.s"


;; ========================================================
;; ========================================================
;; MACROS
;; ========================================================
;; ========================================================
.macro collision_checkPart 
    ld a, (hl)
    inc hl
    inc hl
    add (hl)
    ex de, hl
    ld b, (hl)
    sub b
    dec a
    jp m, #noCollision
.endm



;; ========================================================
;; ========================================================
;; FUNCIONES PÚBLICAS
;; ========================================================
;; ========================================================


;;====================================================
;; Comprueba si dos bounding boxes están en colisión
;; ENTRADA:
;;   DE = puntero al bounding box A
;;   HL = puntero al bounding box B
;; SALIDA:
;;   A = 0 -> no colisionan
;;   A = 1 -> colisionan
;;====================================================
collision_check::
    ; Comprueba HL a la izquierda de DE
    collision_checkPart
    
    ; Comprueba HL a la derecha de DE
    dec de
    dec de
    collision_checkPart

    ; Comprueba HL arriba de DE
    inc hl
    dec de
    collision_checkPart

    ; Comprueba HL abajo de DE
    dec de
    dec de
    collision_checkPart

    ld a, #0x01
    ret

    noCollision:
    ld a, #0x00
    ret

