;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################

;; =============================
;; =============================
;; Símbolos de CPCtelera
;; =============================
;; =============================
.include "cpctelera.h.s"

;; =============================
;; EasyTileMaps
;; =============================
;.globl cpct_etm_drawTilemap2x4_f_asm
;.globl cpct_etm_drawTileBox2x4_asm
;.globl cpct_etm_setTileset2x4_asm
.globl cpct_drawTileAligned4x8_f_asm
;.globl cpct_etm_drawTilemap4x8_ag_asm
;.globl cpct_etm_setDrawTilemap4x8_ag_asm

;; =============================
;; Firmware
;; =============================
.globl cpct_disableFirmware_asm
.globl cpct_setInterruptHandler_asm
.globl cpct_removeInterruptHandler_asm
;.globl cpct_disableLowerROM_asm
;.globl cpct_disableUpperROM_asm
;.globl cpct_enableLowerROM_asm
;.globl cpct_enableUpperROM_asm

;; =============================
;; Keyboard
;; =============================
.globl cpct_scanKeyboard_asm
.globl cpct_isKeyPressed_asm

;; =============================
;; MemUtils
;; =============================
.globl cpct_memset_asm
.globl cpct_setStackLocation_asm

;; =============================
;; Sprites
;; =============================
;.globl cpct_drawSolidBox_asm
;.globl cpct_drawSprite_asm
;.globl cpct_drawSpriteBlended_asm
.globl cpct_drawSprite_asm
.globl cpct_drawSpriteMaskedAlignedTable_asm
.globl cpct_hflipSpriteM0_asm
;.globl cpct_drawSpriteMasked_asm
.globl cpct_drawSolidBox_asm

;; =============================
;; Music
;; =============================
;.globl cpct_akp_musicInit_asm
;.globl cpct_akp_SFXInit_asm
;.globl cpct_akp_musicPlay_asm
;.globl cpct_akp_stop_asm

;; =============================
;; Random
;; =============================
;.globl cpct_getRandom_mxor_u16_asm
.globl cpct_getRandom_mxor_u8_asm

;; =============================
;; Strings
;; =============================
;.globl cpct_drawStringM0_asm

;; =============================
;; Video
;; =============================
.globl cpct_getScreenPtr_asm
;.globl cpct_setPalette_asm
.globl cpct_setVideoMode_asm
;.globl cpct_setPALColour_asm
.globl cpct_waitVSYNC_asm
;.globl cpct_count2VSYNC_asm
.globl cpct_setVideoMemoryPage_asm
.globl cpct_setVideoMemoryOffset_asm

;; =============================
;; Loader
;; =============================
;.globl cpct_miniload_asm
        
;; =============================
;; Bitarray
;; =============================
.globl cpct_get6Bits_asm

;; =============================
;; Nuevos símbolos
;; =============================

; Tilemaps
;.globl cpctex_setTileSet
;.globl cpctex_drawTileMap4x8
.globl cpctex_setDrawTileFunction

.globl cpct_etm_drawTilemap4x8_asm
.globl cpct_etm_setDrawTilemap4x8_asm
.globl cpct_etm_setDrawTilemapSize4x8_asm
.globl cpct_etm_getTilemapPtr_asm
 
; Texto
.globl cpctex_drawTileStringM0

; Tablas precalculadas
.globl cpctex_maskTable0M0
.globl cpctex_hFlipTable0M0

; Sprites
.globl cpctex_drawSpriteMaskedAlignedTableHFlip_asm
.globl cpctex_drawHalf1TileAligned4x8_asm
.globl cpctex_drawHalf2TileAligned4x8_asm

; Arkos tracker 1
;.globl cpct_akp1_musicInit_asm
;.globl cpct_akp1_SFXInit_asm
;.globl cpct_akp1_musicPlay_asm
;.globl cpct_akp1_stop_asm

; Arkos tracker 2
.globl cpct_akp2_SFXInit_asm
.globl cpct_akp2_SFXPlay_asm
.globl cpct_akp2_SFXStop_asm
.globl cpct_akp2_SFXPlayStream_asm

; Cargador de disco
.globl cpct_loadFromDisc_asm

;; =============================
;; Macros
;; =============================
;.macro setBorder color
;    ld    l, #0x10
;    ld    h, color
;    call  cpct_setPALColour_asm         ;; Set border color to black (hwcolor 0x54)
;.endm


.macro define_space _n
    _c = 0
    .rept _n
        .db 0x00
        _c = _c + 1
    .endm
.endm