;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of CPCtelera: An Amstrad CPC Game Engine 
;;  Copyright (C) 2014-2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

cpctex_drawHalf1TileAligned4x8_asm::
   ;; Copy 8 lines of 4 bytes width
   ld    a, #8             ;; [2] We have to draw 8 lines of sprite
   jr dsa48_first_line     ;; [3] First line does not need to do maths to start transferring data. 

dsa48_next_line:
   ;; Move to the start of the next line
   ex   de, hl             ;; [1] Make DE point to the start of the next line of pixels in video memory, by adding BC
   add  hl, bc             ;; [3] (We need to interchange HL and DE because DE does not have ADD)
   ex   de, hl             ;; [1]

dsa48_first_line:
   ;; Draw a sprite-line of 4 bytes
   ld   bc, #0x800-0x02    ;; [3] 800h bytes is the distance to the start of the first pixel in the next line in 
                           ;; .... video memory (it will be decremented by 1 by each LDI)
   ldi                     ;; [5] <|Copy 4 bytes with (DE) <- (HL) and decrement BC 
   ldi                     ;; [5]  | (distance is 1 byte less as we progress up)
   inc hl
   inc de
   inc hl
   inc de

   ;; Repeat for all the lines
   dec   a                 ;; [1]   A = A - 1 (1 more line completed)
   jr   nz, dsa48_next_line;; [2/3] Continue to next line if A != 0 (A = Lines left)

   ret                     ;; [3]
