;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################

.globl cpct_drawTileAligned2x8_f_asm
.globl _g_font
;; ==========================================================
;; Draws a string made up by 4x8 sprite chars
;; HL = Pointer to string
;; ==========================================================
cpctex_drawTileStringM0::

startLoop:
        
        ld hl, #_g_font

        ld      a, (bc)                         ;; | A = caracter actual
        
        cp      #0x00                           ;; |
        jr      z, endLoop                      ;; | Si ha llegado al final de la cadena, terminar
        push de
                                                ;; | // Cargar en DE la posición en bytes relativa a _g_tileset para el caracter actual
        sub     a, #32                          ;; | // Nota: BC es el puntero al caracter actual
        sla     a                               ;; | // Nota: Restamos 32 para alinearnos con el comienzo del array (primer caracter imprimible = 32)
        ld      e, a                            ;; | // Nota: Multiplicamos por 2 porque es un array de punteros (word)
        ld      d, #0x00                        ;; | DE = (*BC-32)*2

        add hl, de                              ;; |
        ld e, (hl)                              ;; |                         
        inc hl                                  ;; |
        ld d, (hl)                              ;; | // Cargar en HL el puntero al sprite a dibujar
        ex de, hl                               ;; | HL = *(tileset+DE)
        
        pop     de
        push    de
        push    bc
        call    cpct_drawTileAligned2x8_f_asm   ;; cpct_drawTileAligned2x8(HL, DE)
        pop     bc
        pop     de
                                                ;; | // Siguiente caracter en la cadena
        inc     bc                              ;; | BC ++

        inc     de                              ;; | // Siguiente posición en la pantalla
        inc     de                              ;; | DE += 2

        jp      startLoop

endLoop:
        ;pop hl
        ret
        
