;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################


.include "cpctSymbols.h.s"
;.include "entity.h.s"
.include "map.h.s"
.include "scroll.h.s"
.include "world.h.s"
.include "math.h.s"
.include "panel.h.s"
.include "characters/frames.h.s"
;.include "entityVector.h.s"
.include "entityWarrior.h.s"
.include "entityOrc.h.s"

.globl hero

.globl _g_ball
.globl _g_ball_0

;; state dir ball
.equ ball_up, 1
.equ ball_down, 2
.equ ball_left, 3
.equ ball_right, 4   

.equ ball_dmg, entity_customData + 5
.equ ball_flagDrop, entity_customData + 4

entity_defineCharacter ball_prototype, 40, 136, 4, 8, _g_aniBallMove, 0, _g_ball, _g_ball_0, ball_logic, entity_tEnemy, 0, 0, 0, 1, 0, 0, 2


;;============================
;; Manage ball's state machine
;; DESTROYS: 
;;============================
ball_logic::
    ;;Chequear colision:
    ;;      - Colision con heroe = quitar vida y eliminar entidad
    ;;      - Colision con otra cosa distinta del heroe = eliminar entidad
    ;;      - No colisión = seguir moviendo la entidad en la dirección otorgada
    ld a, ball_flagDrop (ix)
    cp #0
    jp nz, delete 
    call orc_checkHero_ns
    cp #1
    jp nz, move
        delete:
        call entity_checkDropItem
        cp #0
        jp nz, dropItem
        call entity_delete
        ret
	move::
		ld a, entity_state (ix) 
		cp #ball_up
		call z, entity_moveUpNoAni
		cp #ball_down
		call z, entity_moveDownNoAni
		cp #ball_left
		call z, entity_moveLeftNoAni
		cp #ball_right
		call z, entity_moveRightNoAni
		;; Check colision map
		cp #0
        ret nz
        call entity_checkDropItem
        cp #0
        jp nz, dropItem
		call entity_delete
        ret;
    dropItem:
        ld ball_flagDrop (ix), #1
        ret

setStUp::
    ld entity_state (ix), #ball_up
    ld orc_dir (ix), #entity_dirUp
    ret;

setStDown::
    ld entity_state (ix), #ball_down
    ld orc_dir (ix), #entity_dirDown
    ret;

setStLeft::
    ld entity_state (ix), #ball_left
    ld orc_dir (ix), #entity_dirLeft
    ret;

setStRight::
    ld entity_state (ix), #ball_right
    ld orc_dir (ix), #entity_dirRight
    ret    


ball_prepareAni:
    ld a, #_g_aniBallMove         ;; |
    
    push ix
    ld de, #entity_animation
    add ix, de
    call animation_set          ;; Establecer animación
    pop ix  

    ret