;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################

.include "cpctSymbols.h.s"
.include "entityVector.h.s"
.include "map.h.s"
.include "scroll.h.s"
.include "world.h.s"
.include "characters/frames.h.s"
.include "panel.h.s"
.include "math.h.s"

.include "sfx/sfx.h.s"

.globl hero
;.globl _g_chest_0
;.globl _g_chest
.globl _g_items_4
.globl _g_items
entity_defineStatic chest_prototype, 0, 0, 4, 8, _g_items, _g_items_4, logic_chest, entity_tItem

.globl logic_heart_base
.globl ph_itemLogicCallback

logic_callback:
	ld hl, #3200
	ld de, #50
	call item_newMoney
	ld a, #_g_sfx_moneyId
	ret

;;============================
;; Manage chest's logic
;; DESTROYS: HL, DE, IX, BC, AF
;;============================
logic_chest::
	
logic_chest_base::
	ld hl, #logic_callback
    ld (ph_itemLogicCallback+1), hl
    call logic_heart_base
    ret

;;============================
;; Obtain random money puntuation
;; OUTPUT -> BC
;; DESTROYS: AF, BC, DE, HL
;;============================
item_newMoney::
	ld (ph_maxCoins+1), hl
	ld (ph_minCoins+1), de
	;call cpct_getRandom_mxor_u16_asm
	call cpct_getRandom_mxor_u8_asm
	ld a, l
	add a, a
	ld e, a
	ld d, #0x00

	ex de, hl 	;; DE = random number
	ph_maxCoins:
	ld bc, #450	;; Divisor
	call DE_Mod_BC
	ph_minCoins:
	ld bc, #50
	add hl, bc		;;
	call panel_incrementMoney
	ret