;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################

.include "cpctSymbols.h.s"
.include "entityVector.h.s"
.include "map.h.s"
.include "scroll.h.s"
.include "world.h.s"
.include "characters/frames.h.s"
.include "panel.h.s"
.include "math.h.s"
.include "gameState.h.s"
.include "entityWarrior.h.s"

.globl hero
.globl _g_doorV
.globl _g_doorV_0
.globl _g_doorH
.globl _g_doorH_0
entity_defineStatic horizontalDoor_prototype, 0,0, 4, 24, _g_doorV, _g_doorV_0, logic_door, entity_tEnemy
entity_defineStatic verticalDoor_prototype, 0,0, 8, 8, _g_doorH, _g_doorH_0, logic_door, entity_tEnemy

.equ norte, 0
.equ east, 76
.equ south, 168
.equ west, 0

;;============================
;; Manage coins's logic
;; DESTROYS: HL, DE, IX, BC, AF
;;============================
logic_door::
	ld hl, #hero
	ld__d_ixh
	ld__e_ixl
	call collision_check 
	cp #0
	jp z, fin_logic 	;;If colision door with hero
		call entity_checkDropItem
    	cp #0
    	ret nz
		ld a, (keyQuant) 	;;Load key quant
		cp #0
		jp z, push_hero 	;;If hero has more than zero keys
			call panel_decrementKey 	;;Decrement one key
			call entity_deleteFromWorld
			call entity_delete			;;Delete door
			ret
		push_hero: 		;;Else push hero out
			;;Comprobar si el hero esta en estado attack
			ld a, (hero_attacking)  ;; A = state hero
			cp #1 
			ret z 		;; If is state attack finish

			;;COmprobar ubicacion de la puerta (N,S,E,W)
			ld a, entity_posX (ix)
			cp #west
			jp z, push_right
			cp #east
			jp z, push_left
			ld a, entity_posY (ix)
			cp #norte
			jp z, push_down
			cp #south
			jp z, push_up
			ret
			;;Empuja al heroe a la direccion contraria a la puerta (efecto no dejar pasar)
			push_right:
			ld ix, #hero
			ld a, #entity_dirRight
    		call entity_displace
    		ret
			push_left:
			ld ix, #hero
			ld a, #entity_dirLeft
    		call entity_displace
			ret
			push_up:
			ld ix, #hero
			ld a, #entity_dirUp
    		call entity_displace
			ret
			push_down:
			ld ix, #hero
			ld a, #entity_dirDown
    		call entity_displace
	fin_logic:
	ret
