;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################


.include "cpctSymbols.h.s"
;.include "entity.h.s"
.include "map.h.s"
.include "scroll.h.s"
.include "world.h.s"
.include "math.h.s"
.include "characters/frames.h.s"
.include "entityWarrior.h.s"
.include "entityOrc.h.s"
.include "scene.h.s"


.globl hero

.globl _g_knight
.globl _g_knight_00

entity_defineCharacter knight_prototype, 40, 136, 4, 16, 0, 0, _g_knight, _g_knight_00, knight_logic, entity_tEnemy, 0, 0, 0, 10, 0, 1, 2

;.equ knight_moveControl, entity_customData + 4

;;============================
;;============================
;; LOCAL VARIABLES
;;============================
;;============================

;;============================
;; Manage skeleton's state machine
;; DESTROYS: 
;;============================
knight_logic::
    ld a, (scene_motionDivisor) ;; Check if is needed to do some action this time
    cp #1                       ;; |
    ret z                       ;; |

    call orc_checkHeroSword
    
    ld a, entity_state (ix)
    cp #orc_stThink
    jp z, orc_updateStateThink;
    cp #orc_stSeek
    jp z, orc_updateStateSeek;
    cp #orc_stAttack
    jp z, orc_updateStateAttack;
    cp #orc_stHit
    jp z, orc_updateStateHit;
    cp #orc_stDead
    jp z, orc_updateStateDead

    ret
