;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################


.include "cpctSymbols.h.s"
;.include "entity.h.s"
.include "map.h.s"
.include "scroll.h.s"
.include "world.h.s"
.include "math.h.s"
.include "characters/frames.h.s"
.include "entityWarrior.h.s"
.include "entityOrc.h.s"


.globl hero

.globl _g_skeleton
.globl _g_skeleton_00

entity_defineCharacter skeleton_prototype, 40, 136, 4, 16, 0, 0, _g_skeleton, _g_skeleton_00, skeleton_logic, entity_tEnemy, 0, 0, 0, skeleton_initialLife, 0, 200, 1

.equ skeleton_initialLife, 3

.equ skeleton_deadTime, entity_customData + 4

;;============================
;;============================
;; LOCAL VARIABLES
;;============================
;;============================
;heroDifX: .db 0     ;; pos X difference to hero (can be negative)
;heroDifY: .db 0     ;; pos Y difference to hero (can be negative)
;heroDist: .db 0     ;; distance to hero (manhattan distance)
;startX:   .db 0     ;; start X coordinate to check sensor line
;startY:   .db 0     ;; start Y coordinate to check sensor line


;;============================
;; Manage skeleton's state machine
;; DESTROYS: 
;;============================
skeleton_logic::
    call orc_checkHeroSword
    ld a, entity_state (ix)
    cp #orc_stThink
    jp z, orc_updateStateThink;
    cp #orc_stSeek
    jp z, orc_updateStateSeek;
    cp #orc_stAttack
    jp z, orc_updateStateAttack;
    cp #orc_stHit
    jp z, orc_updateStateHit;
    cp #orc_stDead
    jp z, skeleton_updateStateDead

    ret

skeleton_updateStateDead::
    call orc_updateStateDead

    ld a, skeleton_deadTime (ix)
    dec a
    ld skeleton_deadTime (ix), a
    cp #0
    ret nz

    ld a, (#skeleton_prototype + #skeleton_deadTime)
    ld skeleton_deadTime (ix), a
    ld orc_life (ix), #skeleton_initialLife
    

    call orc_setStateThink

    ret

