;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################


.include "cpctSymbols.h.s"
;.include "entity.h.s"
.include "map.h.s"
.include "scroll.h.s"
.include "world.h.s"
.include "math.h.s"
.include "characters/frames.h.s"
.include "entityOrc.h.s"
.include "entityBall.h.s"
.include "sfx/sfx.h.s"

.globl entity_isVectorFull
.globl ball_prototype

.globl hero

.globl _g_wizard
.globl _g_wizard_00

entity_defineCharacter wizard_prototype, 40, 136, 4, 16, 0, 0, _g_wizard, _g_wizard_00, wizard_logic, entity_tEnemy, 0, 0, 0, 3, 0, 50, 1

;; Substates inside normal attack state
.equ wiz_stEscape, 5
.equ wiz_stAlign, 6
.equ wiz_stThrow, 7
.equ wiz_stRecharge, 8
.equ wiz_stAttackMelee, 9 
.equ wiz_distanceAlign, 4  ;; Distance align  
.equ wiz_distanceEscape, 4  ;; Distance max for scapezz
.equ wiz_distanceAttackMelee, 2  ;; Distance max for attack melee
.equ wiz_rechargeTime, entity_customData + 4


;; entityBall dir
wiz_ball: .dw ball_prototype
;;============================
;; Manage wizard's state machine
;; DESTROYS: 
;;============================
wizard_logic::
    call orc_checkHeroSword
    ld a, entity_state (ix)
    cp #orc_stThink
    jp z, orc_updateStateThink;
    cp #orc_stSeek
    jp z, orc_updateStateSeek;
    cp #wiz_stAttackMelee
    jp z, wiz_updateStateAttackMelee
    cp #orc_stAttack
    jp z, wiz_updateStateAttack;
    cp #wiz_stEscape
    jp z, wiz_updateStateEscape
    cp #wiz_stAlign
    jp z, wiz_updateStateAlign
    cp #wiz_stThrow
    jp z, wiz_updateStateThrow
    cp #wiz_stRecharge
    jp z, wiz_updateStateRecharge
    cp #orc_stHit
    jp z, orc_updateStateHit;
    cp #orc_stDead
    jp z, orc_updateStateDead;
    ret;

;;============================
;; Update state attack
;; DESTROYS: 
;;============================
wiz_updateStateAttack:;
    ;call orc_checkHeroSword;
    call orc_getHeroDirection
    cp #entity_noDir
    jp z, wiz_attackNoHeroFound
        ;;Comprobate distance
        ld a, (heroDist)
        cp #wiz_distanceEscape
        jp m, setStEscape     ;;If distance < distanceEscape, activate state escape
        jp setStAlign         ;; Else activate state align  
        ret

wiz_attackNoHeroFound:
    call orc_setStateThink
    ret;
;;============================
;; Update state escape
;; DESTROYS: 
;;============================
wiz_updateStateEscape::;
    call orc_checkHero
    ;call orc_checkHeroSword
    call orc_getHeroDirection
    cp #entity_noDir
    jp z, wiz_attackNoHeroFound
        ;;Comprobate distance
        ld a, (heroDist)
        cp #wiz_distanceAlign
        jp p, setStAlign         ;; If distance > distanceAlign state align
        cp #wiz_distanceAttackMelee
        jp m, setStAttackMelee
            ;;Else move for scape
            ld orc_dist (ix), #1
            ld a, (heroDifX)
            call absA
            ld b, a     ;; B => abs DifX
            ld a, (heroDifY)
            call absA
            cp b
            jp m, scapeX     ;; If distance Y < distance X scape in X
                ;; Else scape in Y
                ld a, (heroDifY)
                cp #0
                ;;TO-DO Comprobar si choca con un muro (cambiar direccion en ese caso)
                jp m, scapeDown   ;; If dif is negative (hero is up) scape down
                    ;; Else scape up
                    ld orc_dir (ix), #entity_dirUp
                    call orc_move
                    ret
                scapeDown::
                ld orc_dir (ix), #entity_dirDown
                call orc_move
                ret                
            scapeX::
                ld a, (heroDifX)
                cp #0
                jp m, scapeRight   ;; If dif is negative (hero is left) scape right
                    ;; Else scape left
                    ld orc_dir (ix), #entity_dirLeft
                    call orc_move
                    ret                    
                scapeRight::
                ld orc_dir (ix), #entity_dirRight
                call orc_move
                ret
        ret


;;============================
;; Update state align
;; DESTROYS: 
;;============================
wiz_updateStateAlign::;
    ;call orc_checkHeroSword
    call orc_getHeroDirection
    cp #entity_noDir
    jp z, wiz_attackNoHeroFound
        ;;Comprobate distance
        ld a, (heroDist)
        cp #wiz_distanceEscape
        jp m, setStEscape         ;; If distance < distanceEscape state scape
            ;;Else move for align
            ld orc_dist (ix), #1
            ld a, (heroDifX)
            cp #0
            jp z, setStThrow    ;;If is align with hero state throw
            call absA
            ld b, a     ;; B => abs DifX
            ld a, (heroDifY)
            cp #0
            jp z, setStThrow    ;;If is align with hero state throw
            call absA
            cp b
            jp m, alignY     ;; If distance Y < distance X align in Y
                ;; Else align in X
                ld a, (heroDifX)
                cp #0
                ;;TO-DO Comprobar si choca con un muro (cambiar direccion en ese caso)
                jp m, alignLeft   ;; If dif is negative (hero is left) align left
                    ;; Else align right
                    ld orc_dir (ix), #entity_dirRight
                    call orc_move
                    ret
                alignLeft::
                ld orc_dir (ix), #entity_dirLeft
                call orc_move
                ret                
            alignY::
                ld a, (heroDifY)
                cp #0
                jp m, alignUp   ;; If dif is negative (hero is up) align up
                    ;; Else align down
                    ld orc_dir (ix), #entity_dirDown
                    call orc_move
                    ret                    
                alignUp::
                ld orc_dir (ix), #entity_dirUp
                call orc_move
                ret
        ret


wiz_updateStateThrow::
    call orc_checkHero
    ld a, entity_state (ix)
    cp #orc_stThink
    ret z
    ;call orc_checkHeroSword
    call orc_getHeroDirection
    cp #entity_noDir
    jp z, wiz_attackNoHeroFound
        ;;Comprobate distance
        ld a, (heroDist)
        cp #wiz_distanceEscape
        jp m, setStEscape         ;; If distance < distanceEscape state scape
            ;;Else comprobate align
            ld a, (heroDifX)
            cp #0
            jp z, throw_vertical    ;;If is align in x axis 
            ld a, (heroDifY)
            cp #0
            jp z, throw_horizontal    ;;If is align in y axis
            jp setStAlign       ;;If not align in x or y axis state align

            throw_vertical:
            call entity_isVectorFull
            cp #1
            ret z
            ld a, (heroDifY)
            cp #0
            jp m, throw_up  ;; If hero is up throw ball up
            jp throw_down   ;; Else throw down

            throw_horizontal:
            call entity_isVectorFull
            cp #1
            ret z
            ld a, (heroDifX)
            cp #0
            jp m, throw_left  ;; If hero is left throw ball left
            jp throw_right   ;; Else throw right

            throw_up::
            call wiz_throwFx
            ;;Crear entidad ball en x, y-1 añadir al vector con velocidad (0,-1)
            call addBall
            dec b
            ;; Llamar a estado correspondiente
            push ix                 ;; Save wizard entity
            call wiz_positionBall
            call setStUp
            pop ix                 ;; IX = Wizard entity
            call setStRecharge
            ret
            throw_down:
            call wiz_throwFx
            ;;Crear entidad ball en x, y+1 añadir al vector con velocidad (0,1)
            call addBall
            inc b
            ;; Llamar a estado correspondiente
            push ix
            call wiz_positionBall
            call setStDown
            pop ix                 ;; IX = Wizard entity
            call setStRecharge
            ret
            
            throw_left:
            call wiz_throwFx
            ;;Crear entidad ball en x-1, y añadir al vector con velocidad (0,-1)
            call addBall
            dec a
            ;; Llamar a estado correspondiente
            push ix
            call wiz_positionBall
            call setStLeft
            pop ix                 ;; IX = Wizard entity
            call setStRecharge
            ret
            
            throw_right:
            call wiz_throwFx
            ;;Crear entidad ball en x+1, y añadir al vector con velocidad (0,1)
            call addBall
            inc a
            ;; Llamar a estado correspondiente
            push ix
            call wiz_positionBall
            call setStRight
            pop ix                 ;; IX = Wizard entity
            call setStRecharge
            ret

wiz_throwFx:
    push af
    push bc
    ld a, #_g_sfx_fireballId     ;; Sound effect ID
    ld c, #0                        ;; Channel
    ld b, #0                        ;; Volume (inverted 0=max)
    call cpct_akp2_SFXPlay_asm
    pop bc
    pop af
    ret

;;Position ball in x and y axis
wiz_positionBall:
    ld__ixh_d                   ;; |
    ld__ixl_e                   ;; IX = ball entity
    call entity_setPosX         ;; Set pos x ball
    ld a, b
    add #4                      ;;Increment 4 pos ball for align
    call entity_setPosY         ;; Set pos y ball

    ret

;;Add new entity
;; OUTPUT: A = pos X wizard     B = pos Y wizard
addBall:
    ld hl, (wiz_ball)
    call entity_new     ;; vector add new entity ball with prototype dates DE = ball entity
    ld a, entity_pixX (ix)  ;; Load pos X wizard
    ld b, entity_pixY (ix)  ;; Load pos y wizard
    ret

wiz_updateStateRecharge::
    ;; Añadir contador que cuando llegue a 0 vuelva al estado attac
    ;; Al acabar la espera cambia al estado adecuado (think, escape, align, throw)
    ld a, wiz_rechargeTime (ix)
    dec a
    ld wiz_rechargeTime (ix), a
    cp #0
    ret nz;
    ld a, (#wizard_prototype + wiz_rechargeTime)
    ld wiz_rechargeTime (ix), a
    jp setStThrow


;    call orc_getHeroDirection
;    cp #entity_noDir
;    jp z, wiz_attackNoHeroFound
;        ;;Comprobate distance
;        ld a, (heroDist)
;        cp #wiz_distanceEscape
;       jp m, setStEscape     ;;If distance < distanceEscape, activate state escape
;            ld a, (heroDifX)
;            cp #0
;            jp z, setStThrow    ;;If is align in x axis 
;            ld a, (heroDifY)
;            cp #0
;            jp z, setStThrow    ;;If is align in y axis
;            jp setStAlign       ;;If not align in x or y axis state align
;            ret 

    ret

wiz_updateStateAttackMelee:
    call orc_checkHero
    call orc_getHeroDirection
    ld a, (heroDist)
    cp #wiz_distanceEscape
    jp p, orc_setStateAttack
    call orc_updateStateAttack
    ret
setStRecharge:
    call entity_stand
    ld entity_state (ix), #wiz_stRecharge
    ret;

setStThrow:
    ld entity_state (ix), #wiz_stThrow
    ret;

setStAlign:
    ld entity_state (ix), #wiz_stAlign
    ret;

setStEscape:
    ld entity_state (ix), #wiz_stEscape
    ret

setStAttackMelee:
    call orc_setStateAttack
    ld entity_state (ix), #wiz_stAttackMelee
    ret
