;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################

.area _CODE

.include "cpctSymbols.h.s"
.include "dbuffer.h.s"
.include "sfx/sfx.h.s"
.include "panel.h.s"
.include "gameOver.h.s"

text1Win: .asciz       "CONGRATULATIONS!!"
text1: .asciz      "you fought as a "
text2: .asciz    "the bards will sing your feats"
text3: .asciz              "GAME OVER"
text4: .asciz         "press R to restart!"
text9: .asciz     "or C to back to checkpoint!" 
text5: .asciz              "DIRTY RAT"
text6: .asciz              "NOOB FARMER"
text7: .asciz              "BRAVE HERO"
text8: .asciz              "GOD OF FURY"

text1WinPos: .db 22, 72
text1Pos: .db 16, 80
text2Pos: .db 10, 88 
text3Pos: .db 30, 104
text4Pos: .db 20, 120
text9Pos: .db 12, 128
textRangoPos: .db 48, 80

gameOver_stShow:: .db gameOver_stNoShow


gameOver_update::
    ld a, (gameOver_stShow)
    cp #gameOver_stNoShow
    ret z

    cp #gameOver_stShowDead
    jp z, gameOver_showDead

    cp #gameOver_stShowWin
    jp z, gameOver_showWin

    ret


gameOver_showDead::
gameOver_show:    
;    ld bc, (text1Pos)
;    ld hl, #text1
;    call showText;

;    ld bc, (text2Pos)
;    ld hl, #text2
;    call showText

    ld bc, (text3Pos)
    ld hl, #text3
    call showText


    ld bc, (text1Pos) 
    ld hl, #text1
    call showText;

    call rango_money
    ld bc, (textRangoPos)
    call showText

;    ld bc, (text4Pos)
;    ld hl, #text1
;    call showText

    ld bc, (text4Pos)
    ld hl, #text4
    call showText

    ld bc, (text9Pos)
    ld hl, #text9
    call showText

    ret


comprobate_money:
    ld ix, (panel_moneyQuantMarker)
    ld c, #0
    inc_pos:
        ld a, (ix)
        cp #48
        jp nz, fin_pos
        ld a, c
        cp #6
        jp z, fin_pos
        inc ix
        inc c
        jp inc_pos
    fin_pos:
        ret

rango1:
    ld hl, #text5
    ret 

rango2:
    ld hl, #text6
    ret
rango3:
    ld hl, #text7
    ret
rango4:
    ld hl, #text8
    ret

rango_money:
    push ix
    call comprobate_money
    pop ix
    ld a, c
    cp #2
    jp z, rango2
    jp p, rango1
    cp #1
    jp z, rango3
    jp rango4
    ret

gameOver_showWin:
 
    call gameOver_show
    ld bc, (text1WinPos)
    ld hl, #text1Win
    call showText;

   ; ld bc, (text1Pos) 
;    ld hl, #text1
;    call showText;;

;    call rango_money
;    ld bc, (textRangoPos)
;    call showText;

    ld bc, (text2Pos)
    ld hl, #text2
    call showText;

;    ld bc, (text3Pos)
;    ld hl, #text3
;    call showText;

;    ld bc, (text4Pos)
;    ld hl, #text4
;    call showText

    ret    


showText:
    push hl
    ld de, (#_g_backBuffer)
    call cpct_getScreenPtr_asm
    ex de, hl
    pop bc
    call cpctex_drawTileStringM0
    ret

