;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################

.include "gameState.h.s"

.include "world.h.s"
.include "scene.h.s"
.include "panel.h.s"
.include "entity.h.s"
.include "entityWarrior.h.s"
.include "map.h.s"

.include "gameOver.h.s"


.globl hero

;; =============================
;; Use state variables
;; =============================
game_keybSelected:: .db 0x01

;; =============================
;; Warrior state variables
;; =============================
keyQuant:: .db 0x00
hero_life::
lifeQuant:: .db 0x00

gameState_restart::
    call map_deleteCheckPoint
    
gameState_restartCheckpoint::
    ld a, #gameOver_stNoShow
    ld (gameOver_stShow),a

    call world_restart

    ;call world_getCurrentMap
    ;ld (_g_currentMap), hl
    call map_setCurrentMap

    call panel_resetMoney
    call panel_resetKeys
    ;call panel_init
    call panel_drawMoney   
    call panel_drawLife_init
    call panel_resetLife


    call scene_init
    call scene_setScene
    
    ld ix, #hero
    call entity_eraseEnd
    ld a, #80
    call entity_setPosX
    ld a, #68
    call entity_setPosY
    
    ;call entity_eraseEnd
    ;call entity_drawFront
    ;call entity_drawBack

;    call hero_restoreToNormalFrames
;    call hero_setStand
;    call hero_setStateNormal
;    call entity_drawFront
;    call entity_drawBack

    call hero_restoreToNormalFrames
    call hero_setStand
    call hero_setStateNormal


    ret