;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################

.area _CODE

.include "cpctSymbols.h.s"
;.include "split.h.s"
.include "fps.h.s"
;; ========================================================
;; ========================================================
;; PRIVATE DATA
;; ========================================================
;; ========================================================
intId: .db 7
disable: .db 0

interrupt_init::
    ;call cpct_waitVSYNC_asm 
    ;ld hl, #interrupt_defaultISR
    ld hl, #interrupt_handler           ;; |
    call cpct_setInterruptHandler_asm   ;; Set ISR (function to handle interrupts)
    ret

interrupt_disable::
    call cpct_removeInterruptHandler_asm
    ret

interrupt_setISR1::
    ld (interrupt_ISR1+1),hl
    ret
interrupt_setISR2::
    ld (interrupt_ISR2+1),hl
    ret
interrupt_setISR3::
    ld (interrupt_ISR3+1),hl
    ret
interrupt_setISR4::
    ld (interrupt_ISR4+1),hl
    ret
interrupt_setISR5::
    ld (interrupt_ISR5+1),hl
    ret
interrupt_setISR6::
    ld (interrupt_ISR6+1),hl
    ret

;; =======================================================
;; Waits until an interrupt is triggered
;; 
;; Input:
;; B = interruptId = [0..5] = Id of the interrupt to wait
;; =======================================================
interrupt_waitId::
    ld a, (intId)
    nop
    cp b
    jr nz, interrupt_waitId
    ret

;; ========================================================
;; ========================================================
;; PRIVATE FUNCTIONS
;; ========================================================
;; ========================================================

interrupt_defaultISR::
    ret

;; ========================================
;; Updates interrupt Id and calls handlers
;; 
;; ========================================
interrupt_handler::
    ex af, af'
    exx
    push af
    push bc
    push de
    push hl
    push iy

    ld a, (disable)
    cp #1
    jp z, #finish

    ld a, (intId)
    dec a
    jr nz,noReset
        ld a, #6
    noReset:
    ld (intId), a

    cp #1
    jp nz, #test2
        ;setBorder #0x4c
        ;call #split_setEnd
        ;jp finish
        ld a, #1
        ld (disable), a
        interrupt_ISR6:
        call #interrupt_defaultISR
        ld a, #0
        ld (disable), a
        jp finish

    test2:
    cp #2
    jp nz, #test3
        ;setBorder #0x5d
        ;jp finish
        ld a, #1
        ld (disable), a
        interrupt_ISR5:
        call #interrupt_defaultISR
        ld a, #0
        ld (disable), a
        jp finish

    test3:
    cp #3
    jp nz, #test4
        ;setBorder #0x58
        ;jp finish
        ld a, #1
        ld (disable), a
        interrupt_ISR4:
        call #interrupt_defaultISR
        ld a, #0
        ld (disable), a
        jp finish

    test4:
    cp #4
    jp nz, #test5
        ;setBorder #0x5c
        ;jp finish
        ld a, #1
        ld (disable), a
        interrupt_ISR3:
        call #interrupt_defaultISR
        ld a, #0
        ld (disable), a
        jp finish

    test5:
    cp #5
    jp nz, #test6
        ;setBorder #0x55
        ;jp finish
        ld a, #1
        ld (disable), a
        interrupt_ISR2:
        call #interrupt_defaultISR
        ld a, #0
        ld (disable), a
        jp finish

    test6:
    cp #6
    jp nz, #finish
        ;call cpct_waitVSYNC_asm
        ;setBorder #0x44
        ;jp finish
        ld a, #1
        ld (disable), a
        interrupt_ISR1:
        call #interrupt_defaultISR
        ld a, #0
        ld (disable), a

        call fps_increaseCyclesCount

    finish:
        pop iy
        pop hl
        pop de
        pop bc
        pop af
        exx
        ex af, af'
    ret




