;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################

.area _CODE

;; ========================================================
;; ========================================================
;; INCLUDED GLOBAL SYMBOLS
;; ========================================================
;; ========================================================
.include "cpctSymbols.h.s"





;; ========================================================
;; DE Mod BC
;; DESTROYED REGISTERS:  AF, DE, BC, HL
;; INPUT: DE-> Dividendo    BC-> Divisor
;; OUTPUT: HL = Resto
;; ========================================================
DE_Mod_BC::          
     ld a, #16        ;1281-2x, x is at most 16
     ld hl, #0        ;7
     jp segundo         ;10
    DivLoop:
       dec a
       jp z, fin
       segundo:
       rl e        ;86
       rl d         ;128
       tercer:
       adc hl,hl    ;128
       sbc hl,bc    ;240
       jr nc,cuarto ;240
       add hl,bc
       jp DivLoop ;--
       cuarto:
       dec a        ;--
       jp z, fin        ;64
       jp tercer
       fin:
       rl e
       rl d       
ret

;; ========================================================
;; HL div C
;; DESTROYED REGISTERS: BC 
;; INPUT: HL-> Dividendo    C-> Divisor
;; OUTPUT: A = Resto HL = Cociente
;; ========================================================
wdivc::
    ld b, #16
    xor a
    div:
        add hl, hl
        rla
        cp c 
        jr c, continue
            inc l
            sub c
        continue: 
        djnz div
        ret


absA::
     or a
     ret p
     neg         ;or you can use      cpl \ inc a
     ret