;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################

.include "../menu/assetsObj/avatars.h.s"
.include "../menu/assetsObj/menu-title.h.s"
.include "../menu/assetsObj/panel.h.s"
.include "../menu/assetsObj/todStudios.h.s"
.include "../menu/assetsObj/cpctelera.h.s"
.include "../menu/assetsObj/flame.h.s"

.include "../menu/assetsObj/keySpace.h.s"
.include "../menu/assetsObj/keyArrow.h.s"
.include "../menu/assetsObj/arrowH.h.s"
.include "../menu/assetsObj/arrowV.h.s"
.include "../menu/assetsObj/joyButton.h.s"
.include "../menu/assetsObj/joyBall.h.s"
.include "../menu/assetsObj/joyStick.h.s"

;; INTRO SONG

_intro_song = 0x8000
intro_song_size    = 938
intro_song_end     = 0x83a9

;; ASSETS ORIGIN
.equ menuSymbolsOrg, _intro_song + intro_song_size
;.equ menuSymbolsOrg, 0x8000

;; AVATARS
.equ _g_avatars, menuSymbolsOrg
.equ _g_avatar_0, _g_avatars + G_AVATAR_0_OFF
.equ _g_avatar_1, _g_avatars + G_AVATAR_1_OFF
.equ _g_avatar_2, _g_avatars + G_AVATAR_2_OFF
.equ _g_avatars_size, G_AVATAR_0_SIZE * 3

;; MENUTITLE
.equ _g_menutitle_0, _g_avatars + _g_avatars_size

;; PANEL
.equ _g_panel, _g_menutitle_0 + G_MENUTITLE_0_SIZE
.equ _g_panel_0, _g_panel + G_PANEL_0_OFF
.equ _g_panel_1, _g_panel + G_PANEL_1_OFF
.equ _g_panel_size, G_PANEL_0_SIZE * 2

;; LOGO TOD STUDIOS
.equ _g_tod_0, _g_panel + _g_panel_size

;; LOGO CPCTELERA
.equ _g_cpct_0, _g_tod_0 + G_TOD_0_SIZE

;; FLAME
;.globl _g_flame
.equ _g_flame_0, _g_cpct_0 + G_CPCT_0_SIZE + G_FLAME_0_OFF
.equ _g_flame_1, _g_flame_0 + G_FLAME_1_OFF
.equ _g_flame_2, _g_flame_0 + G_FLAME_2_OFF
.equ _g_flame_3, _g_flame_0 + G_FLAME_3_OFF
.equ _g_flame_size, G_FLAME_0_SIZE * 4

;; KEY SPACE
.equ _g_keySp_0, _g_flame_0 + _g_flame_size

;; KEY ARROW
.equ _g_keyArr, _g_keySp_0 + G_KEYSP_0_SIZE
.equ _g_keyArr_0, _g_keyArr + G_KEYARR_0_OFF
.equ _g_keyArr_1, _g_keyArr + G_KEYARR_1_OFF
.equ _g_keyArr_2, _g_keyArr + G_KEYARR_2_OFF
.equ _g_keyArr_3, _g_keyArr + G_KEYARR_3_OFF
.equ _g_keyArr_size, G_KEYARR_0_SIZE * 4

;; ARROW H
.equ _g_arrowH_0, _g_keyArr + _g_keyArr_size

;; ARROW V
.equ _g_arrowV, _g_arrowH_0 + G_ARROWH_0_SIZE
.equ _g_arrowV_0, _g_arrowV + G_ARROWV_0_OFF
.equ _g_arrowV_1, _g_arrowV + G_ARROWV_1_OFF
.equ _g_arrowV_size, G_ARROWV_0_SIZE * 2

;; JOY BUTTON
.equ _g_joyBut, _g_arrowV + _g_arrowV_size
.equ _g_joyBut_0, _g_joyBut + G_JOYBUT_0_OFF
.equ _g_joyBut_1, _g_joyBut + G_JOYBUT_1_OFF
.equ _g_joyBut_size, G_JOYBUT_0_SIZE * 2

;; JOY BALL
.equ _g_joyBall_0, _g_joyBut + _g_joyBut_size

;; JOY STICK
.equ _g_joyStick, _g_joyBall_0 + G_JOYBALL_0_SIZE
.equ _g_joyStick_0, _g_joyStick + G_JOYSTICK_0_OFF
.equ _g_joyStick_1, _g_joyStick + G_JOYSTICK_1_OFF
.equ _g_joyStick_size, G_JOYSTICK_0_SIZE * 2



.equ _g_menu_code_begin, _g_joyStick_0  + _g_joyStick_size + 1


;.globl menu_code_begin
;.globl menu_code_end

;.equ menu_code_size1, menu_code_end - menu_code_begin + 1