;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of legend of steel.
;;
;;    Legend of steel is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Legend of steel is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Legend of steel.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2018 edition.
;;
;;     Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;     Castillo Zaragoza, Juan Miguel       jmczaragoza13@gmail.com
;;     Pérez Pérez, Luis Fernando           luisfernandodos2@hotmail.com
;;     Ponsoda Montiel, Daniel              dponsoda@gmail.com
;;
;;############################ END GPL LICENSE BLOCK #############################
.globl orc_prototype
.globl skeleton_prototype
.globl knight_prototype
.globl heart_prototype
.globl chest_prototype
.globl chicken_prototype
.globl coins_prototype
.globl potion_prototype
.globl key_prototype
.globl treasure_prototype
.globl wizard_prototype
.globl slimer_prototype
.globl horizontalDoor_prototype
.globl verticalDoor_prototype
;;;TILESET1
.globl _g_map0
.globl _g_map1
.globl _g_map2
.globl _g_map3
.globl _g_map4

;;TILESET2
;.globl _g_map5
.globl _g_map6
.globl _g_map7
.globl _g_map8
.globl _g_map9

;;TILESET3
.globl _g_map10
.globl _g_map11
.globl _g_map12
.globl _g_map13

.globl _g_tiles1
.globl _g_tiles2
.globl _g_tiles3

.include "worldDefinition.h.s"

;;==============================================================
;; Here we define the world
;; Each location is defined by a pointer to the current tilemap
;; and 4 pointers, one for each possible direction.
;;
;; The macro works as follows:
;; location_define (id, map, north, east, south, west)
;;==============================================================
;; TUTORIAL

location_define loc1, 0,       0, _g_map0,    loc2,  0,     0,      0, loc1_ents
location_define loc2, 0,       0, _g_map0,    loc7,  0,     loc1,   0, loc2_ents;

;; TILESET1
location_define loc7,  0, _g_map0, _g_map1,    0,        loc8,       loc2,    loc9,   loc7_ents
location_define loc8,  0, _g_map0, _g_map2,    0,           0,          0,    loc7,   loc8_ents
location_define loc9,  0, _g_map0, _g_map3,    loc11,    loc7,      loc10,       0,   loc9_ents
location_define loc10, 0,       0, _g_map0,    loc9,        0,          0,       0,   loc10_ents
location_define loc11, 0, _g_map0, _g_map3,    0,       loc12,       loc9,       0,   loc11_ents
location_define loc12, 0, _g_map0, _g_map4,    loc13,       0,          0,   loc11,   loc12_ents

;; TILESET2
location_define loc13, 1,       0, _g_map6,    loc17,   loc14,      loc12,          0,      loc2_1_ents
location_define loc14, 1, _g_map6, _g_map7,    loc15,       0,          0,      loc13,      loc2_2_ents
location_define loc15, 1, _g_map6, _g_map8,    loc13,       0,      loc14,      loc17,      loc2_3_ents
location_define loc16, 1, _g_map6, _g_map9,    loc18,       0,      loc17,          0,      loc2_4_ents
location_define loc17, 1, _g_map6, _g_map9,    loc16,    loc15,     loc13,          0,      loc2_5_ents

;; TILESET3
location_define loc18, 2,        0,_g_map10,    loc19,   loc21,  loc16,      0,  loc3_1_ents
location_define loc19, 2, _g_map10,_g_map11,    0,       0,      loc18,  loc20,  loc3_2_ents
location_define loc20, 2, _g_map10,_g_map13,    loc27,   loc19,  0,      0,      loc3_3_ents
location_define loc21, 2, _g_map10,_g_map13,    loc24,   loc22,  0,      loc18,  loc3_4_ents
location_define loc22, 2, _g_map10,_g_map11,    loc23,   0,      0,      loc21,  loc3_5_ents
location_define loc23, 2, _g_map10,_g_map12,    loc25,   0,      loc22,  loc24,  loc3_6_ents
location_define loc24, 2,        0,_g_map10,    loc26,   loc23,  loc21,  0,      loc3_7_ents
location_define loc25, 2, _g_map10,_g_map11,    0,       0,      loc23,  loc26,  loc3_8_ents
location_define loc26, 2,        0,_g_map10,    0,       loc25,  loc24,  loc27,  loc3_9_ents
location_define loc27, 2, _g_map10,_g_map12,    0,       loc26,  loc20,  0,      loc3_10_ents

;;===================================
;; IMPORTANTE:
;; Colocar la puerta en esta posición para correcto funcionamiento:
;; VERTICALDOOR:
;; - Al norte, el eje Y debe ser 0
;; - AL sur, el eje Y debe ser 84
;; HORIZONTALDOOR:
;; - Al este, el eje X debe ser 152
;; - Al oeste, el eje X debe ser 0
;;===========================================================
loc_definitionsBegin:
loc1_ents::
    entDef key_prototype, 16, 32
    entDef verticalDoor_prototype, 72, 0
    entDef orc_prototype, 16,48
    ;entDef wizard_prototype, 48, 56
    entDef orc_prototype, 120, 24 
    
    entDefEnd

loc2_ents::
    entDef key_prototype, 16, 48
    entDef verticalDoor_prototype, 72, 0
    entDef chest_prototype, 72, 48
    entDef skeleton_prototype, 40, 24
    entDef skeleton_prototype, 120, 24
    entDef chicken_prototype, 128, 48
    entDefEnd;

loc7_ents::
    entDef horizontalDoor_prototype, 0, 40
    entDef chest_prototype, 136, 24 
    entDef orc_prototype, 40, 40
    entDef orc_prototype, 128, 32
    entDefEnd    ;

loc8_ents::
    entDef chicken_prototype, 64, 16
    entDef chest_prototype, 136, 16
    entDef key_prototype, 16, 72  
    entDef orc_prototype, 104, 44
    entDef orc_prototype, 136, 24
    entDef skeleton_prototype, 24, 60
    entDef skeleton_prototype, 24, 60
    
    entDefEnd    ;
loc9_ents::
    entDef heart_prototype, 8, 76
    entDef key_prototype, 8, 44  
    entDef skeleton_prototype, 104, 16
    entDef skeleton_prototype, 16, 36
    entDef skeleton_prototype, 16, 56
    ;entDef skeleton_prototype, 120, 60
    entDef verticalDoor_prototype, 72, 84
    entDef verticalDoor_prototype, 72, 0;
    entDefEnd;

loc10_ents::
    entDef chest_prototype, 128, 72
    entDef key_prototype, 24, 72  
    entDef orc_prototype, 24, 72
    entDef orc_prototype, 128, 56
    entDef slimer_prototype, 80, 64
;    
    entDefEnd;

loc11_ents::
   entDef horizontalDoor_prototype, 152, 40
   entDef heart_prototype, 8, 76
   entDef chest_prototype, 136, 20
   entDef key_prototype, 16, 20  
   entDef slimer_prototype, 24, 56
   entDef slimer_prototype, 56, 56
   entDef skeleton_prototype, 88, 36
   
    entDefEnd;

loc12_ents::
   entDef chest_prototype, 16, 60
   entDef chest_prototype, 80, 48
   entDef potion_prototype, 40, 32
   entDef heart_prototype, 16, 72
   entDef chest_prototype, 16, 28
   entDef slimer_prototype, 16, 60
   entDef orc_prototype, 80, 68
   entDef slimer_prototype, 128, 60
   entDef skeleton_prototype, 16, 24
   entDef skeleton_prototype, 80, 52    
    entDefEnd;

loc2_1_ents::
    entDef orc_prototype, 24, 44
    entDef orc_prototype, 136, 44
    entDef skeleton_prototype, 40, 24
    entDef skeleton_prototype, 120, 20
    entDef chest_prototype, 24, 20
    entDef key_prototype, 128, 20;
    entDefEnd;;

loc2_2_ents:;
    entDef chicken_prototype, 80, 40
    entDef chest_prototype, 48, 40
    entDef key_prototype, 112, 40
    entDef skeleton_prototype, 80, 24
    entDef wizard_prototype, 48, 56
    entDef slimer_prototype, 112, 48
    entDefEnd;

loc2_3_ents:
    entDef key_prototype, 80, 56
    entDef skeleton_prototype, 32, 44
    entDef skeleton_prototype, 112, 44
    entDef skeleton_prototype, 112, 48
    entDef wizard_prototype, 112, 52
    entDef verticalDoor_prototype, 72, 0
    entDef horizontalDoor_prototype, 0, 40
    entDefEnd;

loc2_4_ents:;
    entDef verticalDoor_prototype, 72, 0
    entDef key_prototype, 80, 52
    entDef heart_prototype, 80, 20
    entDef wizard_prototype, 120, 20
    entDef skeleton_prototype, 40, 36
    entDef skeleton_prototype, 120, 36
    entDef orc_prototype, 40, 60
    entDef slimer_prototype, 120, 60
    entDefEnd;

loc2_5_ents:;
    entDef verticalDoor_prototype, 72, 0
    entDef potion_prototype, 80, 52
    entDef heart_prototype, 32, 40
    entDef chest_prototype, 32, 64
    entDef chicken_prototype, 128, 40
    entDef chest_prototype, 128, 64
    entDef slimer_prototype, 80, 36
    entDef slimer_prototype, 80, 60
    entDef slimer_prototype, 40, 48
    entDef slimer_prototype, 112, 48
    entDefEnd

loc3_1_ents:
    entDef horizontalDoor_prototype, 152, 40
    entDef heart_prototype, 56, 68
    entDef chicken_prototype, 40, 16
    entDef chicken_prototype, 64, 36
    entDef knight_prototype, 40, 36
    entDef skeleton_prototype, 16, 24
    entDef knight_prototype, 136, 48
    entDef skeleton_prototype, 120, 72
    entDef knight_prototype, 88, 24
    entDefEnd

loc3_2_ents:
    entDef key_prototype, 56, 24
    entDef orc_prototype, 120, 24
    entDef orc_prototype, 136, 72
    entDef skeleton_prototype, 128, 48
    entDef skeleton_prototype, 24, 64
    entDef heart_prototype, 72, 16
    entDef chest_prototype, 80, 16
    entDef orc_prototype, 28, 16
    entDefEnd

loc3_3_ents:
    entDef key_prototype, 24, 44
    entDef treasure_prototype, 64, 44
    entDef chest_prototype, 136, 16
    entDef orc_prototype, 136, 36
    entDef orc_prototype, 96, 72
    entDef orc_prototype, 16, 60
    entDef potion_prototype, 8, 44
    entDef skeleton_prototype, 112, 72
    entDef skeleton_prototype, 24, 20
    entDef skeleton_prototype, 96, 20
    entDef slimer_prototype, 48, 52
    entDef slimer_prototype, 96, 52
    entDefEnd
    
loc3_4_ents:
    entDef key_prototype, 64, 44 
    entDef horizontalDoor_prototype, 152, 40
    entDef chest_prototype, 16, 16
    entDef heart_prototype, 112, 24
    entDef knight_prototype, 96, 20
    entDef skeleton_prototype, 16, 24
    entDef knight_prototype, 88, 56
    entDef skeleton_prototype, 24, 72
    entDef slimer_prototype, 126, 72
    entDef heart_prototype, 136, 16
    entDefEnd

loc3_5_ents:
   entDef wizard_prototype, 32, 20
   entDef chicken_prototype, 56, 24
   entDef chicken_prototype, 32, 40
   entDef knight_prototype, 136, 24
   entDef skeleton_prototype, 72, 16
   entDef heart_prototype, 80, 52
   entDef chest_prototype, 72, 52
   entDef chest_prototype, 16, 64
   entDefEnd

loc3_6_ents:
    entDef chest_prototype, 144, 36
    entDef chest_prototype, 144, 72
    entDef slimer_prototype, 48, 48
    entDef slimer_prototype, 104, 48
    entDef wizard_prototype, 16, 40
    entDef wizard_prototype, 136, 72
    entDef chest_prototype, 16, 20
    entDef chest_prototype, 120, 20
    entDef chest_prototype, 32, 20
    entDef chest_prototype, 136, 20
    entDef heart_prototype, 112, 20
    entDef heart_prototype, 24, 20
    entDef heart_prototype, 128, 20
    entDef heart_prototype, 40, 20
    entDef heart_prototype, 72, 36
    entDefEnd

loc3_7_ents:
    entDef verticalDoor_prototype, 72, 0
    entDef key_prototype, 72, 36
    entDef key_prototype, 40, 16
    entDef knight_prototype, 144, 36
    entDef knight_prototype, 16, 24
    entDef chicken_prototype, 40, 56
    entDef chicken_prototype, 104, 36
   entDefEnd
    
loc3_8_ents:
    entDef verticalDoor_prototype, 72, 84
    entDef wizard_prototype, 136, 24
    entDef skeleton_prototype, 80, 56
    entDef skeleton_prototype, 136, 56
    entDef slimer_prototype, 120, 72
    entDef slimer_prototype, 24, 48
    entDef chicken_prototype, 56, 76
    entDef heart_prototype, 56, 20
    entDefEnd

loc3_9_ents:
    entDef key_prototype, 104, 36
    entDef horizontalDoor_prototype, 152, 40
    entDef chest_prototype, 96, 36
    entDef heart_prototype, 88, 36
    entDef heart_prototype, 64, 36
    entDef wizard_prototype, 144, 72
    entDef skeleton_prototype, 32, 24
    entDef skeleton_prototype, 128, 44
    entDef slimer_prototype, 16, 64
    entDefEnd
    
loc3_10_ents:
    entDef verticalDoor_prototype, 72, 84
    entDef chicken_prototype, 40, 36
    entDef chicken_prototype, 112, 36
    entDef wizard_prototype, 8, 36
    entDef wizard_prototype, 144, 36
    entDef wizard_prototype, 144, 72
    entDef wizard_prototype, 8, 72
    entDef skeleton_prototype, 72, 36
    entDefEnd



loc_definitionsEnd:



.equ loc_definitionsSize, loc_definitionsEnd - loc_definitionsBegin

;.macro world_space _n
;    _c = 0
;    .rept _n
;        .db 0x00
;        _c = _c + 1
;    .endm
;.endm;

;;; Reserve space for the world definition
;world_space loc_definitionsSize

worldDefinition_init::
    ld hl, #loc_definitionsBegin    
    ld c, #0
    loop:
        ld a, (hl)
        cp #-1
        jp z, skip
            ld (hl), #1
        skip:
        ld de, #entDefSize
        add hl, de
        inc c
        ld a, #loc_definitionsSize / entDefSize
        cp c
        jp nz, loop


;    ld hl, #loc_definitionsBegin
;    
;    ld de, #loc_definitionsEnd
;    ld bc, #loc_definitionsSize
;    ldir
    ret